<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdklogincheck.jsp" %>

<%@ page import="com.esko.webcenter.jsp.ApprovalMgr" %>
<%@ page import="com.esko.webcenter.src.root.*" %>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%@ page import="com.esko.webcenter.src.root.view.*" %>
<%@ page import="com.esko.webcenter.src.xml.*" %>
<%@ page import="java.util.logging.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.sql.Timestamp" %>
<%@ page import="com.esko.webcenter.src.util.InvalidParameterException" %>
<%@ page import="com.esko.util.StringUtils" %>

<%@ page import="com.esko.webcenter.cache.CategoryObjectCache" %>
<% 

	// This servlet return the history of a document
	// document is identified by the 
	// project (either by ID or by name)
	// document only by name 
	
	// get parameters
	Properties requestParams = SDKUtils.getRequestParams(request, session, application, requestParamsLoginCheck);

	String message = null;
	StringBuffer result = new StringBuffer();

	Vector<UserView> userList = new Vector<UserView>();
	Vector<Group> groupList = new Vector<Group>();
	
	String loginID = LoginMgr.getLoginMgr(session).getLoginID() ; 
	String userID = LoginMgr.getLoginMgr(session).getLoginUserID() ;

	// declarations 
	String projectID = null;  
	DocVersion docversion = null ;
	
	// create the EJBs
	DocumentMgrTM 	documentMgrTM 	= DBTMUtils.findBean(response, session, DocumentMgrTM.class);
	ProjectTM 		projectTM 		= DBTMUtils.findBean(response, session, ProjectTM.class);
	UserTM		 	userTM 			= DBTMUtils.findBean(response, session, UserTM.class);
	Approval 		approvalEJB 	= DBTMUtils.findBean(response, session, Approval.class);
	GroupTM 		groupTM 		= DBTMUtils.findBean(response, session, GroupTM.class);
	ComplexApprovalTM complexApprovalTM = DBTMUtils.findBean(response, session, ComplexApprovalTM.class);
	

	if ((documentMgrTM  == null) ||  (projectTM == null) || (userTM == null) || (approvalEJB == null)
			 || (groupTM == null) || (complexApprovalTM == null))
	{
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);
		return;
	}
		
	//  get call parameters
	
	// get the debug flag 
	String debugString = (requestParams.containsKey("debug")) ? ((String[])requestParams.get("debug"))[0] : null;
	boolean debug = (debugString != null) && debugString.equals("1");
	
 	// get the approval info flag
	String approvalInfoString = (requestParams.containsKey("approvalinfo")) ? 
			((String[])requestParams.get("approvalinfo"))[0] : null;
	boolean approvalInfo = (approvalInfoString != null) && approvalInfoString.equals("1");
	 		
 	// get the annotation info flag
	String annotationInfoString = (requestParams.containsKey("annotationinfo")) ? 
			((String[])requestParams.get("annotationinfo"))[0] : null;
	boolean annotationInfo = (annotationInfoString != null) && annotationInfoString.equals("1");
	 		
	// get the full user info flag (if set to false, we only pass the user ID, otherwise, we give more info)
	String fullUserInfoString = (requestParams.containsKey("fulluserinfo")) ? 
			((String[])requestParams.get("fulluserinfo"))[0] : null;
	boolean fullUserInfo = (fullUserInfoString == null) || !fullUserInfoString.equals("0");

	// get the project info flag
	String projectInfoString = (requestParams.containsKey("projectinfo")) ? 
			((String[])requestParams.get("projectinfo"))[0] : null;
	boolean projectInfo = (projectInfoString != null) && (projectInfoString.equals("1") || projectInfoString.equalsIgnoreCase("true"));

	String includeTemplatesString = (requestParams.containsKey("includetemplates")) ? 
			((String[])requestParams.get("includetemplates"))[0] : null;
	boolean includeTemplates = (includeTemplatesString != null) && 
			(includeTemplatesString.equals("1") || includeTemplatesString.equalsIgnoreCase("true"));
	
	// get the thumbnail url flag (default false)
	String thumbnailUrlString = (requestParams.containsKey("thumbnailurl")) ?
			((String[])requestParams.get("thumbnailurl"))[0] : null;
	boolean thumbnailUrl = (thumbnailUrlString != null) && (thumbnailUrlString.equals("1"));
			
	// get the acatinfo flag
	String acatInfoString = (requestParams.containsKey("acatinfo")) ? ((String[])requestParams.get("acatinfo"))[0] : "0";
	boolean includeAcatInfo = acatInfoString.equals("1");
	
	// get the folder info flag
	String folderInfoString = (requestParams.containsKey("folderinfo")) ? ((String[])requestParams.get("folderinfo"))[0] : "0";
	boolean includeFolderInfo = folderInfoString.equals("1");
			
	// resolve the project ID first
	Vector<Project> projects = new Vector<Project>();
	boolean isTemplatesAlreadyLoaded = false;
	String docIDStr = (requestParams.containsKey("docid")) ? ((String[])requestParams.get("docid"))[0] : null;
	String docVerIDStr = (requestParams.containsKey("docversionid")) ? ((String[])requestParams.get("docversionid"))[0] : null;
	
	String askedDocVerID = null;
	String oneVersionOnly = (requestParams.containsKey("limitdocversions")) ? ((String[])requestParams.get("limitdocversions"))[0] : "0";
	if (oneVersionOnly.trim().equals("1") && (docVerIDStr != null))
	{
		// get the"askedDocVerID" if just one document version should be output.
	  askedDocVerID = docVerIDStr.trim();
	}
	
	// check if we want a WebCenter compatible date format
	// 0: simple Timestamp.toString() - no timezone correction (always GMT) e.g. "2014-10-22 09:37:22.407" (default)
	// 1: WebCenter style date and time string - corrected for client language and timezone, e.g. "Oct 22, 2014 at 9:36 AM" 
	// 2: milliseconds since Jan 1, 1970, e.g. "1413963408890"
	String dateFormatStr = (requestParams.containsKey("dateformat")) ? ((String[])requestParams.get("dateformat"))[0].trim() : "0";
	int dateFormat = "1".equals(dateFormatStr) ? 1 : "2".equals(dateFormatStr) ? 2 : 0;

	projectID = (requestParams.containsKey("projectid")) ? ((String[])requestParams.get("projectid"))[0] : null;
	String projectName = (requestParams.containsKey("projectname")) ? ((String[])requestParams.get("projectname"))[0] : null;

	if ((projectID != null) || (projectName != null)) {
		StringBuffer errorMsg = new StringBuffer();
		Project _project = SDKUtils.getProjectByIDOrName(loginID, projectID, projectName, errorMsg, projectTM);
		if (_project == null)
	  	{
			out.write(errorMsg.toString());
			checkLogOff(session);
			return;
		}
		projectID = _project.getObjectID();
	}
	
	if ((docIDStr != null) || (docVerIDStr != null))
	{
		try
		{
			// find the document version containing all needed info.
			StringBuffer errorMsg = new StringBuffer();
			docversion = SDKUtils.getDocVersionByIDOrDocID(loginID, docVerIDStr, docIDStr, errorMsg, documentMgrTM);
			
			if (docversion == null)
			{
				out.write(errorMsg.toString());
				checkLogOff(session);
				return;
			} 
			
			// find all projects where the 'docversion' is stored in
			projects = documentMgrTM.getDocumentProjectList(loginID, docversion.getDocumentID());
			if (includeTemplates) {
				// add all the templates to the projects from above if "includetemplates" parameter is set to 1/true
				// (note it's done this way to not introduce any regressions as the first element from the Vector
				// is selected by default. Allowing template(s) to be the first in the Vector effectively 
				// alters the behavior of the SDK call which is NOT wanted!)
				projects.addAll(documentMgrTM.getDocumentTemplateList(loginID, docversion.getDocumentID()));
				isTemplatesAlreadyLoaded = true;
			}
			if (projectID != null) 
			{
				// project ID/name specified by the user - make sure the document exists in the specified project
				Project projectFound = Project.getProjectFromListByID(projects, projectID);
				if (projectFound == null) {
					LogUtils.LogSDK(request, session, "Document version with ID " + docversion.getObjectID() + " cannot be found in the specified project with ID " + projectID + "!");
					projectID = null;   // reset the wrong project ID to be able pick the right one
				}
			}
			// when no project ID specified yet, pick the first one from the projects list
			if ((projectID == null) && (projects != null) && (projects.size() > 0))
			{
				projectID = projects.get(0).getObjectID();
			}
		}
		catch(Exception e)
		{
			LogMgr.getLogger().log(Level.SEVERE, "Cannot load the document with this ID " + docIDStr );
			out.write(SDKUtils.ShowError(SDKUtils.SDK_DOC_NOT_ACCESSIBLE));
			checkLogOff(session);
			return;
		}		
	}

	String docID = new String();
	String docVerID = new String();
	String folderID = new String();
	
 try
 {
	// we know the project ID. if document version is still not known, check if the document was not 
	// specified by its name.
	if (docversion == null)
	{
		String documentName = (requestParams.containsKey("documentname")) ? ((String[])requestParams.get("documentname"))[0] : null;
		if ((documentName == null) || (documentName.length() == 0) )
		{
		  // document is a mandatory parameter for this SDK call
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING));
			checkLogOff(session);
			return;
		} 

		ProjectDoc projDoc = documentMgrTM.getProjectDocument(loginID, projectID, documentName);	
		if (projDoc == null)
		{
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_DOC));
			checkLogOff(session);
			return;
		}
		docID = projDoc.getDocumentID();
		docVerID = projDoc.getVersionID();
		folderID = projDoc.getFolderID();
		// load the document version (only the version, the document itself will be loaded later on)
		docversion = documentMgrTM.findDocVersionById(loginID, docVerID );
	} 
	else 
	{
		// we still need to load folder Info
		ProjectDoc projDoc = documentMgrTM.getProjectDocumentByDocId(loginID, projectID, docversion.getDocumentID());
		if (projDoc == null)
		{
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_DOC));
			checkLogOff(session);
			return;
		}
		
		docID = docversion.getDocumentID();
		docVerID = docversion.getObjectID();
		folderID = projDoc.getFolderID();
	}
	
	// load also the latest version of selected document for various usage
	Document docInfo = documentMgrTM.findById( loginID, docID );
	DocVersion latestDocVersion = docversion;
	if (docInfo.getLastVersionIndex() != docversion.getVersionCounter()){
		latestDocVersion = DBUtils.getHighestDocVersion(response, session, documentMgrTM, docID);	
	} 
	
	if (askedDocVerID == null)
	{
		// when limitdocversions is not set (askedDocVerID is null) always fall back at latest version 
		// of the given document no matter if "docversionid" parameter is set or not.
		docVerID = latestDocVersion.getObjectID();
	}
	
	// we know the doc id and the doc version id now.
	// this is the starting point for the real work

	result.append("<document_info>" + Xml.NEWLINEPARAM);

	if (debug) 
	{
		result.append("<debug>docID  : " + docID + "</debug>" + Xml.NEWLINEPARAM);
		result.append("<debug>docVerID : " + docVerID + "</debug>" + Xml.NEWLINEPARAM);
	}

	Vector<ComplexStageApprover> approvers = null ; 

	
	if (docInfo != null)
	{
		if (debug) result.append("<debug>documentName : " + XMLUtils.safeEncodeXml(docInfo.getName()) + "</debug>");
		
		String docInfoXML = getDocInfoXML(docInfo, docVerID, folderID, dateFormat, session);
		
		if (docInfoXML != null) 
			result.append(docInfoXML + Xml.NEWLINEPARAM);
		
		// check whether the document is under approval. If not, there will not be any approval user 
		boolean docUnderApproval = (latestDocVersion.getApprovalCycle() != DocVersionApprovalInfo.ApprovalCycleStates.NO_RULE) ;
	
		
		// also add the approvers 
		// all documents versions are processed, get some extra info
		if ( approvalInfo  && docUnderApproval) 
		{
			// get the list of all approval users that are supposed to approve the doc
			// started stages only
			
			approvers = complexApprovalTM.loadDocVersionApprovers(loginID, docVerID) ; 
			Hashtable processedGroups = new Hashtable();
			
			if ( (approvers != null) && (approvers.size() > 0) )
			{
				result.append("<approval_users>" + Xml.NEWLINEPARAM);
				for (int i = 0; i < approvers.size(); i++ )
				{
					ComplexStageApprover approver = (ComplexStageApprover)approvers.elementAt(i);
					
					if (approver.approverType() == ComplexStageApprover.USER) 
					{
						// when it is a user, write the user info in the XML stream 					
						String apprUserID = (String)approver.approverUserID();
						String approvalUserXML = getUserXML(loginID, userTM, userList, apprUserID, fullUserInfo);
						if (approvalUserXML.length() == 0)
						{
							out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER));
							checkLogOff(session);
							return;
						}
						result.append(approvalUserXML + Xml.NEWLINEPARAM);
					}
					else 
					{
						// group or role
						// for started approvals, groups/roles can be expanded (= we should never get ComplexStageApprover.WHOLE_GROUP type here)
						String apprGroupID = (String)approver.approverGroupID();						
						if  (!processedGroups.containsKey(apprGroupID))
						{
							String approvalGroupXML = getGroupXML(loginID, groupTM, groupList, apprGroupID, fullUserInfo, approver.approverType());
							if (approvalGroupXML.length() == 0)
							{
								out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_GROUP));
								checkLogOff(session);
								return;
							}
							result.append(approvalGroupXML+ Xml.NEWLINEPARAM);
							processedGroups.put(apprGroupID,apprGroupID );
						}							
					}
				}
				result.append("</approval_users>" + Xml.NEWLINEPARAM);						
			}		
		}
	}
	else
	{
		if (debug) result.append("<debug>document with given ID was not found.</debug>" + Xml.NEWLINEPARAM);
	}
		
	// well, for page list documents, we do not have the concept of versions (different versions do not neces, overlap)
	// pagelist document, only get the info of the latest version 
	String pageIndex = (requestParams.containsKey("pageindex")) ? ((String[])requestParams.get("pageindex"))[0] : null;
	PageListTM pagelistTM = DBTMUtils.findBean(response, session, PageListTM.class);
	
	if (latestDocVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList) && pageIndex!=null)
	{
		int pagein = Integer.parseInt(pageIndex); 
			
		// build the pagelist and get the document version id and the version page index of that particular page 
		Vector pages = pagelistTM.buildPageList(loginID, docID);
		if ( (pages != null) && (pages.size() > pagein) && (pagein >= 0)) 
		{
			 PageListPageDocVersionView pageListPageDocVersionView = (PageListPageDocVersionView)pages.elementAt(pagein);
			 if (pageListPageDocVersionView  != null ) 
			 {
				PageListPageProperties pageProps = (PageListPageProperties)pageListPageDocVersionView.getPageListPageProperties();
			 	int versionIndex = pageProps.getVersionPageIndex(); // 0-based index
			 	
				DocVersion pageDocVersion = documentMgrTM.findDocVersionById(loginID, pageProps.getDocVersionID());
				
				Vector listPageVersions =  pagelistTM.getPageVersions(loginID, docID, pagein);
				if (listPageVersions!=null )
				{
					for (int i = 0 ; i < listPageVersions.size() ; i++)
					{
						PageListDocVersionProperties pageVersion = (PageListDocVersionProperties)listPageVersions.elementAt(i) ;
						String pageInfoXML = getPageVersionInfoXML(loginID, userList, groupList, userTM, groupTM, pageDocVersion, latestDocVersion,i+1,pagein, versionIndex, pageVersion, 
								documentMgrTM, approvalEJB, complexApprovalTM, pagelistTM, projectID,  approvalInfo, annotationInfo, fullUserInfo, dateFormat, session);									 
						result.append(pageInfoXML  + Xml.NEWLINEPARAM);
					}
				} 				
			}
		}
	}
	else
	{
		if ( IdGenerator.isIDFormat( askedDocVerID) ) {
			Vector<String> resultVector = getDocVersionInfoXML(loginID, userList, groupList, userTM, groupTM, docversion, latestDocVersion, documentMgrTM, approvalEJB, complexApprovalTM, pagelistTM, projectID, debug, approvalInfo, annotationInfo, fullUserInfo, dateFormat, thumbnailUrl, includeAcatInfo, includeFolderInfo, folderID, session);
			if (resultVector != null ) 
			{
				if (resultVector.size() > 0) 
				{
					String docVersionXML = (String)resultVector.get(0);
					if (docVersionXML != null)
					{
						result.append(docVersionXML + Xml.NEWLINEPARAM);
					}
				}
			}			
		}
		else{
		// iterate over the versions 
		Vector docVersionList = documentMgrTM.loadVersionList(loginID, docID);
		if ( (docVersionList != null ) &&  (docVersionList.size() != 0) ) 
		{
			// start iterating - for every document, get the approval info
			for (int i = 0; i < docVersionList.size(); i++)
			{
				DocVersion docVersion = (DocVersion)docVersionList.elementAt(i);
				if (docVersion != null)
				{
					if ((askedDocVerID != null) && !askedDocVerID.equalsIgnoreCase(docVersion.getObjectID()))
					{
					  // when "askedDocVerID" is set, the output is limited to just the specified document version.
					  // all other doc. versions are skipped.
					  continue;
					}
				  				
					Vector<String> resultVector = getDocVersionInfoXML(loginID, userList, groupList, userTM, groupTM, docVersion, latestDocVersion, documentMgrTM, approvalEJB, complexApprovalTM, pagelistTM, projectID, debug, approvalInfo, annotationInfo, fullUserInfo, dateFormat, thumbnailUrl, includeAcatInfo, includeFolderInfo, folderID, session);
					if (resultVector != null ) 
					{
						if (resultVector.size() > 0) 
						{
							String docVersionXML = (String)resultVector.get(0);
							if (docVersionXML != null)
							{
								result.append(docVersionXML + Xml.NEWLINEPARAM);
							}
						}
					}
				} 
			}
		}
	}	
	}	
		
	// when approval info was required, dump the list of approval types 
	if (approvalInfo ) 
	{
		result.append(getApprovalTypesXML(response, session) + Xml.NEWLINEPARAM);			
	}

	/* If we need to concentrate the users, normalize the vector first and then just get the info for the users IDs in this vector  */
	if (!fullUserInfo )
	{
		if ((userList != null) && (userList.size() > 0)) 
		{
			// get the users list to XML
			result.append("<users>" + Xml.NEWLINEPARAM);
			for (int i = 0; i < userList.size(); i++)
			{
				UserView userView = (UserView)userList.get(i);
				result.append(SDKUtils.getUserXML(userView, true) + Xml.NEWLINEPARAM);
			}
			result.append("</users>" + Xml.NEWLINEPARAM);
		}			
		
		if ((groupList != null) && (groupList.size() > 0)) 
		{
			// get the groups list to XML
			result.append("<groups>" + Xml.NEWLINEPARAM);
			for (int i = 0; i < groupList.size(); i++)
			{
				Group group = (Group)groupList.get(i);
				result.append(SDKUtils.getGroupXML(group, true, 0) + Xml.NEWLINEPARAM);				
			}			
			result.append("</groups>" + Xml.NEWLINEPARAM);
		}			
	} 
	
	if (projectInfo == true)
	{
		// also include project list into the output
		
		if ((projects == null ) || (projects.size() == 0))
		{
			// load list of projects for a given documentID
			projects = documentMgrTM.getDocumentProjectList(loginID, docID);
		}
		if (includeTemplates && !isTemplatesAlreadyLoaded) {
			// load list of templates for a given documentID
			Vector<Project> templates = documentMgrTM.getDocumentTemplateList(loginID, docID);
			projects.addAll(templates);
		}
		// add into XML
		ProjectListXml projListXml = new ProjectListXml();
		result.append(projListXml.getInXml(projects));
	}
	
	result.append("</document_info>" + Xml.NEWLINEPARAM);	

	// finally write generated XML
	message = result.toString();

	out.write(message);
	
 }
 catch (InvalidParameterException paramEx)
 {
   out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, paramEx));
 }
 catch (Exception ex)
 {
   out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ex));
 }
	
	checkLogOff(session);
	
%>


<%!
public String getUserXML(String loginID, UserTM userTM, Vector<UserView> userList, String userID, boolean fullUserInfo)
{
	try
	{
		// first try if the user to be output to XML is already loaded and cached in userList Vector
		String userXML = SDKUtils.getUserXML(userList, userID, fullUserInfo);
		
		if (userXML.length() > 0)
		{
			// user found in the list of cached users - return the result XML
			return userXML;
		}
		
		// particular user (userID) is not loaded yet - load it
		UserView userView = null;
		try
		{
			userView = SDKUtils.getUserView(loginID, userTM, userID, null);
			// add found user (UserView instance) to the list of cached users
			if (userView != null) userList.add(userView);
		}
		catch (WebCenterRemoteException ex)
		{
			userView = null;
		}
		if (userView == null)
		{
			// ignore any exception for now
			return "";
//			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER));
//			checkLogOff(session);
//			return;
		}
		
		// user loaded from DB - output the result XML
		return SDKUtils.getUserXML(userView, fullUserInfo);
	}
	catch (Exception ex)
	{
		// ignore any exception for now
		return "";
	}
}
%>

<%!
public String getGroupXML(String loginID, GroupTM groupTM, Vector<Group> groupList, String groupID, 
		boolean fullUserInfo , int groupApproverType)
{
	try
	{
		// first try if the group to be output to XML is already loaded and cached in groupList Vector
		String groupXML = SDKUtils.getGroupXML(groupList, groupID, fullUserInfo, groupApproverType);
		
		if (groupXML.length() > 0)
		{
			// group found in the list of cached groups - return the result XML
			return groupXML;
		}
		
		// particular group (groupID) is not loaded yet - load it
		Group group = null;
		try
		{
			group = SDKUtils.getGroupObject(loginID, groupTM, groupID, null);
			// add found group (Group instance) to the list of cached groups
			if (group != null) groupList.add(group);
		}
		catch (WebCenterRemoteException ex)
		{
			group = null;
		}
		if (group == null)
		{
			// ignore any exception for now
			return "";
//			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_GROUP));
//			checkLogOff(session);
//			return;
		}
	
		// group loaded from DB - output the result XML
		return SDKUtils.getGroupXML(group, fullUserInfo, groupApproverType);
	}
	catch (Exception ex)
	{
		// ignore any exception for now
		return "";
	}
}
%>

<%!
public String getAnnotationXML(String login, Annotation annotation, UserTM userTM, Vector<UserView> userList, boolean fullUserInfo, int dateFormat, HttpSession session)
{
	StringBuffer result = new StringBuffer(); 
			 
	result.append("<annotation>" + Xml.NEWLINEPARAM) ;
	if ( annotation !=  null )
	{
		result.append("<annotation_text>" +  XMLUtils.safeEncodeXml(annotation.getAnnotationText()) + "</annotation_text>" + Xml.NEWLINEPARAM);
		result.append("<annotation_author>" + getUserXML(login, userTM, userList, annotation.getUserID(), fullUserInfo)+ "</annotation_author>" + Xml.NEWLINEPARAM);
		result.append("<annotation_date>" + XMLUtils.safeEncodeXml(getDateString(annotation.getModTimeStamp(), dateFormat, session)) + "</annotation_date>" + Xml.NEWLINEPARAM);
	} 
	result.append("</annotation>") ;
	return result.toString();
}
%>

<%!
public String translateStatusID(HttpSession session , String approvalStatusID)
{
	String UserLang = LoginMgr.getLoginMgr(session).getLangKey(session);
	String languageTag = null ;  
	
	if (approvalStatusID.equalsIgnoreCase("00001_0000000001") )
	{
		languageTag = "APPROVAL_REJECTED";
	}	
	if (approvalStatusID.equalsIgnoreCase("00001_0000000002") )
	{
		languageTag = "APPROVAL_PENDING";			
	}
	if (approvalStatusID.equalsIgnoreCase("00001_0000000003") )
	{
		languageTag = "APPROVAL_APPROVED";
	}	
	if (approvalStatusID.equalsIgnoreCase("00001_0000000004") )
	{
		languageTag = "APPROVAL_FORCED_REJ";
	}
	if (approvalStatusID.equalsIgnoreCase("00001_0000000005") )
	{
		languageTag = "APPROVAL_FORCED_APP";
	}			
	if (approvalStatusID.equalsIgnoreCase("00001_0000000006"))
		languageTag = "APPROVED_COMMENTS" ;

	if (approvalStatusID.equalsIgnoreCase("00001_0000000007"))
		languageTag = "FORCED_APP_COMMENTS" ;
		 
	
	if (languageTag!=null ) 
		return LanguageMgr.getStr(UserLang, languageTag);
	else 
		return "Unknown status" ;
}
%>

<%! 
private int getStageIndex(Vector<ComplexApprovalStage> stages, String stageID)
{
	if (stages != null) 
	{	
		for (int i = 0; i < stages.size(); i++)
		{
			ComplexApprovalStage stage = stages.elementAt(i);	
			if (stage.getObjectID().equalsIgnoreCase(stageID)) 	
				return stage.counter();
		}
	}
	return 0;
}
%> 

<%!
public String getApprovalXMLExt(String login, HttpSession session, Vector approvals, 
		String userID, Vector<UserView> userList, UserTM userTM, String groupID, Vector<Group> groupList, GroupTM groupTM, 
		PageListUserApproval lastUserApproval, ComplexApprovalRule complexApprovalRule, boolean fullUserInfo, int dateFormat)
{
	StringBuffer result = new StringBuffer(); 
			 
	result.append("<approval>" + Xml.NEWLINEPARAM);
	if ( approvals != null )
	{
		// write the 'summary' status in order to be compatible with the past
		if (lastUserApproval!=null)
		{
			result.append("<approval_status>" + XMLUtils.safeEncodeXml(translateStatusID( session , lastUserApproval.getApprovalStatus())) + "</approval_status>" + Xml.NEWLINEPARAM);
			result.append("<approval_status_ID>" + lastUserApproval.getApprovalStatus()+ "</approval_status_ID>" + Xml.NEWLINEPARAM) ;
			result.append("<approval_date>" + XMLUtils.safeEncodeXml(getDateString(lastUserApproval.getModTimeStamp(), dateFormat, session)) + "</approval_date>" + Xml.NEWLINEPARAM) ;
			
			// write stage info to the xml file
			int stageIndex = getStageIndex(complexApprovalRule.stages(), lastUserApproval.getStageID());
			if (stageIndex > 0)
				result.append("<stage_index>" +  stageIndex + "</stage_index>" + Xml.NEWLINEPARAM) ;
			
			// indicate from which document version this comments comes - this is to be able to show inherited submitted approvals
			result.append("<doc_version>" +  lastUserApproval.getCopiedFromVersion() + "</doc_version>" + Xml.NEWLINEPARAM);
		} 
	
		// either the user is specified or the group is specified
		if (userID != null) 
		{
			String approvalUserXML = getUserXML(login, userTM, userList, userID, fullUserInfo);
			result.append("<approval_user>" + approvalUserXML + "</approval_user>" + Xml.NEWLINEPARAM);
			
		}
		if (groupID != null) 
		{
			String approvalGroupXML = getGroupXML(login, groupTM, groupList, groupID, fullUserInfo, 0);
			result.append("<approval_group>" + approvalGroupXML+ "</approval_group>" + Xml.NEWLINEPARAM);
		} 
		
		// iterate over the approval objects and dump them in the output 
		if ( (approvals != null))
		{	
			result.append("<approval_comment_list>" + Xml.NEWLINEPARAM);
			
			for (int i = 0; i < approvals.size(); i++)
			{
				PageListUserApproval _pageListUserApproval 	= (PageListUserApproval )approvals.elementAt(i);
				if (_pageListUserApproval!=null )
				{
					result.append("<approval_comment>" + Xml.NEWLINEPARAM);
					
					result.append("<comment>" + XMLUtils.safeEncodeXml( _pageListUserApproval.getApprovalComment() )  + "</comment>" + Xml.NEWLINEPARAM) ;
					result.append("<date>" + XMLUtils.safeEncodeXml(getDateString(_pageListUserApproval.getModTimeStamp(), dateFormat, session)) + "</date>" + Xml.NEWLINEPARAM) ;
				
					// there is always an actual user who sbmitted the approval - write that info to the xml  	
					String approvalUserXML = getUserXML(login, userTM, userList, _pageListUserApproval.getUserID(), fullUserInfo);
					result.append("<approval_user>" + approvalUserXML + "</approval_user>" + Xml.NEWLINEPARAM);

					// dump the actual approval status in this field
					result.append("<approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session , _pageListUserApproval.getApprovalStatus())) + "</approval_status>" + Xml.NEWLINEPARAM);
					result.append("<approval_status_ID>" +  _pageListUserApproval.getApprovalStatus()+ "</approval_status_ID>" + Xml.NEWLINEPARAM) ;
		
					result.append("</approval_comment>" + Xml.NEWLINEPARAM);
				}
			}			
			result.append("</approval_comment_list>" + Xml.NEWLINEPARAM);				
		}
	}
		
	result.append("</approval>") ;
	return result.toString();
}
%>


<%!
// Get the extented approval overview on this document 
private Vector<String> getDocumentApprovalXML(String login, Vector<UserView> userList, Vector<Group> groupList, 
		Approval approvalEJB, ComplexApprovalTM complexApprovalTM, UserTM userTM, GroupTM groupTM, DocumentMgrTM documentMgrTM, PageListTM pagelistTM,
		String projectID, DocVersion docVersion, DocVersion latestDocVersion, int pageIndexInDocument, int pageIndex, boolean fullUserInfo, int dateFormat, HttpSession session)
throws Exception
{
	StringBuffer result = new StringBuffer();
	Vector<String> resultVector = new Vector<String>();

	// Approval info is required, 
	// 1. get the document approval status 
	// 2. get the list of users that are supposed to approve the document
	// 3. get the list of submitted approval infos
			
	// 1. get the document approval status 
	//    - document approval status : (not_required, ongoing (aka pending), stopped, finished (+the status)  )
	//      when the approval status is not required, we do not continue since there is no info to put there.
	//    - document approval due date : due date  
	
	// note : for page list documents, we need to get to the highest document version again (not the same one as we are currently processing)
	String docVersionID =	docVersion.getObjectID();
	PageListPageProperties pageListPageProperties = null ;
	PageListDocVersionProperties pageListDocVersionProperties= null ;
	boolean pagelistDocType = false ; 
	if (docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList)) 
		pagelistDocType = true;
	int indexOfTheDocVersion = -1;  // variables only needed in the page list workflow 
	int pageIndexForApproval = -1;
	
	
	// now we get the approval info of the document ??? - complex approval counterpart!?
	// GRBO: there is no complex approval counter part.
	// Bugfix: for pagelist documents, we need to make this call with the highest document version
	DocVersionApprovalInfo docVersionAppInfo= null ;
	if (!pagelistDocType){
		boolean docUnderApproval = (docVersion.getApprovalCycle() != DocVersionApprovalInfo.ApprovalCycleStates.NO_RULE);
		
		if (docUnderApproval){
		docVersionAppInfo = (DocVersionApprovalInfo)approvalEJB.findDocVersionApprovalInfoByDocVersionId(login, docVersionID); 
		}
	}
	else
	{
		docVersionID = docVersion .getObjectID();

		docVersionAppInfo = (DocVersionApprovalInfo)approvalEJB.findDocVersionApprovalInfoByDocVersionId(login, latestDocVersion.getObjectID());
		// pagelist document - initialize variables only needed in the PL workflow  
		// DT112896  getting the approval information of the not-latest version of a page, was wrong:
		// Comment: this section is also executed for getting the approvals of previous versions of pages! 
		// In case of fetching approval info of the not-latest version of a page, 
		// we need to calculate the index that this version of the page has in its docversion:
		// For example: 
		//	                    					x1                     	     
		// pagelist:    |---|---|---|---|---|---|---|---|---|---|---|
		//          					 x2
		// x1 is the page in the document that we want to know the details of. In the code it is identified by 'pageIndexInDocument' and is an absolute index
		// x2 is the index of the document version that contains the page we are getting the info of. 
		// In order to get the approval info, we need to know the relative offset of the page in this particular document version, hence x1 - x2,
		//  or, using the terms of the code: pageIndexInDocument - indexOfTheDocVersion.
		// Remark that this complexity only comes in when we are querying the information of not-latest version of a given page.
		pageListDocVersionProperties = pagelistTM.loadPageListDocVersionProperties(login, docVersion.getObjectID()); // needed to get the offset of the doc version
		
		indexOfTheDocVersion = pageListDocVersionProperties.getIndex() - 1; // need the index, 0-based
		pageIndexForApproval = pageIndexInDocument - indexOfTheDocVersion; // we need to know the index of this page in its doc version part. 		

		pageListPageProperties = pagelistTM.loadPageListPageProperties(login, docVersion.getObjectID(), pageIndexForApproval);// load the page property
	}

	// get the document cycle status code
	// we need this to know whether the approval cycle was required or not
	short cycleStatus = latestDocVersion.getApprovalCycle();
	
	if (DocVersionApprovalInfo.ApprovalCycleStates.NO_RULE == cycleStatus)
	{
		// let them know that there is no approval ongoing on the document  
		String userLang = LoginMgr.getLoginMgr(session).getLangKey(session);
		String not_required_translated = LanguageMgr.getStr(userLang, "APPROVAL_NO_APP_REQ" );
		result.append("<document_approval_status>"+ XMLUtils.safeEncodeXml(not_required_translated) + "</document_approval_status>");
		//JANH or "No Approval Required" without translating

		resultVector.add(0 , result.toString());		
		return resultVector ;
	}

	result.append("<document_approval_cycle_code>" + cycleStatus + "</document_approval_cycle_code>" + Xml.NEWLINEPARAM);
	result.append("<document_approval_cycle_status>" + XMLUtils.safeEncodeXml(ApprovalMgr.getCycleName(session,  cycleStatus)) + "</document_approval_cycle_status>" + Xml.NEWLINEPARAM);

	// check whethet the cycle was never started, in that case, just return now 
	if (docVersionAppInfo== null){
		resultVector.add(0 , result.toString());		
		return resultVector ;		
	} 
	
	if (!pagelistDocType)
	{
		if ( (cycleStatus == DocVersionApprovalInfo.ApprovalCycleStates.STARTED) || (cycleStatus == DocVersionApprovalInfo.ApprovalCycleStates.FINISHED) )
		{
			// get the final status and translate this one 
			String final_state = docVersion.getApprovalStatus(); 
			result.append("<document_approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session, final_state)) + "</document_approval_status>" + Xml.NEWLINEPARAM);
			result.append("<document_approval_code>" + final_state + "</document_approval_code>" + Xml.NEWLINEPARAM);
		}
	} 
	else
	{
		if (pageListPageProperties != null) // checking on the cycleStatus as in the non-pagelist example does not seem to guarantee that the pageListPageProperties are defined  
		{
			String pageApprovalStatus = pageListPageProperties.getApprovalStatus();
			result.append("<document_approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session, pageApprovalStatus)) + "</document_approval_status>" + Xml.NEWLINEPARAM);
			result.append("<document_approval_code>" + pageApprovalStatus + "</document_approval_code>" + Xml.NEWLINEPARAM);
		}
		else if ( (cycleStatus == DocVersionApprovalInfo.ApprovalCycleStates.STARTED) || (cycleStatus == DocVersionApprovalInfo.ApprovalCycleStates.FINISHED) )
		{
			// get the final status and translate this one 
			String final_state = latestDocVersion.getApprovalStatus(); 
			result.append("<document_approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session, final_state)) + "</document_approval_status>" + Xml.NEWLINEPARAM);
			result.append("<document_approval_code>" + final_state + "</document_approval_code>" + Xml.NEWLINEPARAM);
		}
	}
	
				
	// set the due date (when approval is required )
	if ( (DocVersionApprovalInfo.ApprovalCycleStates.NO_RULE != cycleStatus)  && (docVersionAppInfo.getApprovalDueDate() != null) )
	{	
		Timestamp beginning_of_time = new Timestamp(0);
		if (!beginning_of_time.equals( docVersionAppInfo.getApprovalDueDate() )) 
			result.append("<document_approval_due_date> " + XMLUtils.safeEncodeXml(getDateString(docVersionAppInfo.getApprovalDueDate(), dateFormat, session)) + " </document_approval_due_date>" + Xml.NEWLINEPARAM);
	}

	Vector pageApprovals = null;
	
	// get the list of approvals submitted on this document version or in this page 
	ComplexApprovalRule complexApprovalRule;
	// 0. list of the approval stages  - 
	// JANH: this is ommited in case of a simple approval ??? - check if complexApprovalRule == null in case of simple approval!? - NO!
	// GRBO: (replying on Jan's remark above): all approval rules are now loaded with this call for simplicity (we do not need to make a disctinction between simple and complex approval rules)  
	Vector<DocVersionApprovalInfo> stageApprovalInfos;

	if (docVersion.getDocTypeID().equalsIgnoreCase(DocTypeDB.DocTypeIDValues.PageList))
	{
		pageApprovals = pagelistTM.loadPageListPageApprovalInfo(login, docVersion.getObjectID(), pageIndexForApproval);
		complexApprovalRule = complexApprovalTM.loadApprovalSetup(login, null, null, docVersion.getDocumentID(),latestDocVersion.getObjectID() );
		stageApprovalInfos = complexApprovalTM.loadDocVersionApprovalStageInfo(login, latestDocVersion.getObjectID());
	}
	else
	{
		pageApprovals = complexApprovalTM.getSubmittedApprovals(login, docVersion.getObjectID(), null, null); 		
		stageApprovalInfos = complexApprovalTM.loadDocVersionApprovalStageInfo(login, docVersion.getObjectID());
		
		// load the approval setup of the current version. 
		complexApprovalRule = complexApprovalTM.loadApprovalSetup(login, null, null, docVersion.getDocumentID(),docVersion.getObjectID());
		// DT102951/DT89135 : this is to cover the situation when we are looking at a documnet that has an approval in 7.1 (or earlier) and that got migrated to a version 10 
		// These documents do not have a version-based approval, so we need to look at the approval rule of the highest document version
		if (complexApprovalRule==null)
			complexApprovalRule		= complexApprovalTM.loadApprovalSetup( login, null,null , null, latestDocVersion.getObjectID()) ;		
			
		// we filter the page approvals against the users that are approval users of the rule
		pageApprovals = ApprovalMgr.filterApprovalUsers(pageApprovals , complexApprovalRule );
	}	
	
	
		
	// the index of the current (ongoing) stage 
	result.append("<stage_index>" + docVersionAppInfo.getStageCounter() + "</stage_index>");		
		
	// dump stages into XML (JANH moved elsewhere!)
	result.append(writeStagesToXML(login, session, complexApprovalRule, stageApprovalInfos, pageApprovals, userList, groupList, userTM, groupTM, fullUserInfo, dateFormat));
		
	// 1. a list of approval statuses  
	result.append("<approvals>" + Xml.NEWLINEPARAM);
			
	
	if ((pageApprovals != null) && (pageApprovals.size() > 0)) 
	{
		// iterate over the stages, for each stage, iterate over the submitted stages and group them by approval user
		
		for ( int k = 0 ; k < complexApprovalRule.nrStages() ; k++ )
		{
			// need to iterate over the approval statuses and group the settings that belong to a same user identity 
			Vector<String> processedUsers = new Vector<String>(); 
			Vector<String> processedGroups = new Vector<String>(); 
				
			// iterate and bundle according to the same identities 
			for (int i = 0 ; i < pageApprovals.size() ; i++  )
			{
				PageListUserApproval pageListUserApproval = (PageListUserApproval )pageApprovals.elementAt(i);
				if (pageListUserApproval !=null && pageListUserApproval.getStageCounter()==k+1) // filter on the stage
				{
					String userID = pageListUserApproval.getUserID() ;
					String groupID = pageListUserApproval.getGroupID() ;
					boolean groupApproval = false ;
					if ((groupID != null) && (groupID.length() > 0)) 
					{
						groupApproval = true;
					}
					
					// when it is a group approval and this group has not been processed yet, do the processing of this group
					if (groupApproval)
					{					
						if (!processedGroups.contains(groupID)) 
						{
							// get all the approvals that go with this group and then dump the content in XML 
							Vector<PageListUserApproval> groupApprovalList = filterBasedUponApprover(pageApprovals, groupID, null, true, i, k); 
						
							// get the last submitted status 
							PageListUserApproval lastSubmittedStatus = getLastStatus(groupApprovalList);
					
							result.append(getApprovalXMLExt(login, session, groupApprovalList, null, userList, userTM, groupID, groupList, groupTM, lastSubmittedStatus, complexApprovalRule, fullUserInfo, dateFormat) + Xml.NEWLINEPARAM);
							
							// add the group to the list of processed groups so that it does not get processed a second time
							processedGroups.add(groupID);
						}
					}
					// when it is a user approval and this user has not been processed yet, do the processing of this user
					else if (!processedUsers.contains(userID))
					{
						// get all the approvals that go with this user and then dump the content in XML 
						Vector<PageListUserApproval> userApprovalList = filterBasedUponApprover(pageApprovals, null, userID, false, i, k); 
					
						// get the last submitted status 
						PageListUserApproval lastSubmittedStatus = getLastStatus(userApprovalList);
						
						result.append(getApprovalXMLExt(login, session, userApprovalList, userID, userList, userTM, null, groupList, groupTM, lastSubmittedStatus, complexApprovalRule, fullUserInfo, dateFormat) + Xml.NEWLINEPARAM);
					
						// add the user to the list of processed userss so that it does not get processed a second time 					
						processedUsers.add(userID);
					}
				}
			}
		}
	}

	result.append("</approvals>");							
		
	resultVector.add(0 , result.toString());		
				
	return resultVector ;	
	
}
%>
 
 
<%!
	public String getDocInfoXML(Document doc, String docVersionID, String folderID, int dateFormat, HttpSession session)
	throws Exception
	{
		StringBuffer result = new StringBuffer(); 

		result.append(Xml.getFieldXml("docID", doc.getObjectID()));
		result.append(Xml.getFieldXml("last_version_number", doc.getLastVersionIndex()));
		result.append(Xml.getFieldXml("document_name", doc.getName()));

		// get the description	
		String description = doc.getDescription();
		if (description != null)
			result.append(Xml.getFieldXml("description", description));
		
		// get modification date 
		if (doc.getModTimeStamp() != null) {
			result.append(Xml.getFieldXml("modification_date", getDateString(doc.getModTimeStamp(), dateFormat, session)));
		}
		if (!StringUtils.checkForValue(folderID)) folderID = "";
		result.append("<folderID>" + folderID + "</folderID>" + Xml.NEWLINEPARAM);
		
		result.append("<is_url>" + doc.isUrl() + "</is_url>" + Xml.NEWLINEPARAM);
		result.append("<checked_out_owner_id>" + doc.getCheckedOwnerID() + "</checked_out_owner_id>" + Xml.NEWLINEPARAM);
		
		// the highest doc revision
		int lastRev = doc.getLastRevision();
		result.append(Xml.getFieldXml(DocumentXml.XMLLASTREVISIONTAG, lastRev));
		result.append(Xml.getFieldXml(DocVersionXml.XMLREVISIONLETTER, DocVersion.getRevisionLetter(lastRev)));

		Permission permission=SecurityUtils.getEffectiveDocVersionUserPermission(session, docVersionID);
		if (permission!=null){
			PermissionXml permissionXml= new PermissionXml();
			result.append(permissionXml.getInXml(permission));
		}
		
		return result.toString();
	}
%>

<%!
// write the list of approval choices in an xml string 
public Vector<PageListUserApproval> filterBasedUponApprover(Vector<PageListUserApproval> approvals, String groupID, String userID, boolean groupApproval, int startIndex, int stageIndex) 
{
	Vector<PageListUserApproval> resultingApprovals = new Vector<PageListUserApproval>(); 

	for (int j = startIndex ; j < approvals.size() ; j++) // I only need to start to count from i
	{
		PageListUserApproval _pageListUserApproval = approvals.elementAt(j);
		if (_pageListUserApproval != null && _pageListUserApproval.getStageCounter()==stageIndex+1)
		{
			String _groupID = _pageListUserApproval.getGroupID() ;
			if (groupApproval)
			{
				if ( (_groupID != null) && (_groupID.equalsIgnoreCase(groupID)) )
				{
					resultingApprovals.add(_pageListUserApproval); 
				} 							
			} 
			else // no group approval - the group should be set to 0
			{
				String _userID = _pageListUserApproval.getUserID() ;
				
				// user need to match but also the group shoudl be zero (otherwise it is a group approval!!! )
				if ( (_userID != null) && (_userID.equalsIgnoreCase(userID)) )
				{
					boolean isGroupApproval = false; 
					if ( (_groupID != null) && (_groupID.length() > 0) )
					{
						isGroupApproval = true;
					}
					if (!isGroupApproval)
					{
						resultingApprovals.add( _pageListUserApproval); // add the user approval record 
					} 	
				} 
			}
		} 
	}
	return resultingApprovals;
}
%>



<%!
public PageListUserApproval getLastStatus(Vector<PageListUserApproval> approvalStatuses)
	{
		if ( approvalStatuses == null)
			return null ; 
		
		
		PageListUserApproval lastStatus = approvalStatuses.elementAt(0);	
		for (int i = 1 ; i < approvalStatuses.size() ; i++ )	 
		{
			PageListUserApproval tempStatus = approvalStatuses.elementAt(i) ;		
			Timestamp ts = tempStatus.getModTimeStamp() ;
			if ( ts.getTime() > lastStatus.getModTimeStamp().getTime() )
			{
				lastStatus = tempStatus;
			} 
		}
		
		return lastStatus ;
	}
%>

<%!
// write the list of approval choices in an xml string 
public String getApprovalTypesXML(HttpServletResponse response, HttpSession session) 
{
	String appLevelsXML = new String ();
	String UserLang = LoginMgr.getLoginMgr(session).getLangKey(session);
	
	appLevelsXML += "<approvaltypes>" + Xml.NEWLINEPARAM;
			
	Vector approvalTypesList = ApprovalMgr.GetApprovalTypes(response, session);
	if (approvalTypesList != null)
	{
		for (int i = 0 ; i < approvalTypesList.size(); i++)
		{
			ApprovalType appType = (ApprovalType)approvalTypesList.elementAt(i);
		
			appLevelsXML += Xml.getBeginTag("approvaltype");
				appLevelsXML += Xml.getFieldXml("approvalid", appType.getObjectID());   // (original)
				appLevelsXML += Xml.getFieldXml("type_name", appType.getTypeName());
				String labelTag = appType.getLabelTag();
				// translated approval type name (original)
				appLevelsXML += Xml.getFieldXml("approvalname", LanguageMgr.getStr(UserLang, labelTag));
				appLevelsXML += Xml.getFieldXml("approval_level", appType.getApprovalLevel());
				appLevelsXML += Xml.getFieldXml("display_order", appType.getDisplayOder());
				appLevelsXML += Xml.getFieldXml("icon", appType.getIcon());
			appLevelsXML += Xml.getEndTag("approvaltype") + Xml.NEWLINEPARAM;
		}
	}

	appLevelsXML += "</approvaltypes>";
	return appLevelsXML ;
}
%>

<%!
/**
* Format dateAndTime (Timestamp) into a string
* 
* @param dateAndTime Timestamp to be formatted 
* @param dateFormat
*   0: simple Timestamp.toString() - no timezone correction (always GMT) e.g. "2014-10-22 09:37:22.407" (default)
*   1: WebCenter style date and time string - corrected for client language and timezone, e.g. "Oct 22, 2014 at 9:36 AM" 
*   2: milliseconds since Jan 1, 1970, e.g. "1413963408890"
* @param session
*/
public String getDateString(Timestamp dateAndTime, int dateFormat, HttpSession session) 
{
	int timezoneOffsetMillis = LoginMgr.getLoginMgr(session).getTimezoneOffsetMillis();
	String userLang = LoginMgr.getLoginMgr(session).getLangKey(session);
	switch (dateFormat) {
		case 1:
			return DateUtils.HumanReadableDateAndTime(Long.toString(dateAndTime.getTime()), Integer.toString(timezoneOffsetMillis), userLang);
		case 2:
			return Long.toString(dateAndTime.getTime());
		case 0:
		default:
			return dateAndTime.toString();
	}
}
%>
 
<%!
public Vector<String> getDocVersionInfoXML(String login, Vector<UserView> userList, Vector<Group> groupList, UserTM userTM, GroupTM groupTM, 
		DocVersion docVersion, DocVersion latestDocVersion, DocumentMgrTM documentMgrTM, Approval approvalEJB, ComplexApprovalTM complexApprovalTM, PageListTM pagelistTM,
		String projectID, boolean debug, boolean approvalInfo, boolean annotationInfo, boolean fullUserInfo, int dateFormat, boolean thumbnailUrl, boolean acatInfo, 
		boolean folderInfo, String folderID, HttpSession session)
throws InvalidParameterException, Exception		
{
	// get the XML string for all the documents in this folder
	StringBuffer result = new StringBuffer(); 
	Vector<String> resultVector = new Vector<String>();
		
	//  Information about this version
	//  We need: 
	//  1. general infomation (created data, author, version nr )
	//  2. approval information - list of approval users, submitted approval 
	//  3. annotation information
	//  4. thumbnail url (optional)
	//  5. attribute category basic info (optional)
	//  6. folder information (optional)

	result.append("<document_version>" + Xml.NEWLINEPARAM);

	try {
		// general info 
		String authorID = docVersion.getAuthorID() ;
		String comment = docVersion.getComments();
		String modTime = docVersion.getModTimeStamp().toString() ;
		String sourceID = docVersion.getSourceID();
		short  versionNr = docVersion.getVersionCounter();	
		String revisionLetter = DocVersion.getRevisionLetter(docVersion.getRevision());
		String has3dView = docVersion.getHas3DView()?"1":"0";

		result.append("<version_number>" + new Short(versionNr).toString() + "</version_number>" + Xml.NEWLINEPARAM);
		result.append("<revision_letter>" + revisionLetter + "</revision_letter>" + Xml.NEWLINEPARAM);
		result.append("<version_comments>" + XMLUtils.safeEncodeXml (comment) + "</version_comments>" + Xml.NEWLINEPARAM);
		result.append("<creation_date>" + XMLUtils.safeEncodeXml(getDateString(docVersion.getCreatedDate(), dateFormat, session)) + "</creation_date>" + Xml.NEWLINEPARAM);
		try {
    		result.append(Xml.getFieldXml(DocVersionXml.XMLCREATEDDATETAG, docVersion.getCreatedTimestamp()));
   		} catch (InvalidParameterException x) { }
		result.append("<source_id>" + sourceID + "</source_id>" + Xml.NEWLINEPARAM);
		result.append("<has_3d_view>" + has3dView + "</has_3d_view>" + Xml.NEWLINEPARAM);
		
		// revision
		int rev = docVersion.getRevision();
		result.append(Xml.getFieldXml(DocVersionXml.XMLREVISION, rev));
		result.append(Xml.getFieldXml(DocVersionXml.XMLREVISIONLETTER, DocVersion.getRevisionLetter(rev)));

		result.append("<docVersionID>" + docVersion.getObjectID()  + "</docVersionID>" + Xml.NEWLINEPARAM);	
		
		result.append("<doc_type_id>" + docVersion.getDocTypeID() + "</doc_type_id>" + Xml.NEWLINEPARAM);

		// Category Info
		if (acatInfo) {
			String categoryID = docVersion.getAttributeCategoryID(); 
			
			// get the category's last modified stamp
			if (IdGenerator.isIDFormat(categoryID) ){
				result.append("<category_id>" + categoryID + "</category_id>" + Xml.NEWLINEPARAM);
				
				// write user units
				String userUnits = LoginMgr.getLoginMgr(session).getUserUnits(session);
				result.append("<user_units>" + userUnits + "</user_units>"+ Xml.NEWLINEPARAM);
				
				CategoryTM categoryTM = DBTMUtils.findBean(null, null, CategoryTM.class);
				Timestamp lastModified = categoryTM.getModifiedTimeStamp(login,categoryID);				
				final Category category = CategoryObjectCache.get(login,categoryID,categoryTM);
				boolean layoutIsEmpty = category.getCategoryXML() == null || category.getCategoryXML().length==0 ;
				result.append( CategoryXml.writeLayoutInfo(CategoryXml.XMLTAG, categoryID, category.getName(),  lastModified, layoutIsEmpty ));						
			}
		}

		// Folder Info
		if (folderInfo) {
			String folderName = "";   // empty string means "Root folder", which is also a default value
			if (StringUtils.checkForValue(folderID)) {
				FolderTM folderTM = DBTMUtils.findBean(null, null, FolderTM.class);
				Folder folderObj = folderTM.findById(login, folderID);
				if ((folderObj != null) && folderObj.isLoaded()) {
					folderName = folderObj.getName();
				}
			}
			result.append(Xml.getBeginTag("folder"));
				result.append(Xml.getFieldXml("id", folderID));
				result.append(Xml.getFieldXml("name", folderName));
			result.append(Xml.getEndTag("folder"));
		}
		
		// thumbnail URL (thumbnail streamer)
		if (thumbnailUrl) {
			Document document = documentMgrTM.findById(login, docVersion.getDocumentID());
			if (document != null) {
				String thumbnailURL = ThumbnailMgr.getDocumentThumbnail(session, document, docVersion.getDocTypeID());
				if (StringUtils.checkForValue(thumbnailURL)) {
					result.append("<thumb_url>" + XMLUtils.safeEncodeXml(thumbnailURL) + "</thumb_url>" + Xml.NEWLINEPARAM);
				}
			}
		}

		if (authorID != null)
			result.append( "<author>" + getUserXML(login, userTM, userList, authorID, fullUserInfo) + "</author>" + Xml.NEWLINEPARAM);
				
		// Find annotations 
		if (annotationInfo)
		{
			Vector<DocVersionAnnotationView> annotations = null; 
		
			result.append("<annotations>" );
			if ( docVersion.isPageListDocument()) {
				annotations = approvalEJB.findDocVersionAnnotations(login, projectID, latestDocVersion.getObjectID());	
			}
			else{
				annotations = approvalEJB.findDocVersionAnnotations(login, projectID, docVersion.getObjectID());
			}
			if (annotations != null)
			{
				for (int i = 0; i < annotations.size(); i++)
				{
					DocVersionAnnotationView ann = annotations.elementAt(i);
					result.append(getAnnotationXML(login, ann.getAnnotation(), userTM, userList, fullUserInfo, dateFormat, session));				
				}
			}
			result.append("</annotations>" + Xml.NEWLINEPARAM);
		}			

		// Find Approval info
		if (approvalInfo)
		{
			Vector<String> documentApprovalInfoVector = null;
			if ( docVersion.isPageListDocument()) {
				
				documentApprovalInfoVector = getDocumentApprovalXML(login, userList, groupList, 
						approvalEJB, complexApprovalTM, userTM, groupTM, documentMgrTM, pagelistTM, 
						projectID, latestDocVersion, latestDocVersion,-1, -1, fullUserInfo, dateFormat, session);	
			}
			else{
				documentApprovalInfoVector = getDocumentApprovalXML(login, userList, groupList, 
						approvalEJB, complexApprovalTM, userTM, groupTM, documentMgrTM, pagelistTM, 
						projectID, docVersion, latestDocVersion,-1, -1, fullUserInfo, dateFormat, session);
			}
			
			if (documentApprovalInfoVector!=null)
			{
				result.append(documentApprovalInfoVector.elementAt(0) + Xml.NEWLINEPARAM);
			} 					    
		} 
		
		result.append("</document_version>");
		
	}
	catch(WebCenterRemoteException e)
	{
		return null ; 
	}			
	
	// result vector : return the string 
	resultVector.add(0, result.toString());
		    
	// debug : 
	//System.out.println("Get Document History " +result.toString())	 ;   
		    
  return resultVector;
}
%>


  
<%!
public String getPageVersionInfoXML(String login, Vector<UserView> userList, Vector<Group> groupList, UserTM userTM, GroupTM groupTM,  
		DocVersion docVersion, DocVersion latestDocVersion,int versionCounter,int pageIndexInDocument, int versionPageIndex,  PageListDocVersionProperties pageListPageDocVersionView, 
		DocumentMgrTM documentMgrTM , Approval approvalEJB, ComplexApprovalTM  complexApprovalTM, PageListTM pagelistTM,
		String projectID, boolean approvalInfo, boolean annotationInfo, boolean fullUserInfo, int dateFormat, HttpSession session)
throws InvalidParameterException, Exception
{
	// get the XML string for all the documents in this folder
	StringBuffer result = new StringBuffer(); 
		
	//  Information about this page
	//  We need: 
	//  1. general infomation (created data, author, version nr )
	//  2. approval information - list of approval users, submitted approval 
	//  3. annotation information
	String pageDocVersionID = pageListPageDocVersionView.getDocVersionID();
	DocVersion pageDocVersion = documentMgrTM.findDocVersionById(login, pageDocVersionID);
	String authorID = pageDocVersion.getAuthorID() ;
	String revisionLetter = DocVersion.getRevisionLetter(pageDocVersion.getRevision());

	result.append("<document_version>" + Xml.NEWLINEPARAM);

	try {
		// general info 
		result.append("<version_number>" + versionCounter + "</version_number>" + Xml.NEWLINEPARAM);
		result.append("<revision_letter>" + revisionLetter + "</revision_letter>" + Xml.NEWLINEPARAM);
		result.append("<version_comments>" + XMLUtils.safeEncodeXml (pageDocVersion.getComments()) + "</version_comments>" + Xml.NEWLINEPARAM);
		result.append("<creation_date>" + XMLUtils.safeEncodeXml(getDateString(pageDocVersion.getCreatedDate(), dateFormat, session)) + "</creation_date>" + Xml.NEWLINEPARAM);

		result.append("<docVersionID>" + pageDocVersion.getObjectID()  + "</docVersionID>" + Xml.NEWLINEPARAM);
		result.append("<pageno>" + (int)(versionPageIndex + 1) + "</pageno>" + Xml.NEWLINEPARAM);


		if ( authorID != null )
				result.append( "<author>" + getUserXML(login, userTM, userList, pageDocVersion.getAuthorID(), fullUserInfo) + "</author>" + Xml.NEWLINEPARAM);
				
		// Find annotations 
		if (annotationInfo)
		{
			result.append("<annotations>" );
			Vector<DocVersionAnnotationView> annotations = approvalEJB.findDocVersionAnnotations(login, projectID, pageDocVersion.getObjectID(), versionPageIndex);
			if (annotations !=null )
			{
				for (int i = 0 ; i < annotations.size() ; i++ )
				{
					DocVersionAnnotationView ann =  annotations.elementAt(i);
					result.append(getAnnotationXML(login, ann.getAnnotation(), userTM, userList, fullUserInfo, dateFormat, session));				
				}
			}
			result.append("</annotations>" + Xml.NEWLINEPARAM);
		}			

		// Find Approval info
		if (approvalInfo)
		{
			Vector<String> documentApprovalInfoVector = getDocumentApprovalXML(login, userList, groupList, 
					approvalEJB, complexApprovalTM, userTM, groupTM, documentMgrTM, pagelistTM, 
					projectID, pageDocVersion, latestDocVersion, pageIndexInDocument, versionPageIndex, fullUserInfo, dateFormat, session);
			if (documentApprovalInfoVector!=null)
			{
				result.append( documentApprovalInfoVector.elementAt(0) + Xml.NEWLINEPARAM);
			} 					    
		} 
		result.append("</document_version>");		
	}
	catch(WebCenterRemoteException e)
	{
		LogMgr.getLogger().log(Level.SEVERE, "RemoteExcepotion occured " + e.toString());					
		return null ; 
	}			
		    
  return result.toString();
}
%> 

<%!
private String writeStagesToXML(String loginID, HttpSession session, ComplexApprovalRule complexApprovalRule, 
		Vector<DocVersionApprovalInfo> stageApprovalInfos, Vector<PageListUserApproval> pageApprovals, 
		Vector<UserView> userList, Vector<Group> groupList, UserTM userTM, GroupTM groupTM, boolean fullUserInfo, int dateFormat)
throws InvalidParameterException
{
	StringBuffer result = new StringBuffer();
	
	Vector<ComplexApprovalStage> stages = complexApprovalRule.stages();
	if (stages != null) 
	{
		result.append("<stages>");
		for (int stageIdx = 0; stageIdx < stages.size(); stageIdx++) 
		{
			ComplexApprovalStage stage = complexApprovalRule.getStageAtCounter(stageIdx+1);
			DocVersionApprovalInfo stageAppInfo = null;
			if ((stageApprovalInfos != null) && (stageApprovalInfos.size() > stageIdx))
			{
				stageAppInfo = stageApprovalInfos.get(stageIdx);
				//JANH should not happen - then DEL ???
				if (!stageAppInfo.getStageID().equalsIgnoreCase(stage.getObjectID())) stageAppInfo = null;
			}
			
			if (stage != null) 
			{
				// write the stage into the XML 
				result.append(Xml.getBeginTag("stage"));
				result.append(Xml.getFieldXml("stage_id", stage.getObjectID()));
				result.append(Xml.getFieldXml("name", XMLUtils.safeEncodeXml(stage.name())));
				result.append(Xml.getFieldXml("index", stage.counter()));
				if (stage.dueDate() != null) result.append(Xml.getFieldXml("due_date", XMLUtils.safeEncodeXml(getDateString(stage.dueDate(), dateFormat, session))));
				if (stage.leadTime() > 0) result.append(Xml.getFieldXml("lead_time", stage.leadTime()));
				result.append(Xml.getFieldXml("conditional_approval", stage.condApprovalAllowed()));
				result.append(Xml.getFieldXml("upon_rejection_code", stage.uponrejection()));
//				result.append(Xml.getFieldXml("upon_rejection", stage.uponRejectionString()));
				result.append(Xml.getFieldXml("require_review_state_code", stage.getRequireReviewState()));
			
				if (stageAppInfo != null)
				{
					result.append(Xml.getFieldXml("stage_approval_cycle_code", stageAppInfo.getApprovalCycleState()));
					result.append(Xml.getFieldXml("stage_approval_cycle_status", XMLUtils.safeEncodeXml(ApprovalMgr.getCycleName(session, stageAppInfo.getApprovalCycleState()))));
					result.append(Xml.getFieldXml("stage_approval_code", stageAppInfo.getApprovalState()));
					result.append(Xml.getFieldXml("stage_approval_status", XMLUtils.safeEncodeXml(translateStatusID(session, stageAppInfo.getApprovalState()))));
					if (stageAppInfo.getStartedDate() != null)
					{
						result.append(Xml.getFieldXml("stage_approval_start_date", XMLUtils.safeEncodeXml(getDateString(stageAppInfo.getStartedDate(), dateFormat, session))));
					}
					if (stageAppInfo.getApprovalDueDate().getTime() < 1000L*3600*24) 
						result.append(Xml.getFieldXml("stage_approval_due_date", ""));
					else
						result.append(Xml.getFieldXml("stage_approval_due_date", XMLUtils.safeEncodeXml(getDateString(stageAppInfo.getApprovalDueDate(), dateFormat, session))));
				}
				
				result.append(Xml.getBeginTag("approver_list"));

				Vector<String> processedUserApprovers = new Vector<String>((pageApprovals != null) ? pageApprovals.size() : 1);
				
				if (stage.approvers() != null) 
				{
					Vector<ComplexStageApprover> approvers = stage.approvers();
					for (int a = 0; a < approvers.size(); a++) 
					{
						ComplexStageApprover approver = approvers.get(a);

						boolean approverFound = false;
						
						// write out approver type and ID
						result.append(Xml.getBeginTag("approver"));
//						result.append(Xml.getFieldXml("type", approver.approverType()));
						if (approver.approverType() == ComplexStageApprover.USER) 
						{
							result.append(getUserXML(loginID, userTM, userList, approver.approverUserID(), fullUserInfo));

							// find corresponding approval made by actual user if exists
							for (int j = 0; j < pageApprovals.size(); j++) 
							{
								PageListUserApproval userApproval = pageApprovals.get(j);
								if ((userApproval != null) && (userApproval.getStageCounter() == stageIdx+1) &&
										(userApproval.getUserID().length() > 0) && (userApproval.getGroupID().length() == 0) &&
										userApproval.getUserID().equalsIgnoreCase(approver.approverUserID()))
								{
									approverFound = true;
									processedUserApprovers.add(userApproval.getUserID());

									result.append("<approval_action>" + Xml.NEWLINEPARAM);

									result.append("<user_approver_ID>" + XMLUtils.safeEncodeXml(userApproval.getUserID()) + "</user_approver_ID>" + Xml.NEWLINEPARAM);
									
									result.append("<approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session, userApproval.getApprovalStatus())) + "</approval_status>" + Xml.NEWLINEPARAM);
									result.append("<approval_status_ID>" + userApproval.getApprovalStatus() + "</approval_status_ID>" + Xml.NEWLINEPARAM);
									result.append("<approval_date>" + XMLUtils.safeEncodeXml(getDateString(userApproval.getModTimeStamp(), dateFormat, session)) + "</approval_date>" + Xml.NEWLINEPARAM);
			
									// indicate from which document version this comments comes - this is to be able to show inherited submitted approvals
									result.append("<doc_version>" +  userApproval.getCopiedFromVersion() + "</doc_version>" + Xml.NEWLINEPARAM);
									
									if (userApproval.getApprovalComment().length() > 0)
									{
										// write out approval comments if any
										result.append("<approval_comment>" + Xml.NEWLINEPARAM);
										result.append("<comment>" + XMLUtils.safeEncodeXml(userApproval.getApprovalComment()) + "</comment>" + Xml.NEWLINEPARAM);
										result.append("<date>" + XMLUtils.safeEncodeXml(getDateString(userApproval.getModTimeStamp(), dateFormat, session)) + "</date>" + Xml.NEWLINEPARAM);
										result.append("</approval_comment>" + Xml.NEWLINEPARAM);
									}
									else
									{
										result.append("<approval_comment/>" + Xml.NEWLINEPARAM);
									}
									result.append("</approval_action>" + Xml.NEWLINEPARAM);
								}
							}
						}
						else   // approver is a group
						{
							result.append(getGroupXML(loginID, groupTM, groupList, approver.approverGroupID(), fullUserInfo, 
									approver.approverType()));

							// find corresponding approval made by actual group if exists
							for (int j = 0; j < pageApprovals.size(); j++) 
							{
								PageListUserApproval groupApproval = (PageListUserApproval)pageApprovals.get(j);
								if ((groupApproval != null) && (groupApproval.getStageCounter() == stageIdx+1) &&
										(groupApproval.getGroupID().length() > 0) && 
										groupApproval.getGroupID().equalsIgnoreCase(approver.approverGroupID()))
								{
									approverFound = true;
									processedUserApprovers.add(groupApproval.getUserID());

									result.append("<approval_action>" + Xml.NEWLINEPARAM);

									result.append("<group_approver_ID>" + XMLUtils.safeEncodeXml(groupApproval.getGroupID()) + "</group_approver_ID>" + Xml.NEWLINEPARAM);
									result.append("<actual_user_approver>" + Xml.NEWLINEPARAM);
										result.append(getUserXML(loginID, userTM, userList, groupApproval.getUserID(), fullUserInfo));
									result.append("</actual_user_approver>" + Xml.NEWLINEPARAM);
																
									result.append("<approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session, groupApproval.getApprovalStatus())) + "</approval_status>" + Xml.NEWLINEPARAM);
									result.append("<approval_status_ID>" + groupApproval.getApprovalStatus() + "</approval_status_ID>" + Xml.NEWLINEPARAM);
									result.append("<approval_date>" + XMLUtils.safeEncodeXml(getDateString(groupApproval.getModTimeStamp(), dateFormat, session)) + "</approval_date>" + Xml.NEWLINEPARAM);
			
									// indicate from which document version this comments comes - this is to be able to show inherited submitted approvals
									result.append("<doc_version>" +  groupApproval.getCopiedFromVersion() + "</doc_version>" + Xml.NEWLINEPARAM) ;			 

									if (groupApproval.getApprovalComment().length() > 0)
									{
										// write out approval comments if any
										result.append("<approval_comment>" + Xml.NEWLINEPARAM);
										result.append("<comment>" + XMLUtils.safeEncodeXml(groupApproval.getApprovalComment()) + "</comment>" + Xml.NEWLINEPARAM);
										result.append("<date>" + XMLUtils.safeEncodeXml(getDateString(groupApproval.getModTimeStamp(), dateFormat, session)) + "</date>" + Xml.NEWLINEPARAM);
										result.append("</approval_comment>" + Xml.NEWLINEPARAM);
									}
									else
									{
										result.append("<approval_comment/>" + Xml.NEWLINEPARAM);
									}

									result.append("</approval_action>" + Xml.NEWLINEPARAM);
								}
							}
						}
						
						if (!approverFound)
						{
							// no approval action done by approvers in actual approval stage
							result.append("<approval_action/>" + Xml.NEWLINEPARAM);
						}
							
						result.append(Xml.getEndTag("approver"));
					}
				}

				if (processedUserApprovers.size() < pageApprovals.size())  
				{
					// there is another approval done by approver who (probably) force approved actual document version
					// identify the extra approver(s) and write them to XML
					for (int j = 0; j < pageApprovals.size(); j++)
					{
						PageListUserApproval extraApproval = (PageListUserApproval)pageApprovals.get(j);
						if ((extraApproval != null) && !processedUserApprovers.contains(extraApproval.getUserID()) && 
								(extraApproval.getGroupID().length() == 0) && (extraApproval.getStageCounter() == stageIdx+1))
						{
							result.append(Xml.getBeginTag("extra_approver"));
							result.append(getUserXML(loginID, userTM, userList, extraApproval.getUserID(), fullUserInfo));
															result.append("<approval_action>" + Xml.NEWLINEPARAM);
							
							result.append("<approval_status>" + XMLUtils.safeEncodeXml(translateStatusID(session, extraApproval.getApprovalStatus())) + "</approval_status>" + Xml.NEWLINEPARAM);
							result.append("<approval_status_ID>" + extraApproval.getApprovalStatus() + "</approval_status_ID>" + Xml.NEWLINEPARAM);
							result.append("<approval_date>" + XMLUtils.safeEncodeXml(getDateString(extraApproval.getModTimeStamp(), dateFormat, session)) + "</approval_date>" + Xml.NEWLINEPARAM);
	
							// indicate from which document version this comments comes - this is to be able to show inherited submitted approvals
							result.append("<doc_version>" +  extraApproval.getCopiedFromVersion() + "</doc_version>" + Xml.NEWLINEPARAM);
							
							if (extraApproval.getApprovalComment().length() > 0)
							{
								// write out approval comments if any
								result.append("<approval_comment>" + Xml.NEWLINEPARAM);
								result.append("<comment>" + XMLUtils.safeEncodeXml(extraApproval.getApprovalComment()) + "</comment>" + Xml.NEWLINEPARAM);
								result.append("<date>" + XMLUtils.safeEncodeXml(getDateString(extraApproval.getModTimeStamp(), dateFormat, session)) + "</date>" + Xml.NEWLINEPARAM);
								result.append("</approval_comment>" + Xml.NEWLINEPARAM);
							}
							else
							{
								result.append("<approval_comment/>" + Xml.NEWLINEPARAM);
							}
							result.append("</approval_action>" + Xml.NEWLINEPARAM);
							result.append(Xml.getEndTag("extra_approver"));
						}
					} 
				}

				result.append(Xml.getEndTag("approver_list"));

				result.append(Xml.getEndTag("stage"));
			}
		}
		result.append("</stages>");
	}
	
	return result.toString();
}
%>
 
