<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdklogincheck.jsp" %>

<%@ page import="java.util.*" %>
<%@page import="java.util.concurrent.ExecutionException"%>

<%@ page import="com.esko.webcenter.jsp.*" %>
<%@ page import="com.esko.webcenter.src.root.*"%>
<%@ page import="com.esko.webcenter.src.root.view.ProjectView"%>
<%@ page import="com.esko.webcenter.src.xml.*"%>
<%@ page import="com.esko.util.*" %>
<%@ page import="com.esko.webcenter.src.util.IdGenerator" %>
<%@ page import="com.esko.webcenter.cache.DocTypeAutoNamingCache" %>
<%@ page import="com.esko.webcenter.cache.SiteDefaultsCache"%>
<%@ page import="com.esko.webcenter.list.OutputList"%>
<%@ page import="com.esko.webcenter.list.JSONOutputList"%>
<%@ page import="com.esko.webcenter.list.ListContentCache"%>
<%@ page import="com.esko.webcenter.shared.util.Pair"%>

<%
	// === Start of the main scriplet ===
	Properties requestParams = requestParamsLoginCheck;

	// Get the request parameters
	String listName = (requestParams.containsKey("list")) ? ((String[]) requestParams.get("list"))[0] : null;
	String listType = (requestParams.containsKey("listtype")) ? ((String[]) requestParams.get("listtype"))[0] : "WCR_DB_LIST";
	String   outputType= (requestParams.containsKey("outputtype")) ? ((String[]) requestParams.get("outputtype"))[0] : OutputList.XMLOUTPUT;
	String[] input = (requestParams.containsKey("input")) ? ((String[]) requestParams.get("input")) : null;
	String[] outputparams = (requestParams.containsKey("output")) ? ((String[]) requestParams.get("output")) : null;
	String   maxRowsString= (requestParams.containsKey("maxrows")) ? ((String[]) requestParams.get("maxrows"))[0] : "-1";
	String   maxColRowsString= (requestParams.containsKey("maxcolrows")) ? ((String[]) requestParams.get("maxcolrows"))[0] : maxRowsString;
	String   indexed= (requestParams.containsKey("indexed")) ? ((String[]) requestParams.get("indexed"))[0] : "0";
	String   cache= (requestParams.containsKey("cache")) ? ((String[]) requestParams.get("cache"))[0] : "0";

	final int MAX_NR_ITEMS = 10000; // max number of items to load: 10.000 

	
	// check the supported output type 
	
	if (!OutputList.supportedOutputType( outputType))
	{
		out.write(SDKUtils.ShowError(SDKUtils.SDK_LIST_UNKNOWNOUTPUTTYPE , "The output type " + outputType + " is not supported."));
		checkLogOff(session);
		return;		
	}
	if (outputType.equalsIgnoreCase(OutputList.XMLOUTPUT)){
		response.setContentType("application/xml" );		
	}else{
		response.setContentType("application/json" );
	}
	
	
	if ((listName == null) || (listName.length() == 0)) {

		String detail = "You need to specify a value for the list parameter";
		out.write(OutputList.getErrorMessage(outputType,SDKUtils.SDK_LIST_UNKNOWNLIST, detail));
		checkLogOff(session);
		return;
	}

	if (!listType.equalsIgnoreCase("WCR_DB_LIST"))
	{
		String detail = "You need to specify a valid listtype.";
		out.write(OutputList.getErrorMessage(outputType,SDKUtils.SDK_LIST_UNKNOWNOUTPUTTYPE, detail));
		checkLogOff(session);
		return;
	}

	// auxiliary variables
	String loginID = LoginMgr.getLoginMgr(session).getLoginID();
	
	String dataXML = null; 
	

	// look up the list object and execute the query
	try{
		
		ListManagerTM listManagerTM = DBTMUtils.findBean(response, session, ListManagerTM.class);
		if (listManagerTM == null) {
			String detail = "You need to specify a valid listtype.";
			out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_UNDEF_ERROR, detail));
			checkLogOff(session);
			return;
		}
		WcList wcList = listManagerTM.getListByName(loginID, listName);
		if (wcList== null) 
		{
			String detail = "The list " + listName + " cannot be found.";
			out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_LIST_UNKNOWNLIST, detail));
			checkLogOff(session);
			return;	
		}

		// convert the input parameters to something the backend can use
		Vector<String> columns = new Vector<String>(); 
		if (outputparams != null)
			for (int i = 0 ; i < outputparams.length;i++)
				columns.addElement(outputparams[i]);
		else
			columns = wcList.getListColumns();
		
		Vector<String> allColumnsInList = wcList.getListColumns(); 
		
		
		// the input params need to be parsed. They are of the form "<input column>:0/1:<value>"
		Vector<Properties> values = new Vector<Properties>();
		
		if (input != null)
		{
			for (int i = 0; i < input.length; i++)
			{
				Properties inputParams = new Properties();
				
				String inputValue = input[i];
				String[] inputValues = inputValue.split(":");
				if ((inputValues == null) || (inputValues.length < 2))
				{
					String detail = "Wrong format of the input parameters : " + inputValue;
					out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_LIST_UNKNOWNINPUTCOL, detail));
					checkLogOff(session);
					return;	
				}
				String inputColName  = inputValues[0];
				String exactMatch    = inputValues[1]; 
				String inputColValue = inputValue.substring(inputColName.length() + exactMatch.length() + 2);
				
				// check whether the inputColName is an existing column name
				if (!allColumnsInList.contains(inputColName))
				{
					String detail = "The input parameter should contain an existing column : " + inputValue;
					out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_LIST_UNKNOWNINPUTCOL, detail));
					checkLogOff(session);
					return;	
				}	
				inputParams.put("key", inputColName);
				inputParams.put("value", inputColValue);
				inputParams.put("exact_match", inputValues[1]);
				values.add(inputParams);
			}
		}		

		StringBuffer strBuffer = new StringBuffer();
		
		int maxRows = 1;
		int maxColRows = 1;
		try
		{
			maxRows = Integer.parseInt(maxRowsString);
			if (maxRows>MAX_NR_ITEMS)
				maxRows=MAX_NR_ITEMS;
			
			maxColRows= Integer.parseInt(maxColRowsString);
			if (maxColRows>MAX_NR_ITEMS)
				maxColRows=MAX_NR_ITEMS;
		}
		catch (NumberFormatException ex) 
		{
			out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_WRONG_PARAM, "'maxrows'/'maxcolrows'  parameter has to be an integer number"));
			checkLogOff(session);
			return;	
		}
	
		if (cache.equalsIgnoreCase("1"))
		{
			try 
			{
				String requestURL = request.getQueryString();		
				dataXML = ListContentCache.get(loginID, listName, columns, values, maxRows, maxColRows, indexed, outputType,
						new ListContentCache.CacheKey(requestURL, wcList.getModTimeStamp().getTime()));
			}
			catch (ExecutionException ex)
			{
				String errorMsg = "Problem in Lists cache occured. Details: " + ex.getMessage();
				out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_UNDEF_ERROR, errorMsg));
				checkLogOff(session);
				return;	
			}
		}
		else 
		{
			if (indexed.equalsIgnoreCase("0")) 
			{	
				Pair<Integer, Vector<Properties>> data = listManagerTM.getListData(loginID, listName, columns, values, maxRows);
				dataXML = OutputList.writeListData(data,columns,outputType);
			}
			else
			{
				Pair<Integer,Properties> indexedData = listManagerTM.getListDataIndexed(loginID, listName, columns, values,maxRows,maxColRows);
				dataXML=OutputList.writeIndexedListData(indexedData, columns,outputType );
			}
		}

		out.write(dataXML);	
		checkLogOff(session);
		return;	
	}
	catch(Exception e)
	{
		try {
			out.write(OutputList.getErrorMessage(outputType, SDKUtils.SDK_UNDEF_ERROR ,e.getMessage()));
			checkLogOff(session);
			return;
		}
		catch (IOException ex)
		{
		}	
	}
%>


