define("component/message/MessageType",["underscore"],function(c){return{SUCCESS:{value:0,name:"SUCCESS"},INFO:{value:1,name:"INFO"},WARN:{value:2,name:"WARN"},ERROR:{value:3,name:"ERROR"},getTypeFromString:function(e){return c.findWhere(this,{name:e.toUpperCase()})}}});
define("component/message/Message",["underscore","component/message/MessageType"],function(c,e){var b=function(b,f,d,a,j){this._type=c.isString(b)?e.getTypeFromString(b):b;this._message=f;this._action=d;this._autoHide=a;this._tag=j};b.prototype.getType=function(){return this._type};b.prototype.getMessage=function(){return this._message};b.prototype.getAction=function(){return this._action};b.prototype.getAutoHide=function(){return this._autoHide};b.prototype.getTag=function(){return this._tag};return b});
define("component/message/MessageModel",["utils/Observable","underscore"],function(c,e){var b=function(){c.mixin(this,"message");this._messageQueue=[]};b.prototype.addToMessageQueue=function(b){this._messageQueue.push(b);this._emit("added",b)};b.prototype.getNextMessage=function(){return this._messageQueue.shift()};b.prototype.markObsolete=function(b){this._messageQueue=e.filter(this._messageQueue,function(c){return!c.getTag()||c.getTag()!==b});this._emit("obsolete",b)};return b});
define("utils/webcss-text!component/message/messagewidget-style.css",[],function(){return"/*!\r\n * Bootstrap v2.3.2\r\n *\r\n * Copyright 2013 Twitter, Inc\r\n * Licensed under the Apache License v2.0\r\n * http://www.apache.org/licenses/LICENSE-2.0\r\n *\r\n * Designed and built with all the love in the world @twitter by @mdo and @fat.\r\n * changed by esko: split off alert, close\r\n */\r\n.messageWidget .alert {\r\n\tpadding: 8px 35px 8px 14px;\r\n\tmargin-bottom: 20px;\r\n\tbackground-color: #fcf8e3;\r\n\tborder: 1px solid #fbeed5;\r\n}\r\n.messageWidget .alert,\r\n.messageWidget .alert h4 {\r\n\tcolor: #c09853;\r\n}\r\n.messageWidget .alert h4 {\r\n\tmargin: 0;\r\n}\r\n.messageWidget .alert .close {\r\n\tposition: relative;\r\n\ttop: -2px;\r\n\tright: -2px;\r\n\tline-height: 20px;\r\n}\r\n.messageWidget .alert-success {\r\n\tbackground-color: #dff0d8;\r\n\tborder-color: #d6e9c6;\r\n\tcolor: #468847;\r\n}\r\n.messageWidget .alert-success h4 {\r\n\tcolor: #468847;\r\n}\r\n.messageWidget .alert-danger,\r\n.messageWidget .alert-error {\r\n\tbackground-color: #f2dede;\r\n\tborder-color: #eed3d7;\r\n\tcolor: #b94a48;\r\n}\r\n.messageWidget .alert-danger h4,\r\n.messageWidget .alert-error h4 {\r\n\tcolor: #b94a48;\r\n}\r\n.messageWidget .alert-info {\r\n\tbackground-color: #d9edf7;\r\n\tborder-color: #bce8f1;\r\n\tcolor: #3a87ad;\r\n}\r\n.messageWidget .alert-info h4 {\r\n\tcolor: #3a87ad;\r\n}\r\n.messageWidget .alert-block {\r\n\tpadding-top: 14px;\r\n\tpadding-bottom: 14px;\r\n}\r\n.messageWidget .alert-block > p,\r\n.messageWidget .alert-block > ul {\r\n\tmargin-bottom: 0;\r\n}\r\n.messageWidget .alert-block p + p {\r\n\tmargin-top: 5px;\r\n}\r\n.messageWidget .close {\r\n\tfloat: right;\r\n\tfont-size: 20px;\r\n\tfont-weight: bold;\r\n\tline-height: 20px;\r\n\tcolor: #000000;\r\n\topacity: 0.2;\r\n\tfilter: alpha(opacity=20);\r\n}\r\n.messageWidget .close:hover,\r\n.messageWidget .close:focus {\r\n\tcolor: #000000;\r\n\ttext-decoration: none;\r\n\tcursor: pointer;\r\n\topacity: 0.4;\r\n\tfilter: alpha(opacity=40);\r\n}\r\n.messageWidget button.close {\r\n\tpadding: 0;\r\n\tcursor: pointer;\r\n\tbackground: transparent;\r\n\tborder: 0;\r\n\t-webkit-appearance: none;\r\n}\r\n.messageWidget .message-text {\r\n\twhite-space: pre-wrap;\r\n}"});
define("component/message/MessageWidget","utils/webcss!./messagewidget-style.css utils/webi18n!MessageWidget component/message/MessageType component/message/Message jquery underscore".split(" "),function(c,e,b,g,f,d){c=function(a,b){this._AUTOHIDE_DELAY=3E3;this._showing=!1;this._currentMessage=void 0;this._currentMessageObject=null;this._messageModel=a;this._context=b;this._context.addClass("messageWidget");this._messageModel.on("added",d.bind(this._showNextMessage,this));this._messageModel.on("obsolete",
d.bind(this._markObsolete,this));this._showNextMessage()};c.prototype._getCSSClass=function(a){switch(a){case b.ERROR:return"alert-danger";case b.WARN:return"";case b.INFO:return"alert-info";case b.SUCCESS:return"alert-success"}};c.prototype._showMessage=function(a){this._showing=!0;this._currentMessageObject=a;var b=f("<button />").attr("type","button").addClass("close").append(f("<i>",{"class":"icon icon-small icon-WCR_Close12"})),c=f("<strong />").append(e.t(a.getType().name)),c=f("<span />",{"class":"message-text"}).append(c).append(" "),
h=a.getAction();if(h){var i=f("<a/>").addClass("alert-link").text(a.getMessage());if("string"===typeof h)i.attr("href",h);else i.attr("href","#").on("click",d.bind(function(b){b.stopPropagation();this._destroyCurrentMessage(d.bind(function(){a.getAction()();this._showNextMessage()},this))},this));c.append(i)}else c.append(a.getMessage());this._currentMessage=f("<div />").addClass("alert").addClass(this._getCSSClass(a.getType())).append(b).append(c).hide();this._currentMessage.on("contextmenu mouseenter mouseleave mousedown click mousemove mouseup dblclick",
function(a){a.stopPropagation()});c.on("dblclick",function(a){if(document.selection){var b=document.body.createTextRange();b.moveToElementText(this);b.select()}else window.getSelection&&(b=document.createRange(),b.selectNodeContents(this),window.getSelection().removeAllRanges(),window.getSelection().addRange(b));a.stopPropagation();a.preventDefault()});var g;a.getAutoHide()&&(g=window.setTimeout(d.bind(function(){this._destroyCurrentMessage(d.bind(function(){this._showNextMessage()},this))},this),
this._AUTOHIDE_DELAY));b.on("click",d.bind(function(a){a.stopPropagation();g&&window.clearTimeout(g);this._destroyCurrentMessage(d.bind(function(){this._showNextMessage()},this))},this));this._context.empty().append(this._currentMessage);this._currentMessage.fadeIn("fast")};c.prototype._destroyCurrentMessage=function(a){this._currentMessage.fadeOut("fast",d.bind(function(){this._currentMessage.remove();this._showing=!1;a()},this))};c.prototype._showNextMessage=function(){if(!this._showing){var a=
this._messageModel.getNextMessage();a&&this._showMessage(a)}};c.prototype._isShowingMessageWithTag=function(a){return this._showing&&this._currentMessage&&this._currentMessageObject&&this._currentMessageObject.getTag()===a};c.prototype._markObsolete=function(a){this._isShowingMessageWithTag(a)&&this._destroyCurrentMessage(d.bind(function(){this._showNextMessage()},this))};c.prototype.getContext=function(){return this._context};return c});
define("component/message/MessageComponent",["component/message/Message","component/message/MessageType","component/message/MessageModel","component/message/MessageWidget"],function(c,e,b,g){return{Message:c,MessageType:e,MessageModel:b,MessageWidget:g}});
define("component/savedsearchdialog/ProjectSavedSearchDialog",["component/smartnames/savedsearchcontext/SavedSearchContextInfo","component/savedsearchdialog/SavedSearchDialog","component/pagemessagecomponent/PageMessageComponent","utils/webi18n!SavedSearchDialog","jquery"],function(c,e,b,g,f){var d=function(a){e.call(this,a);this._savedSearchContext=new c;this._savedSearchContext.setProjectId(this._currentProjectID);this._dialogTitle=g.t("SEARCH_PROJECT");this._childAlreadyExisted=this._newProjectMessage=
"";if(a.getAttribute("LinkInExisting")){var b=this;this._buttonObj[g.t("LINK")]=function(){var a=f("[name='selectproject']:checked"),c=window.webcenterConfig.jspBaseUrl+"UpdateProjectRelation.jsp?projectid="+b._currentProjectID+"&action=add";if(0===a.size())window.alert(b._noProjectsSelected);else{for(var d=0;d<a.size();d++)var e=a[d].getAttribute("projectid"),c=c+("&childprojectid="+e);f.ajax({url:c,type:"POST",data:"text",contentType:"application/x-www-form-urlencoded",synchronous:!1,timeout:3E4,
success:function(a){b.onProjectLinkSuccess(a)},error:function(){window.console.error("An error occurred when trying to link a child project")},objHdl:this})}}}};d.prototype.constructor=d;d.prototype=Object.create(e.prototype);d.wcrinit=function(a){a.ProjectSavedSearchDialog=new d(a)};d.prototype.onProjectLinkSuccess=function(a){a=f(a);if(0<a.find("error").length)b.markObsolete("programManagementError"),b.sendErrorMessage(a.find("message").text(),void 0,"programManagementError");else{var a=a.find("project_new_relations").find("child_project_list").find("name"),
c;if(0!==a.length){c=this._newChildMessage;for(var d=0;d<a.length;d++)c+=' "'+f(a[d]).text()+'"'}else c=this._childAlreadyExisted;b.markObsolete("programManagementError");b.sendSuccessMessage(c,void 0,!0)}this.popup.close()};d.prototype.setNewChildrenAddedMessage=function(a){this._newChildMessage=a};d.prototype.getNewChildrenMessage=function(){return this._newChildMessage};d.prototype.setChildrenAlreadyExistedMessage=function(a){this._childAlreadyExisted=a};d.prototype.getChildrenAlreadyExistedMessage=
function(){return this._childAlreadyExisted};d.prototype.setNoProjectsSelectedMessage=function(a){this._noProjectsSelected=a};d.prototype.getNoProjectsSelectedMessage=function(){return this._noProjectsSelected};return d});