define("pages/rules/Rule",["underscore","utils/Observable"],function(d,b){var a=function(a,c,d,f,g,i,k){b.mixin(this,"rule");this._id=a;this._name=c;this._description=d;this._order=f;this._triggers=i||[];this._actions=k||[];this._enabled=g};a.prototype.getID=function(){return this._id};a.prototype.getName=function(){return this._name};a.prototype.setName=function(a){this._name=a};a.prototype.getDescription=function(){return this._description};a.prototype.setDescription=function(a){this._description=
a};a.prototype.getOrder=function(){return this._order};a.prototype.setOrder=function(a){this._order=a};a.prototype.isEnabled=function(){return this._enabled};a.prototype.setEnabled=function(a){this._enabled=a};a.prototype.getTriggers=function(){return this._triggers};a.prototype.addTrigger=function(a,c){void 0===c&&(c=this._triggers.length);this._triggers.splice(c,0,a);this._emit("trigger.added",a,c)};a.prototype.removeTrigger=function(a){var c=d.indexOf(this._triggers,a);0<=c&&(this._triggers.splice(c,
1),this._emit("trigger.removed",a,c));return c};a.prototype.replaceTrigger=function(a,c){var b=this.removeTrigger(a);this.addTrigger(c,b)};a.prototype.getActions=function(){return this._actions};a.prototype.addAction=function(a,c){void 0===c&&(c=this._actions.length);this._actions.splice(c,0,a);this._emit("action.added",a,c)};a.prototype.removeAction=function(a){var c=d.indexOf(this._actions,a);0<=c&&(this._actions.splice(c,1),this._emit("action.removed",a,c));return c};a.prototype.replaceAction=
function(a,c){var b=this.removeAction(a);this.addAction(c,b)};a.prototype.copy=function(){var b=[],c=[];d.each(this._triggers,function(a){b.push(a.copy())});d.each(this._actions,function(a){c.push(a.copy())});return new a(this._id,this._name,this._description,this._order,this._enabled,b,c)};return a});define("pages/rules/RuleAction",["underscore"],function(){var d=function(b){this.type=b};d.prototype.getType=function(){return this.type};d.prototype.copy=function(){return new d(this.type)};return d});
define("pages/rules/RuleConstants",{TriggerType:{PROJECTATTRIBUTE:"ProjectAttribute",PROJECTSTATUS:"ProjectStatus",PROJECTDUEDATE:"ProjectDueDate"},ActionType:{STARTTASK:"StartTask"}});
define("pages/rules/RuleActionStartTask",["./RuleAction","./RuleConstants","underscore"],function(d,b){var a=function(){d.call(this,b.ActionType.STARTTASK);this.taskTypeID=null};a.prototype=Object.create(d.prototype);a.prototype.constructor=a;a.prototype.getTaskTypeID=function(){return this.taskTypeID};a.prototype.setTaskTypeID=function(a){this.taskTypeID=a};a.prototype.copy=function(){var b=new a;b.setTaskTypeID(this.getTaskTypeID());return b};return a});
define("pages/rules/RuleTrigger",[],function(){var d=function(b){this.type=b};d.prototype.getType=function(){return this.type};d.prototype.copy=function(){return new d(this.type)};return d});
define("pages/rules/RuleTriggerProjectAttribute",["./RuleTrigger","./RuleConstants","underscore"],function(d,b){var a=function(){d.call(this,b.TriggerType.PROJECTATTRIBUTE);this.attributeID=null};a.prototype=Object.create(d.prototype);a.prototype.constructor=a;a.prototype.getAttributeID=function(){return this.attributeID};a.prototype.setAttributeID=function(a){this.attributeID=a};a.prototype.copy=function(){var b=new a;b.setAttributeID(this.getAttributeID());return b};return a});
define("pages/rules/RuleFactory",["./RuleConstants","./RuleTriggerProjectAttribute","./RuleTrigger","./RuleActionStartTask","underscore"],function(d,b,a,e){var c=function(){};c.prototype.createTrigger=function(c){switch(c){case d.TriggerType.PROJECTATTRIBUTE:return new b;case d.TriggerType.PROJECTDUEDATE:case d.TriggerType.PROJECTSTATUS:return new a(c)}};c.prototype.createAction=function(a){switch(a){case d.ActionType.STARTTASK:return new e}};return c});
define("pages/rules/RuleActionView",["./RuleFactory","./RuleConstants","utils/webi18n!RulesTable","underscore"],function(d,b,a,e){var c=function(c,f){this._rule=f;this._enabled=!0;this._action=c;this._ruleFactory=new d;this._element=$("<div>").addClass("row ruleActionView");this._selectorWrapper=$("<div>").addClass("col-md-5 select");this._selector=$("<select>").addClass("form-control");e.each(b.ActionType,function(c){var b=$("<option>",{value:c}).text(a.t(("RULE_ACTION_"+c).toUpperCase()));c===this._action.getType()&&
b.prop("selected",!0);this._selector.append(b)},this);this._selector.on("change",e.bind(function(){this._changeActionType()},this));this._selectorWrapper.append(this._selector);this._removeButton=$("<div>").addClass("col-md-1 remove").append($("<i>").addClass("icon icon-normal icon-WCR_Filter-Remove12").click(e.bind(function(){this._removeAction()},this)));this._element.append(this._removeButton).append(this._selectorWrapper)};c.prototype._changeActionType=function(){var a=this._ruleFactory.createAction(this._selector.val());
this._rule.replaceAction(this._action,a)};c.prototype._removeAction=function(){this._rule.removeAction(this._action)};c.prototype.getElement=function(){return this._element};c.prototype.destroy=function(){};c.prototype.setEnabled=function(a){this._enabled=a;this._updateEnabled()};c.prototype._updateEnabled=function(){this._removeButton.toggle(this._enabled);this._selector.prop("disabled",!this._enabled)};c.prototype.validate=function(){return!0};return c});
define("webcenterapi/AbstractAPI",["utils/HTTPUtils","underscore","jquery"],function(d,b,a){var e=function(a,b){this._wcrConfig=a;this._errorHandler=b};e.prototype.getWebCenterConfig=function(){return this._wcrConfig};e.prototype.constructURL=function(a,b){return d.constructURL(a,b,this._wcrConfig.jspBaseUrl)};e.prototype.callSDK=function(c,d,f){var g=a.Deferred(),f=b.extend({dataType:"xml",cache:!1,type:"GET",data:""},f);a.ajax(this.constructURL(c,d),{dataType:f.dataType,cache:f.cache,type:f.type,
data:f.data}).done(function(a,c,b){if("xml"===f.dataType&&(!a||!a.documentElement||"error"===a.documentElement.tagName.toLowerCase())){var c="",d=a.documentElement.getElementsByTagName("message")[0];d&&(c=d.textContent);var d=a.documentElement.getElementsByTagName("code")[0],e;d&&(e=d.textContent,c+=" ("+e+")");g.reject(b,"error",c,e,a)}else a&&a.error?(c="",(d=a.error.msg)&&(c=d),(e=a.error.addonMsg)&&(c+=" "+e),g.reject(b,"error",c,a)):g.resolve(a,c,b)}).fail(function(a,c,b){g.reject(a,c,b)});return g.promise()};
return e});
define("WFEditorWCR/core/WebCenterWFEditorConstants",{FeedbackUpdateInterval:2E4,WorkflowControlActions:{HOLD:2,RESUME:3,CANCEL:1},WorkflowControlToolbar:"workflowControlActions",WorkflowControlActionButtons:{HOLD:"holdWorkflowAction",RESUME:"resumeWorkflowAction",CANCEL:"cancelWorkflowAction"},WorkflowStatusToolbar:"workflowStatusToolbar",WorkflowErrorStatus:"00001_0000000004",WorkflowErrorImage:"Canceled_pink.png",WorkflowCanceledStatus:"00001_0000000005",WorkflowCanceledImage:"wf_cancelled.gif",WorkflowActionsToolbar:"wcrActions",
WorkflowSaveToolbarButton:"wcrSaveAction",WorkflowImportToolbarButton:"wcrImportAction",WorkflowExportToolbarButton:"wcrExportAction",WorkflowClearToolbarButton:"wcrClearAction",TaskNameToolbarComponent:"wcrTaskName",WorkflowWFModesToolbar:"wcrWFModesToolbar",WorkflowFullScreenToolbarButton:"wcrFullScreenAction",WorkflowHighlightActiveToolbarButton:"wcrHighlightActiveAction",WorkflowTaskDefaultIcon:"workflow/images/hand.png",WorkflowWorldBounds:{x:0,y:0,width:16384,height:16384}});
define("webcenterapi/data/WebCenterTaskType",["utils/XMLUtils","WFEditorWCR/core/WebCenterWFEditorConstants"],function(d,b){var a=function(a,c,b,d,g,i,k,v,w){this._taskTypeID=a;this._name=c;this._description=b;this._creatorID=d;this._leadDays=g;this._leadTime=i;this._hasWorkflow=k;this._icon=v;this._restrictedAssignee=w};a.prototype.getId=function(){return this._taskTypeID};a.prototype.getName=function(){return this._name};a.prototype.getDescription=function(){return this._description};a.prototype.getLeadDays=
function(){return this._leadDays};a.prototype.getLeadTime=function(){return this._leadTime};a.prototype.getIcon=function(){return this._icon||b.WorkflowTaskDefaultIcon};a.prototype.getRestrictedAssignee=function(){return this._restrictedAssignee};a.prototype.hasWorkflow=function(){return"1"==this._hasWorkflow};a.fromXML=function(b){var c=b.getAttribute("id"),d=b.getElementsByTagName("task_type_name")[0],f=b.getElementsByTagName("description")[0],g=b.getElementsByTagName("creator_id")[0],i=b.getElementsByTagName("approximate_length")[0],
k=b.getElementsByTagName("approximate_time")[0],v=b.getElementsByTagName("has_workflow")[0],w=b.getElementsByTagName("icon")[0],x,r=b.getElementsByTagName("restrict_assignees");r&&(r[0]&&"1"===r[0].textContent)&&(x=(b=b.getElementsByTagName("main_assignee_id"))&&b[0]?{restriction:"roleOrGroup",id:b[0].textContent}:{restriction:"noUser"});if(c&&d&&f&&g&&i&&k&&v&&w)return new a(c,d.textContent,f.textContent,g.textContent,i.textContent,k.textContent,v.textContent,w.textContent,x)};return a});
define("webcenterapi/TaskTypeAPI","./AbstractAPI ./data/WebCenterTaskType utils/Map utils/webi18n!WebCenterAPI underscore jquery".split(" "),function(d,b,a,e,c,h){var f=function(a,b){d.call(this,a,b);this._deferredTaskTypesPromise=this._tasktypeDefinitionPromise=null};f.prototype=Object.create(d.prototype);f.prototype.constructor=f;f.prototype.getTaskTypeDefinitions=function(){this._tasktypeDefinitionPromise||(this._tasktypeDefinitionPromise=this.callSDK("GetTaskTypes.jsp",{verbose:"0",loadicons:"1",
ajax:"1"},{cache:!0}).fail(c.bind(function(a,b,c){this._errorHandler.severe(e.t("LoadTaskTypesFailed")+" ("+c+")",a,b,c)},this)));return this._tasktypeDefinitionPromise};f.prototype.getTaskTypes=function(){if(!this._deferredTaskTypesPromise){var d=h.Deferred();this._deferredTaskTypesPromise=d.promise();h.when(this.getTaskTypeDefinitions()).done(function(c){for(var k=new a,c=c.getElementsByTagName("wctask_type"),f=0;f<c.length;f++){var e=c.item(f);(e=b.fromXML(e))&&k.add(e.getId(),e)}d.resolve(k)}).fail(c.bind(function(a,
c,b){d.reject(a,c,e.t("LoadTaskTypesFailed")+" ("+b+")")},this))}return this._deferredTaskTypesPromise};return f});
define("component/sdrop/dataproviders/MapPromiseDataProvider",["underscore","lib/PromisePolyfill","wcr/sdrop"],function(d){return new Class({Extends:SDropDataProvider,options:{nameGetter:"getName",entityLabel:"element",sortMethod:function(b,a){return b.name.toLowerCase()<a.name.toLowerCase()?-1:b.name.toLowerCase()>a.name.toLowerCase()?1:0},promise:null},initialize:function(b){this.parent(b);this.options.promise=Promise.resolve(b.promise)},reset:function(){this.flushDataStore(this.options.datastoreCapacity)},
setData:function(b){b=d.map(b.asObject(),function(a,b){return{id:b,name:a[this.options.nameGetter](),item:a}},this);this.addToStore(b)},loadByID:function(b,a){a&&a.dataproviderIsLoading();var e=this.registerPattern("###BYID###"+b+"####");e.loading=!0;this.options.promise.then(d.bind(function(c){e.loading=!1;(c=c.get(b))?(this.flushDataStore(1,e),this._addToStore([{id:b,name:c[this.options.nameGetter](),item:c}]),e.truncatedResults=!1,a&&a.dataproviderLoadCompleted()):a&&a.dataproviderLoadFailed("Could not find "+
this.options.entityLabel+": "+b)},this)).catch(d.bind(function(){a&&a.dataproviderLoadFailed("Could not find  "+this.options.entityLabel+": "+b)},this))},load:function(b,a){a&&a.dataproviderIsLoading();if(!this.isPatternLoaded(b,a)){var e=this.registerPattern(b);e.loading=!0;a&&(e.delegates=[a]);this.options.promise.then(d.bind(function(a){var b=[],f=!1;d.each(a.asObject(),function(a,c){if(!f){var d=a[this.options.nameGetter]();e.regex.test(d)&&(b.length<this.options.truncate?b.push({id:c,name:d,
item:a}):f=!0)}},this);this.flushDataStore(b.length,e);this._addToStore(b);e.loaded=!0;e.truncatedResults=f;this.setPatternLoadCompleted(e)},this)).catch(d.bind(function(){this.loadFailed(e,"Error while loading data")},this))}},getData:function(b){return this.datastore.filter(function(a){return this.regex.test(a.name)},this.registerPattern(b)).sort(this.options.sortMethod)}})});
define("pages/rules/RuleActionStartTaskView","./RuleActionView webcenterapi/TaskTypeAPI component/errorhandler/ErrorHandler component/sdrop/dataproviders/MapPromiseDataProvider component/sdrop/SDrop underscore jquery utils/webi18n!RulesTable".split(" "),function(d,b,a,e,c,h,f,g){var a=new a,i=new b(window.webcenterConfig,a),b=function(a,b){d.call(this,a,b);this._taskTypeSelectWrapper=f("<div>").addClass("col-sm-6");this._taskTypeSelect=f("<select />");this._taskTypeSelectWrapper.append(this._taskTypeSelect);
this._selectorWrapper.after(this._taskTypeSelectWrapper);this._taskTypesPromise=i.getTaskTypes();this._dataProvider=new e({promise:this._taskTypesPromise});this._options={autoload:!1,autoloadOnFirstUsage:!0,manageStyleAndWidth:!1,onChangedByUser:h.bind(this._taskTypeSelected,this)};this._taskTypesPromise.done(h.bind(function(a){var b=this._action.getTaskTypeID();b&&a.has(b)?this._options.initialValue=b:b&&this._action.setTaskTypeID(null);this._sDrop=new c(this._taskTypeSelect,"",this._dataProvider,
this._options);this._updateEnabled()},this)).fail(h.bind(function(a,b,c){this._taskTypeSelectWrapper.empty().text(c)},this))};b.prototype=Object.create(d.prototype);b.prototype.constructor=b;b.prototype._taskTypeSelected=function(){var a=this._taskTypeSelect.val();(a=this._sDrop.dataProvider.getById(a))&&a.item&&this._action.setTaskTypeID(a.item.getId())};b.prototype._updateEnabled=function(){d.prototype._updateEnabled.call(this);this._sDrop&&!this._enabled&&this._sDrop.setDisabled(!0)};b.prototype.destroy=
function(){d.prototype.destroy.call(this);this._sDrop&&this._sDrop.destroy()};b.prototype.validate=function(){return!this._action.getTaskTypeID()?(window.alert(g.t("RULE_ACTION_STARTTASK_REQUIRED")),!1):d.prototype.validate.call(this)};return b});
define("pages/rules/RuleTriggerView",["./RuleFactory","./RuleConstants","utils/webi18n!RulesTable","underscore"],function(d,b,a,e){var c=function(c,f){this._rule=f;this._enabled=!0;this._trigger=c;this._ruleFactory=new d;this._element=$("<div>").addClass("row ruleTriggerView");this._selectorWrapper=$("<div>").addClass("col-md-5 select");this._selector=$("<select>").addClass("form-control");e.each(b.TriggerType,function(b){var c=$("<option>",{value:b}).text(a.t(("RULE_TRIGGER_"+b).toUpperCase()));
b===this._trigger.getType()&&c.prop("selected",!0);this._selector.append(c)},this);this._selector.on("change",e.bind(function(){this._changeTriggerType()},this));this._selectorWrapper.append(this._selector);this._removeButton=$("<div>").addClass("col-md-1 remove").append($("<i>").addClass("icon icon-normal icon-WCR_Filter-Remove12").click(e.bind(function(){this._removeTrigger()},this)));this._element.append(this._removeButton).append(this._selectorWrapper)};c.prototype._changeTriggerType=function(){var a=
this._ruleFactory.createTrigger(this._selector.val());this._rule.replaceTrigger(this._trigger,a)};c.prototype._removeTrigger=function(){this._rule.removeTrigger(this._trigger)};c.prototype.getElement=function(){return this._element};c.prototype.destroy=function(){};c.prototype.setEnabled=function(a){this._enabled=a;this._updateEnabled()};c.prototype._updateEnabled=function(){this._removeButton.toggle(this._enabled);this._selector.prop("disabled",!this._enabled)};c.prototype.validate=function(){return!0};
return c});define("webcenterapi/data/WebCenterAttribute",[],function(){var d=function(b,a,d,c){this._id=b;this._name=a;this._unit=d;this._restrictedSet=c};d.prototype.getId=function(){return this._id};d.prototype.getName=function(){return this._name};d.prototype.getType=function(){return this._unit};d.prototype.getRestrictedSet=function(){return this._restrictedSet};d.prototype.isDocRef=function(){return this._unit?this._unit.isDocRef():!1};return d});
define("webcenterapi/data/WebCenterAttributeUnit",[],function(){var d=function(b,a,d){this._id=b;this._name=a;this._type=d};d.prototype.getId=function(){return this._id};d.prototype.getName=function(){return this._name};d.prototype.getType=function(){return this._type};d.prototype.isDocRef=function(){return"00001_0000000022"===this._id};d.prototype.isDateTime=function(){return"00001_0000000020"===this._id};return d});
define("webcenterapi/data/WebCenterRestrictedSet",[],function(){var d=function(b,a,d,c){this._id=b;this._name=a;this._unit=d;this._values=c};d.prototype.getId=function(){return this._id};d.prototype.getName=function(){return this._name};d.prototype.getType=function(){return this._unit};d.prototype.getValues=function(){return this._values};return d});
define("webcenterapi/data/WebCenterRestrictedSetValue",[],function(){var d=function(b,a){this._id=b;this._value=a};d.prototype.getId=function(){return this._id};d.prototype.getValue=function(){return this._value};return d});
define("webcenterapi/AttributesAPI","./AbstractAPI ./data/WebCenterAttribute ./data/WebCenterAttributeUnit ./data/WebCenterRestrictedSet ./data/WebCenterRestrictedSetValue utils/Map utils/webi18n!WebCenterAPI underscore jquery".split(" "),function(d,b,a,e,c,h,f,g,i){var k=function(a,b){d.call(this,a,b);this._specificationPromise=this._deferredSpecificationsPromise=this._attributesPromise=this._deferredAttributesPromise=null};k.prototype=Object.create(d.prototype);k.prototype.constructor=k;k.prototype.getAttributes=
function(){if(!this._deferredAttributesPromise){var a=i.Deferred();this._deferredAttributesPromise=a.promise();this._attributesPromise||(this._attributesPromise=this.callSDK("GetAttributeListXML.jsp",{},{cache:!0}).fail(g.bind(function(b,c,d){this._errorHandler.severe(f.t("LoadAttributesFailed")+" ("+d+")",b,c,d);a.reject(b,c,f.t("LoadAttributesFailed")+" ("+d+")")},this)));i.when(this._attributesPromise).done(g.partial(this._createAttributesMap,a))}return this._deferredAttributesPromise};k.prototype.getSpecifications=
function(){if(!this._deferredSpecificationsPromise){var a=i.Deferred();this._deferredSpecificationsPromise=a.promise();this._specificationPromise||(this._specificationPromise=this.callSDK("GetAttributeListXML.jsp",{type:"task"},{cache:!0}).fail(g.bind(function(b,c,d){this._errorHandler.severe(f.t("LoadAttributesFailed")+" ("+d+")",b,c,d);a.reject()},this)));i.when(this._specificationPromise).done(g.partial(this._createAttributesMap,a))}return this._deferredSpecificationsPromise};k.prototype._createAttributesMap=
function(d,f){var k=new h,g=new h,i=new h;if(f&&f.documentElement){for(var t=f.documentElement,m=t.getElementsByTagName("attribute_unit"),n,s,l=0;l<m.length;l++){var j=m.item(l);n=j.getAttribute("id");s=j.getElementsByTagName("name")[0];j=j.getElementsByTagName("type")[0];n&&(s&&j)&&k.add(n,new a(n,s.textContent,j.textContent))}for(var p,j=t.getElementsByTagName("restricted_set"),l=0;l<j.length;l++)if(p=j.item(l),n=p.getAttribute("id"),s=p.getElementsByTagName("name")[0],m=p.getElementsByTagName("attribute_unit_id")[0],
n&&s&&m){m=k.get(m.textContent);p=p.getElementsByTagName("restricted_set_value");for(var q=[],u=0;u<p.length;u++){var z=p.item(u),A=z.getAttribute("id"),z=z.getElementsByTagName("value")[0];A&&z&&q.push(new c(A,z.textContent))}g.add(n,new e(n,s.textContent,m,q))}t=t.getElementsByTagName("attribute");for(l=0;l<t.length;l++)j=t.item(l),n=j.getAttribute("id"),s=j.getElementsByTagName("name")[0],m=j.getElementsByTagName("attribute_unit_id")[0],j=j.getElementsByTagName("restricted_set_id")[0],n&&(s&&m)&&
(m=k.get(m.textContent),p=j?g.get(j.textContent):void 0,i.add(n,new b(n,s.textContent,m,p)))}d.resolve(i)};k.prototype.getDocRefAttributes=function(){var a=i.Deferred();this.getAttributes().done(function(b){var c=new h;g.each(b.asObject(),function(a,b){a.isDocRef()&&c.add(b,a)});a.resolve(c)}).fail(function(){a.reject()});return a.promise()};return k});
define("pages/rules/RuleTriggerProjectAttributeView","./RuleTriggerView webcenterapi/AttributesAPI component/errorhandler/ErrorHandler component/sdrop/dataproviders/MapPromiseDataProvider component/sdrop/SDrop underscore jquery utils/webi18n!RulesTable".split(" "),function(d,b,a,e,c,h,f,g){var a=new a,i=new b(window.webcenterConfig,a),b=function(a,b){d.call(this,a,b);this._attributeSelectWrapper=f("<div>").addClass("col-sm-6");this._attributeSelect=f("<select />");this._attributeSelectWrapper.append(this._attributeSelect);
this._selectorWrapper.after(this._attributeSelectWrapper);this._attributesPromise=i.getAttributes();this._dataProvider=new e({promise:this._attributesPromise});this._options={enableEmptySelection:!1,manageStyleAndWidth:!1,onChangedByUser:h.bind(this._attributeSelected,this)};this._attributesPromise.done(h.bind(function(a){var b=this._trigger.getAttributeID();b&&a.has(b)?this._options.initialValue=b:b&&this._trigger.setAttributeID(null);this._sDrop=new c(this._attributeSelect,"",this._dataProvider,
this._options);this._updateEnabled()},this)).fail(h.bind(function(a,b,c){this._attributeSelectWrapper.empty().text(c)},this))};b.prototype=Object.create(d.prototype);b.prototype.constructor=b;b.prototype._attributeSelected=function(){var a=this._attributeSelect.val();(a=this._sDrop.dataProvider.getById(a))&&a.item&&this._trigger.setAttributeID(a.item.getId())};b.prototype._updateEnabled=function(){d.prototype._updateEnabled.call(this);this._sDrop&&!this._enabled&&this._sDrop.setDisabled(!0)};b.prototype.destroy=
function(){d.prototype.destroy.call(this);this._sDrop&&this._sDrop.destroy()};b.prototype.validate=function(){return!this._trigger.getAttributeID()?(window.alert(g.t("RULE_TRIGGER_PROJECTATTRIBUTE_REQUIRED")),!1):d.prototype.validate.call(this)};return b});
define("pages/rules/RuleViewFactory",["./RuleConstants","./RuleTriggerView","./RuleTriggerProjectAttributeView","./RuleActionStartTaskView"],function(d,b,a,e){var c=function(){};c.prototype.createTriggerViewFor=function(c,f){switch(c.getType()){case d.TriggerType.PROJECTATTRIBUTE:return new a(c,f);case d.TriggerType.PROJECTDUEDATE:case d.TriggerType.PROJECTSTATUS:return new b(c,f)}};c.prototype.createActionViewFor=function(a,b){switch(a.getType()){case d.ActionType.STARTTASK:return new e(a,b)}};return c});
define("pages/rules/RuleActionsView","./RuleFactory ./RuleViewFactory ./RuleConstants utils/webi18n!RulesTable utils/Observer underscore jquery".split(" "),function(d,b,a,e,c,h,f){var g=function(a){c.mixin(this);this._rule=a;this._enabled=!0;this._ruleFactory=new d;this._ruleViewFactory=new b;this._element=f("<div>").addClass("form-entry ruleActions");this._addButton=f("<div>").addClass("form-group triggerAdd").append(f("<a>").addClass("AddBtn btn btn-sm btn-primary").append(f("<i>").addClass("icon icon-WCR_Actions-Add icon-small"))).click(h.bind(function(){this._addAction()},
this));this._actionViewsElement=f("<div>").addClass("form-group ruleActionViews");this._element.append(this._actionViewsElement);this._element.append(this._addButton);this._observe(a,"action.added",this._actionAdded);this._observe(a,"action.removed",this._actionRemoved);this._actionViews=[];0<h.size(this._rule.getActions())?h.each(this._rule.getActions(),function(a,b){this._actionAdded(a,b)},this):this._addAction()};g.prototype.getElement=function(){return this._element};g.prototype.destroy=function(){h.each(this._actionViews,
function(a){a.destroy()})};g.prototype.setEnabled=function(a){this._enabled=a;this._updateEnabled()};g.prototype._updateEnabled=function(){this._addButton.toggle(this._enabled);h.each(this._actionViews,function(a){return a.setEnabled(this._enabled)},this)};g.prototype._actionAdded=function(a,b){var c=this._ruleViewFactory.createActionViewFor(a,this._rule);this._actionViews.splice(b,0,c);0===b?this._actionViewsElement.prepend(c.getElement()):this._actionViewsElement.children().eq(b-1).after(c.getElement())};
g.prototype._actionRemoved=function(a,b){var c=this._actionViews[b];c&&(c.destroy(),c.getElement().remove());this._actionViews.splice(b,1)};g.prototype._addAction=function(){this._rule.addAction(this._ruleFactory.createAction(a.ActionType.STARTTASK))};g.prototype.validate=function(){return 0>=h.size(this._rule.getActions())?(window.alert(e.t("RULEACTIONREQUIRED")),!1):h.every(this._actionViews,function(a){return a.validate()})};return g});
define("pages/rules/RuleTriggersView","./RuleFactory ./RuleViewFactory ./RuleConstants utils/webi18n!RulesTable utils/Observer underscore jquery".split(" "),function(d,b,a,e,c,h,f){var g=function(a){c.mixin(this);this._rule=a;this._enabled=!0;this._ruleFactory=new d;this._ruleViewFactory=new b;this._element=f("<div>").addClass("form-entry ruleTriggers");this._addButton=f("<div>").addClass("form-group triggerAdd").append(f("<a>").addClass("AddBtn btn btn-sm btn-primary").append(f("<i>").addClass("icon icon-WCR_Actions-Add icon-small")).click(h.bind(function(){this._addTrigger()},
this)));this._triggerViewsElement=f("<div>").addClass("form-group ruleTriggerViews");this._element.append(this._triggerViewsElement);this._element.append(this._addButton);this._observe(a,"trigger.added",this._triggerAdded);this._observe(a,"trigger.removed",this._triggerRemoved);this._triggerViews=[];0<h.size(this._rule.getTriggers())?h.each(this._rule.getTriggers(),function(a,b){this._triggerAdded(a,b)},this):this._addTrigger()};g.prototype.getElement=function(){return this._element};g.prototype.destroy=
function(){h.each(this._triggerViews,function(a){a.destroy()})};g.prototype.setEnabled=function(a){this._enabled=a;this._updateEnabled()};g.prototype._updateEnabled=function(){this._addButton.toggle(this._enabled);h.each(this._triggerViews,function(a){return a.setEnabled(this._enabled)},this)};g.prototype._triggerAdded=function(a,b){var c=this._ruleViewFactory.createTriggerViewFor(a,this._rule);this._triggerViews.splice(b,0,c);0===b?this._triggerViewsElement.prepend(c.getElement()):this._triggerViewsElement.children().eq(b-
1).after(c.getElement())};g.prototype._triggerRemoved=function(a,b){var c=this._triggerViews[b];c&&(c.destroy(),c.getElement().remove());this._triggerViews.splice(b,1)};g.prototype._addTrigger=function(){this._rule.addTrigger(this._ruleFactory.createTrigger(a.TriggerType.PROJECTATTRIBUTE))};g.prototype.validate=function(){return 0>=h.size(this._rule.getTriggers())?(window.alert(e.t("RULETRIGGERREQUIRED")),!1):h.every(this._triggerViews,function(a){return a.validate()})};return g});
define("utils/webcss-text!pages/rules/ruleview-style.css",[],function(){return'.rule fieldset {\r\n\tborder: 1px solid #ddd;\r\n\tpadding: 0 15px;\r\n\tmargin: 10px 0 15px 0;\r\n}\r\n.rule legend {\r\n\tpadding: 0 5px 0 5px;\r\n\twidth: auto;\r\n\tmargin: 0;\r\n\tmargin-bottom: 13px;\r\n\tborder: 0;\r\n\tfont-size: 11px;\r\n}\r\n.rule .ruleTriggerView,\r\n.rule .ruleActionView {\r\n\tmargin-bottom: 5px;\r\n}\r\n.rule .remove {\r\n\theight: 26px;\r\n\tline-height: 26px;\r\n}\r\n.rule label.form-required:after {\r\n  content: "*";\r\n  color: #d9534f;\r\n  margin-left: 2px;\r\n}\r\n.rule textarea {\r\n  resize: vertical; \r\n}\r\n.loadingIndicator .wcr-loadingIndicator {\r\n\tposition: relative;\r\n}'});
define("pages/rules/RuleView","./RuleTriggersView ./RuleActionsView utils/webi18n!RulesTable underscore jquery utils/webcss!./ruleview-style.css".split(" "),function(d,b,a,e,c){var h=function(f){this._rule=f;this._enabled=!0;this._element=c("<div>").addClass("container-fluid rule");this._ruleName=c("<div>").addClass("form-group");this._ruleNameInput=c("<input>",{type:"text","class":"form-control",name:"ruleName",maxlength:"256",value:this._rule.getName()}).on("change",e.bind(function(a){this._rule.setName(c(a.target).val())},
this));this._ruleNameLabel=c("<label>",{"for":"ruleName","class":"form-required"}).text(a.t("RULENAME"));this._ruleName.append(this._ruleNameLabel).append(c("<div>").addClass("form-entry").append(this._ruleNameInput));this._ruleDescription=c("<div>").addClass("form-group");this._ruleDescriptionInput=c("<textarea>",{cols:"75",rows:"3","class":"form-control",name:"ruleDescription",maxlength:256,value:this._rule.getDescription()}).on("change",e.bind(function(a){this._rule.setDescription(c(a.target).val())},
this));this._ruleDescriptionLabel=c("<label>",{"for":"ruleDescription"}).text(a.t("RULEDESCRIPTION"));this._ruleDescription.append(this._ruleDescriptionLabel).append(c("<div>").addClass("form-entry").append(this._ruleDescriptionInput));this._ruleOrder=c("<div>").addClass("form-group");this._ruleOrderInput=c("<input>",{type:"text","class":"form-control",name:"ruleOrder",value:this._rule.getOrder()}).attr("size","3").on("change",e.bind(function(a){this._rule.setOrder(c(a.target).val())},this));this._ruleOrderLabel=
c("<label>",{"for":"ruleOrder"}).text(a.t("RULEORDER"));this._ruleOrder.append(this._ruleOrderLabel).append(c("<div>").addClass("form-entry").append(this._ruleOrderInput));this._ruleEnabled=c("<div>").addClass("form-group");this._ruleEnabledInput=c("<input>",{type:"checkbox",name:"ruleEnabled"}).prop("checked",this._rule.isEnabled()).on("change",e.bind(function(a){this._rule.setEnabled(c(a.target).prop("checked"))},this));this._ruleEnabledLabel=c("<label>",{"for":"ruleEnabled"}).text(a.t("RULEENABLED"));
this._ruleEnabled.append(this._ruleEnabledLabel).append(c("<div>").addClass("form-entry").append(this._ruleEnabledInput));this._ruleTriggersWrapper=c("<div>").addClass("form-group");this._ruleTriggers=c("<fieldset>");this._ruleTriggersWrapper.append(this._ruleTriggers);this._ruleTriggersView=new d(this._rule);this._ruleTriggersLabel=c("<legend>").text(a.t("RULETRIGGERS"));this._ruleTriggers.append(this._ruleTriggersLabel).append(this._ruleTriggersView.getElement());this._ruleActionsWrapper=c("<div>").addClass("form-group");
this._ruleActions=c("<fieldset>");this._ruleActionsWrapper.append(this._ruleActions);this._ruleActionsView=new b(this._rule);this._ruleActionsLabel=c("<legend>").text(a.t("RULEACTIONS"));this._ruleActions.append(this._ruleActionsLabel).append(this._ruleActionsView.getElement());this._element.append(this._ruleName).append(this._ruleEnabled).append(this._ruleDescription).append(this._ruleOrder).append(this._ruleTriggersWrapper).append(this._ruleActionsWrapper)};h.prototype.getRule=function(){return this._rule};
h.prototype.getElement=function(){return this._element};h.prototype.destroy=function(){this._ruleTriggersView.destroy();this._ruleActionsView.destroy()};h.prototype.setEnabled=function(a){this._enabled=a;this._updateEnabled()};h.prototype._updateEnabled=function(){this._ruleNameInput.prop("disabled",!this._enabled);this._ruleDescriptionInput.prop("disabled",!this._enabled);this._ruleOrderInput.prop("disabled",!this._enabled);this._ruleEnabledInput.prop("disabled",!this._enabled);this._ruleTriggersView.setEnabled(this._enabled);
this._ruleActionsView.setEnabled(this._enabled)};h.prototype.validate=function(){if(!this._rule.getName())return window.alert(a.t("RULENAMEREQUIRED")),!1;var b=this._rule.getOrder();if(void 0!==b){if(!/^[1-9][0-9]*$/.test(b))return window.alert(a.t("RULEORDERINVALID")),!1}else return window.alert(a.t("RULEORDERINVALID")),!1;return this._ruleTriggersView.validate()&&this._ruleActionsView.validate()};return h});
define("pages/rules/RulePopupView","jquery underscore ./RuleView component/modal/Modal utils/webi18n!RulesTable lib/PromisePolyfill".split(" "),function(d,b,a,e,c){var h=function(){this._enabled=!0;this._cancelButton=this._addButton=null;this._onAddCallbacks=[];this._onCancelCallbacks=[];this._addClickHandler=b.bind(function(a,c){return Promise.all(b.map(this._onAddCallbacks,function(a){return a(c)}))},this);this._cancelClickHandler=b.bind(function(){return Promise.all(b.map(this._onCancelCallbacks,
function(a){return a()}))},this);this._constructPopup()};h.prototype._constructPopup=function(){this._popup||(this._popupContent=d("<div>").text(c.t("RULELOADING")),this._popup=new e(this._popupContent,this._options),this._popup.getJQElement().addClass("rulePopupView"),this._popup.setFooter(this._getFooterContent()))};h.prototype._getFooterContent=function(){var a=d("<div>").addClass("btn-group").attr({role:"group",name:"ActiveButtons"});this._addButton=d("<input>").attr({type:"button",value:c.t("RULESAVE")}).addClass("btn btn-primary");
this._addButton.click(b.bind(function(a){if(this._ruleView.validate()){var c=this._ruleView.getRule();this._addClickHandler(a,c).then(b.bind(function(){this._popup.close()},this))}},this));this._cancelButton=d("<input>").attr({type:"button",value:c.t("RULECANCEL")}).addClass("btn btn-default add-spacing-right");this._cancelButton.click(b.bind(function(a){this._cancelClickHandler(a).then(b.bind(function(){this._popup.close()},this))},this));a.append(this._cancelButton,this._addButton);return a};h.prototype.show=
function(a){this._initPopup(a);this._popup.open()};h.prototype._initPopup=function(b){this._ruleView&&this._ruleView.destroy();this._ruleView=new a(b.rule);this.setEnabled(b.enabled);this._popup.setContent(this._ruleView.getElement());this._popup.setTitle(b.title)};h.prototype.setEnabled=function(a){this._enabled=a;this._updateEnabled()};h.prototype._updateEnabled=function(){this._ruleView&&this._ruleView.setEnabled(this._enabled);this._addButton&&this._addButton.toggle(this._enabled)};h.prototype.onSubmit=
function(a){this._onAddCallbacks.push(a)};h.prototype.onCancel=function(a){this._onCancelCallbacks.push(a)};h.prototype.clearListeners=function(){this._onAddCallbacks=[];this._onCancelCallbacks=[]};return h});
define("pages/rules/RulePopup",["jquery","underscore","./RulePopupView"],function(d,b,a){d=function(b){this._options=b;this._view=new a};d.prototype.open=function(a){this._view.show(a)};d.prototype.onSubmit=function(a){this._view.onSubmit(a)};d.prototype.onCancel=function(a){this._view.onCancel(a)};d.prototype.clearListeners=function(){this._view.clearListeners()};return d});
define("pages/rules/RuleRowView",["utils/webi18n!RulesTable","underscore","jquery"],function(d,b,a){var e=function(c,e){this._rule=c;this._defaultOptions={enabled:!0};this._options=b.extend(this._defaultOptions,e);this._element=a("<tr>");this._options.enabled&&(this._checkboxInput=a("<input>",{type:"checkbox",name:"selectitem",value:this._rule.getID()}),this._checkbox=a("<td>").addClass("td-checkbox").append(this._checkboxInput),this._element.append(this._checkbox));this._order=a("<td>").addClass("td-narrow").append(this._rule.getOrder());
this._nameAnchor=a("<a>",{"class":"tableaction",title:d.t("RULEEDIT"),"data-action":"edit_rule"}).text(this._rule.getName());this._nameAnchor[0].rule=this._rule;this._name=a("<td>").append(this._nameAnchor);this._description=a("<td>").text(this._rule.getDescription());this._enabledCheckboxInput=a("<input>",{"class":"tableaction",type:"checkbox",name:"enablerule","data-action":"enable_rule",value:this._rule.getID()}).prop("checked",this._rule.isEnabled()).prop("disabled",!this._options.enabled).on("click",
b.bind(function(b){this._rule.setEnabled(a(b.target).prop("checked"))},this));this._enabledCheckboxInput[0].rule=this._rule;this._enabledCheckbox=a("<td>").addClass("td-checkbox").append(this._enabledCheckboxInput);this._element.append(this._order).append(this._name).append(this._description).append(this._enabledCheckbox)};e.prototype.getRule=function(){return this._rule};e.prototype.getElement=function(){return this._element};e.prototype.destroy=function(){};e.prototype.setEnabled=function(a){this._checkboxInput&&
this._checkboxInput.prop("disabled",!a);this._nameAnchor.prop("disabled",!a);this._enabledCheckboxInput.prop("disabled",!a)};return e});
define("webcenterapi/RuleEngineAPI","./AbstractAPI utils/webi18n!WebCenterAPI utils/ConvertUtils utils/Promisify pages/rules/Rule pages/rules/RuleFactory underscore jquery".split(" "),function(d,b,a,e,c,h,f,g){b=function(a,b){d.call(this,a,b);this._ruleFactory=new h};b.prototype=Object.create(d.prototype);b.prototype.constructor=b;b.prototype.saveRule=function(a,b){var c={action:"SAVE_RULE",projectid:b,name:a.getName(),enabled:a.isEnabled(),description:a.getDescription(),order:a.getOrder(),ruleJSON:JSON.stringify({triggers:a.getTriggers(),
actions:a.getActions()}),ruleUpdateDependent:!0};a.getID()&&(c.id=a.getID());return e.deferred(this.callSDK("RuleEngineServlet.wcr",{},{data:c,type:"POST"}))};b.prototype.deleteRules=function(a,b){return e.deferred(this.callSDK("RuleEngineServlet.wcr",{action:"DELETE_RULES",projectid:b,ruleid:a}))};b.prototype.getRules=function(a){return e.deferred(this.callSDK("RuleEngineServlet.wcr",{action:"LOAD_RULES",projectid:a})).then(f.bind(function(a){var b={},d={},e=[];b.owner=d;b.rules=e;if(a&&a.documentElement){var a=
a.documentElement,g=a.getElementsByTagName("owner")[0],h=a.getElementsByTagName("owner_name")[0];g&&h&&(d.id=g.textContent,d.name=h.textContent);d=a.getElementsByTagName("rule");for(a=0;a<d.length;a++){var i=d[a],g=i.getElementsByTagName("id")[0],h=i.getElementsByTagName("name")[0],m=i.getElementsByTagName("description")[0],n=i.getElementsByTagName("order")[0],s=i.getElementsByTagName("enabled")[0],i=i.getElementsByTagName("json")[0];if(g&&h&&m&&n&&s&&i){var l=JSON.parse(i.textContent),j,p=i=l.triggers;
f.isArray(i)||(p=[i]);for(var i=[],q=0;q<p.length;q++){var u=p[q];u&&(j=u.type,j=this._ruleFactory.createTrigger(j),j=f.extend(j,u),i.push(j))}l=q=l.actions;f.isArray(q)||(l=[q]);p=[];for(q=0;q<l.length;q++)if(u=l[q])j=u.type,j=this._ruleFactory.createAction(j),j=f.extend(j,u),p.push(j);n=parseInt(n.textContent,10);g=new c(g.textContent,h.textContent,m.textContent,n,"1"===s.textContent,i,p);e.push(g)}}}return b},this))};b.prototype.exportRules=function(a,b){var c="RuleEngineServlet.wcr?"+g.param({action:"EXPORT_RULES",
projectid:a,ruleid:b},!0);document.location.href=c};return b});
define("pages/rules/RulesTable","component/table/Table component/errorhandler/ErrorHandler webcenterapi/RuleEngineAPI ./RuleRowView utils/webi18n!RulesTable component/pagemessagecomponent/PageMessageComponent underscore jquery".split(" "),function(d,b,a,e,c,h,f,g){var i=function(f,e,h,i,r,y){d.call(this,f,e,h,i);this._errorHandler=new b;this._ruleEngineAPI=new a(window.webcenterConfig,this._errorHandler);this._projectID=r;this._isTemplate=y;this._views=[];this._ruleSourceLink=g("<a>").addClass("text-info actionlink");
this._ruleSource=g("<div>").addClass("alert alert-info").text(c.t("RULEOWNER")+" ").append(this._ruleSourceLink);this._selectAllInput=null;this.render()};i.prototype=Object.create(d.prototype);i.prototype.constructor=i;i.prototype.getMaxOrder=function(){return 0<f.size(this._views)?f.max(this._views,function(a){return a.getRule().getOrder()}).getRule().getOrder():0};i.prototype.getProjectID=function(){return this._projectID};i.prototype.isTemplate=function(){return this._isTemplate};i.prototype._clear=
function(){f.each(this._views,function(a){a.destroy()});this._views=[];this._tablesection.empty();this._tablesection.text(c.t("RULELOADING"))};i.prototype.setEnabled=function(a){this._selectAllInput&&this._selectAllInput.prop("disabled",!a);f.each(this._views,function(b){b.setEnabled(a)})};i.prototype.render=function(){this._clear();this._ruleEngineAPI.getRules(this.getProjectID()).then(f.bind(function(a){!this._isTemplate&&a.owner.name&&(this._ruleSourceLink.attr("href","projectrulesetup.jsp?menu_file=projmgmnttmplts&projectID="+
a.owner.id).text(a.owner.name),this._ruleSource.insertBefore(this._context));var b=g("<table>").addClass("ordtable");this._tablesection.empty().append(b);var d=g("<thead>");b.append(d);var h=g("<tr>");d.append(h);this._isTemplate&&(this._selectAllInput=g("<input>",{type:"checkbox",name:"selectall",value:"","data-toggle-all":"input[name='selectitem']",alt:c.t("RULESELECTALL")}),this._selectAllInput.prop("disabled",!this._isTemplate),d=g("<th>").addClass("td-checkbox").append(this._selectAllInput),
h.append(d));var d=g("<th>").text(c.t("RULEORDER")),i=g("<th>").text(c.t("RULENAME")),y=g("<th>").text(c.t("RULEDESCRIPTION")),t=g("<th>").text(c.t("RULEENABLED"));h.append(d).append(i).append(y).append(t);if(0===a.rules.length)a=g("<div>").addClass("no-results").text(c.t("RULESNOTFOUND")),this._tablesection.append(a);else{var m=g("<tbody>");b.append(m);f.each(a.rules,function(a){a=new e(a,{enabled:this._isTemplate});this._views.push(a);m.append(a.getElement())},this)}},this)).catch(f.bind(function(a){this._tablesection.empty();
h.sendErrorMessage(c.t("RULELOADINGFAILED")+(a?" "+a:""))},this))};i.wcrinit=function(a){typeof a!==g&&(a=g(a));var b=a.attr("data-itemrow-selector"),d=a.attr("data-checkbox-selector"),f=a.attr("data-projectid"),e="true"===a.attr("data-template"),y=a.attr("data-feedback"),t=a.attr("data-is-feedback-enabled"),m=a.attr("data-feedback-type");b||(b=" > table.ordtable > tbody > tr",g("> .wcr-table-section > table.ordtable",a).hasClass("gridview")&&(b=" > table.ordtable > tbody > tr > td"));d||(d="input[type='checkbox'][name^='select']");
var n="0"===a.attr("data-click-to-select")?!1:!0;new i(a,b,d,n,f,e);"true"===t&&("success"===m?h.sendSuccessMessage(c.t("RULE_IMPORT_SUCCESS"),void 0,!0):"warning"===m?h.sendWarnMessage("\n"+y):h.sendErrorMessage("\n"+y))};return i});
define("tpl!pages/rules/ImportRuleSetPopupContent",function(){return function(d){var b;return d=""+('<form enctype="MULTIPART/FORM-DATA" action="RuleEngineServlet.wcr" method="post" name="rsimportform">\r\n\t<input name="redirect" type="hidden" value="projectrulesetup.jsp?projectID='+(null==(b=d.projectID)?"":_.escape(b))+'&menu_file=projmgmnttmplts"></input>\r\n\t<input name="action" type="hidden" value="import_rules"></input>\r\n\t<input name="projectid" type="hidden" value="'+(null==(b=d.projectID)?
"":_.escape(b))+'"></input>\r\n\t<input class="datafile" name="XMLFile" type="file"></input>\r\n</form>')}});
define("pages/rules/ImportRuleSetPopup","component/actionpopup/ImportPopup utils/webi18n!RulesTable Template tpl!pages/rules/ImportRuleSetPopupContent underscore jquery".split(" "),function(d,b,a,e){var c={ImportConfirmText:b.t("RULE_SET_CONFIRM_TEXT"),ImportConfirmTooltip:b.t("RULE_SET_IMPORT_TOOLTIP"),ImportConfirmCancel:b.t("RULE_SET_CANCEL"),ImportConfirmOk:b.t("RULE_SET_OK"),ImportTooltip:b.t("RULE_SET_IMPORT_TOOLTIP"),ImportCancel:b.t("RULE_SET_CANCEL"),ImportOk:b.t("RULE_SET_OK")},h=function(f){this._projectId=
f;this._importPopup=new d(c,new a(b,e));this._importPopup.importConfirm=function(){document.rsimportform.submit()}};h.prototype.open=function(){this._importPopup.template.d.projectID=this._projectId;this._importPopup.open()};return h});
define("pages/rules/RulesTableActions","require underscore ./Rule component/errorhandler/ErrorHandler pages/rules/ImportRuleSetPopup webcenterapi/RuleEngineAPI utils/webi18n!RulesTable component/pagemessagecomponent/PageMessageComponent component/loadingindicator/LoadingIndicator jquery utils/webcss!./ruleview-style.css".split(" "),function(d,b,a,e,c,h,f,g,i,k){var b=new e,v=new h(window.webcenterConfig,b),w=k("<div>").addClass("loadingIndicator").append((new i).start()).hide(),x=function(a){a.table.getContext().before(w.show());
a.table.setEnabled(!1);a.actionmenu.setEnabled(!1)},r=function(a){a.table.render();a.actionmenu.setEnabled(!0);w.hide()};return{executeAction:function(b){var e=b.action,h=b.table.getProjectID(),i,k,l,j;switch(e){case "delete_rules":x(b);e=b.getActionItemsAttribute("value");v.deleteRules(e,h).then(function(){g.markObsolete("ruleAction");g.sendSuccessMessage(f.t("RULEDELETESUCCESS"),void 0,!0);r(b)}).catch(function(a){g.markObsolete("ruleAction");g.sendErrorMessage(f.t("RULEDELETEFAILED")+(a?" "+a:
""),void 0,"ruleAction");r(b)});break;case "new_rule":e=b.table.getMaxOrder()+1,i=new a(void 0,void 0,void 0,""+e,!0),k=f.t("RULENEW"),l="RULENEWSUCCESS",j=f.t("RULENEWFAILED");case "edit_rule":b.actionbutton[0]&&b.actionbutton[0].rule&&(i=b.actionbutton[0].rule.copy(),k=f.t("RULEEDIT"),l="RULEEDITSUCCESS",j=f.t("RULEEDITFAILED",i.getName()));d(["./RulePopup"],function(a){b.table._rulePopup||(b.table._rulePopup=new a);b.table._rulePopup.clearListeners();b.table._rulePopup.onSubmit(function(a){x(b);
v.saveRule(a,h).then(function(){g.markObsolete("ruleAction");g.sendSuccessMessage(f.t(l,a.getName()),void 0,!0);r(b)}).catch(function(a){g.markObsolete("ruleAction");g.sendErrorMessage(j+(a?" "+a:""),void 0,"ruleAction");r(b)});return Promise.resolve()});b.table._rulePopup.open({rule:i,title:k,enabled:b.table.isTemplate()})});break;case "enable_rule":b.actionbutton[0]&&b.actionbutton[0].rule&&(x(b),i=b.actionbutton[0].rule,l=i.isEnabled()?"RULEENABLESUCCESS":"RULEDISABLESUCCESS",j=f.t("RULEENABLEFAILED",
i.getName()),v.saveRule(i,h).then(function(){g.markObsolete("ruleAction");g.sendSuccessMessage(f.t(l,i.getName()),void 0,!0);r(b)}).catch(function(a){g.markObsolete("ruleAction");g.sendErrorMessage(j+(a?" "+a:""),void 0,"ruleAction");r(b)}));break;case "import_rules":(new c(h)).open();break;case "export_rules":e=b.getActionItemsAttribute("value"),v.exportRules(h,e)}}}});
define("pages/rules/all","pages/rules/Rule pages/rules/RuleAction pages/rules/RuleActionStartTask pages/rules/RuleActionStartTaskView pages/rules/RuleActionsView pages/rules/RuleActionView pages/rules/RuleConstants pages/rules/RuleFactory pages/rules/RulePopup pages/rules/RulePopupView pages/rules/RuleRowView pages/rules/RulesTable pages/rules/RulesTableActions pages/rules/RuleTrigger pages/rules/RuleTriggerProjectAttribute pages/rules/RuleTriggerProjectAttributeView pages/rules/RuleTriggersView pages/rules/RuleTriggerView pages/rules/RuleView pages/rules/RuleViewFactory".split(" "),function(){});