define("web-viewer/annotation/AnnotationFilter",["underscore","web-viewer/core/PrivateChannel","web-viewer/annotation/AnnotationConstants"],function(d,l,j){var k=function(h,f){l.installTo(this,h,["annotationFilter"]);this._annotationFilterModel=f};k.prototype.filterAnnotations=function(h){var f=[];if(this._annotationFilterModel.isCustomFilterActive()&&h)return f=d.filter(h,d.bind(function(f){return this.compliesToCustomFilter(f)},this)),this._annotationFilterModel.setNumberOfFilteredAnnotations(f.length),
f;if(h)return f=d.filter(h,d.bind(function(f){return this.compliesToFilter(f)},this)),this._annotationFilterModel.setNumberOfFilteredAnnotations(f.length),f;this._annotationFilterModel.setNumberOfFilteredAnnotations(0);return[]};k.prototype.filterIncomingAnnotations=function(h){var f=this._annotationFilterModel.getViewerUserFilter();if(0<f.length){var c=[];d.each(h,function(h){h.runThroughAnnotation(!0,!0,!0,d.bind(function(g){if(!d.some(f,function(f){return this._compliesToAuthor(g,f)},this)){if(g.inreplyto&&
!g.state){var h=d.indexOf(g.parent.replies,g);g.parent.replies.splice(h,1);return!0}if(g.state&&g.parent)return h=d.indexOf(g.parent.states,g),g.parent.states.splice(h,1),!0;if(!g.parent||g.linkedto)return c.push(g),!0}return!1},this))},this);d.each(c,function(f){f=d.indexOf(h,f);h.splice(f,1)})}return h};k.prototype.compliesToFilter=function(h){var f=this._annotationFilterModel.getOriginType();return f!==j.AnnotationOriginTypes.user.id&&f===h.originType?!0:this._compliesToUser(h)&&this._compliesToState(h)&&
this._compliesToType(h)};k.prototype.compliesToCustomFilter=function(h){var f=this._annotationFilterModel.getFilterRows();if(this._annotationFilterModel.getFilterOperator()==j.FilterOperators.ALL)return d.every(f,function(f){return this._checkCustomFilterRule(h,f)},this);if(this._annotationFilterModel.getFilterOperator()==j.FilterOperators.ANY)return d.some(f,function(f){return this._checkCustomFilterRule(h,f)},this)};k.prototype._checkCustomFilterRule=function(h,f){if(f.filterType==j.FilterTypes.AUTHOR)return f.filterCondition==
j.FilterCondition.IS?this._compliesToUser(h,f.filterOption):!this._compliesToUser(h,f.filterOption);if(f.filterType==j.FilterTypes.REVIEWSTATE)return f.filterCondition==j.FilterCondition.IS?this._compliesToCustomFilterState(h,f.filterOption):!this._compliesToCustomFilterState(h,f.filterOption);if(f.filterType==j.FilterTypes.REVIEWAUTHORANDSTATE)return f.filterCondition==j.FilterCondition.IS?this._compliesToReviewAuthorAndState(h,f.filterOption):!this._compliesToReviewAuthorAndState(h,f.filterOption)};
k.prototype._compliesToUser=function(h,f){var c=!0;void 0===f&&(f=this._annotationFilterModel.getSelectedUser());f&&(c=!1,h.runThroughAnnotation(!0,!0,!0,d.bind(function(h){if(h.username==f)return c=!0},this)));return c};k.prototype._compliesToType=function(h){return h.originType===this._annotationFilterModel.getOriginType()};k.prototype._compliesToAuthor=function(h,f){return f&&h.username==f?!0:!1};k.prototype._compliesToReviewAuthorAndState=function(h,f){var c=!1;if(f){var n=d.invert(j.AnnotationReviewState);
h.runThroughAnnotation(!0,!0,!1,d.bind(function(g){if(c=d.some(g.states,d.bind(function(g){g=g.getUserName()+" "+n[g.state];return f===g},this)))return!0},this))}return c};k.prototype._compliesToState=function(h){var f=!0,c=this._annotationFilterModel.getSelectedState();c&&(f=!1,"Any"==c?h.runThroughAnnotation(!0,!this._annotationFilterModel.isInverseState(),!1,d.bind(function(h){h=h.states;f=f||0<h.length},this)):h.runThroughAnnotation(!0,!this._annotationFilterModel.isInverseState(),!1,d.bind(function(h){d.some(h.states,
d.bind(function(g){return g.state==c},this))&&(f=!0)},this)),this._annotationFilterModel.isInverseState()&&(f=!f));return f};k.prototype._compliesToCustomFilterState=function(h,f){var c=!1;h.runThroughAnnotation(!0,!0,!1,d.bind(function(h){d.some(h.states,d.bind(function(g){return g.state==j.AnnotationReviewState[f]},this))&&(c=!0)},this));return c};return k});
define("web-viewer/annotation/Annotation","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils utils/StringSet web-viewer/annotation/AnnotationConstants underscore".split(" "),function(d,l,j,k,h,f,c,n,g,m){function p(e,i){var a=null;if(e.nodeType===Node.TEXT_NODE)a=i.createTextNode(e.textContent);else if(e.nodeType===Node.ELEMENT_NODE){a=i.createElement(e.nodeName.toLowerCase());
if(e.hasAttributes&&e.hasAttributes())for(var b=0;b<e.attributes.length;b++)a.setAttribute(e.attributes[b].name,e.attributes[b].value);if(e.hasChildNodes&&e.hasChildNodes())for(b=0;b<e.childNodes.length;b++){var g=p(e.childNodes[b],i);null!=g&&a.appendChild(g)}}return a}var b=function(e,i){d.call(this);this.f=e;this.creationdate=new Date;this.date=new Date;this.name=null;this.page=0;this.content=this.title=this.subject="";this.originType=i||g.AnnotationOriginTypes.user.id;this._view3DPosition=null;
this.lastname=this.firstname=this.username="";this.messagenumber=-1;this.parent=this.annottype=null;this.replies=[];this.inreplyto=null;this.links=[];this.linkedto=null;this.saved=!1;this.isNew=!0;this.states=[];this.statemodel=this.state=null;this.flags="print";this.popuprect=new j.Rect;this.popuppage=0;this.popupIsOpen=!1;this.originalAnnotationColor=this.modifiedContent=this.unsavedReplyText=null;this._modifications=new n;this._scaling=null;this._override("setRect",function(a,e){this._super(a,
e);this.setModified("LINEWORK")});this._override("move",function(a){this._super(a);(0!==a.width||0!==a.height)&&this.setModified("LINEWORK")});this._override("setStartEnd",function(a,e){this._super(a,e);this.setModified("LINEWORK")})};b.prototype=Object.create(d.prototype);b.prototype.constructor=b;b.prototype.getPermission=function(){return this.f.getCurrentUser().getUsername()==this.username?g.AccessRight.READ_WRITE:g.AccessRight.READ_ONLY};b.prototype.getPermissionFor=function(e){return e!==g.ActionPermissions.DUPLICATE_WITHOUT_TEXT};
b.prototype.getSortByAttr=function(){return this.content};b.prototype.getOutliningRect=function(){var e=m.union(this.links,[this]),i=m.min(e,function(a){return a.rect.left()}).rect.left(),a=m.max(e,function(a){return a.rect.top()}).rect.top(),b=m.max(e,function(a){return a.rect.right()}).rect.right(),e=m.min(e,function(a){return a.rect.bottom()}).rect.bottom();return new j.Rect(new j.Point(i,a),new j.Size(b-i,e-a))};b.prototype.getIconClass=function(){return g.AnnotationIcons[this.annottype]};b.prototype.isAnnotationModified=
function(){return 0===this.date-this.creationdate};b.prototype.initAnnotation=function(e,i,a,b,f){if(!this.name||0===this.name.length)void 0===b?this.f.emit("error.SEVERE","Problem initializing annotation","No model specified for generating unique name!"):this.name=b.generateUniqueName();f||(f=new j.Rect);this.rect=f;b&&(this._scaling=b.getCurrentScaling());i||(i=this.annotationcolor);this.annotationcolor=this.originalAnnotationColor=i;null===this.annotationcolor&&(this.annotationColor=this._getDefaultAnnotationColor(e));
this.color=i;this.annottype=e;this.setSelected(a);if(!this.subject||0===this.subject.length)this.subject=(null!=this.inreplyto?"Re: ":"")+g.AnnotationReplyName[this.annottype];switch(e){case g.AnnotationType.ANNOT_RECT:this.color=i;this.type=c.LWTYPE_RECT;break;case g.AnnotationType.ANNOT_ELLIPSE:this.color=i;this.type=c.LWTYPE_ELLIPSE;break;case g.AnnotationType.ANNOT_HIGHLIGHT:this.type=c.LWTYPE_RECT;this.treatAsOutline=!0;this.color=null;break;case g.AnnotationType.ANNOT_LINE:this.type=c.LWTYPE_LINE;
this.color=i;this.pointArray[0]=new l;this.pointArray[0].makeMoveTo(this.rect.origin.x,this.rect.origin.y);this.pointArray[1]=new l;this.pointArray[1].makeLineTo(this.rect.origin.x+this.rect.size.width,this.rect.origin.y+this.rect.size.height);break;case g.AnnotationType.ANNOT_ARROW:this.type=c.LWTYPE_ARROW;this.color=i;this.pointArray[0]=new l;this.pointArray[0].makeMoveTo(this.rect.origin.x,this.rect.origin.y);this.pointArray[1]=new l;this.pointArray[1].makeLineTo(this.rect.origin.x+this.rect.size.width,
this.rect.origin.y+this.rect.size.height);break;case g.AnnotationType.ANNOT_PIN:this.type=c.LWTYPE_IMAGE;this.imagehotspot=new j.Point(g.AnnotationPin.imagehotspotx,g.AnnotationPin.imagehotspoty);this.imagetouchspot=new j.Rect(new j.Point(g.AnnotationPin.imagetouchspotx,g.AnnotationPin.imagetouchspoty),new j.Size(g.AnnotationPin.imagetouchspotw,g.AnnotationPin.imagetouchspoth));break;case g.AnnotationType.ANNOT_FREEFORM:this.type=c.LWTYPE_LINEARRAY,this.color=i}};b.prototype.initWithXML=function(e,
i){this.saved=!0;this.isNew=!1;this.pointArray=[];this.name=k.attributeValue(e,"name");this.subject=k.attributeValue(e,"subject");this.title=k.attributeValue(e,"title");this.flags=k.attributeValue(e,"flags");this._view3DPosition={scale:h.parseFloat(k.attributeValue(e,"view3Dscale")),azimuth:h.parseFloat(k.attributeValue(e,"view3Dazimuth")),elevation:h.parseFloat(k.attributeValue(e,"view3Delevation"))};if(isNaN(this._view3DPosition.scale)||isNaN(this._view3DPosition.azimuth)||isNaN(this._view3DPosition.elevation))this._view3DPosition=
null;var a=/((\d+)\s)?(.+)/.exec(this.title);if(a){this.messagenumber=a[2];void 0===this.messagenumber&&(this.messagenumber=-1);var b=/([^,]+)(,\s(.+))?\s\((.+)\)/.exec(a[3]);b?(this.username=b[4],this.lastname=b[1],this.firstname=b[3]||""):(this.username=a[3],this.firstname=this.lastname="")}this.messagenumber=parseInt(this.messagenumber,10);this.page=k.attributeValue(e,"page");this.date=h.dateFromString(k.attributeValue(e,"date"));this.creationdate=h.dateFromString(k.attributeValue(e,"creationdate"));
this.state=k.attributeValue(e,"state");this.statemodel=k.attributeValue(e,"statemodel");this._parseContentsFromXML(e);if(a=k.attributeValue(e,"inreplyto"))this.inreplyto=a;if(a=k.attributeValue(e,"linkedto"))this.linkedto=a;var a=RegExp(/(.+),(.+),(.+),(.+)/),r=a.exec(k.attributeValue(e,"rect")),b=f.convertPSPointsToMM(r[1]),p=f.convertPSPointsToMM(r[2]),d=f.convertPSPointsToMM(r[3]),r=f.convertPSPointsToMM(r[4]),r=this._modifyAnnotatationCoords(b,p,d,r,i),b=r[0],p=r[1],d=r[2],r=r[3];switch(e.nodeName){case "square":this.initAnnotation(g.AnnotationType.ANNOT_RECT);
break;case "circle":this.initAnnotation(g.AnnotationType.ANNOT_ELLIPSE);break;case "highlight":this.initAnnotation(g.AnnotationType.ANNOT_HIGHLIGHT);break;case "text":this.rect.size.width=0;this.rect.size.height=0;this.initAnnotation(g.AnnotationType.ANNOT_PIN);break;case "ink":this.initAnnotation(g.AnnotationType.ANNOT_FREEFORM);if(!this.inreplyto){var c=e.getElementsByTagName("inklist")[0];if(c){for(var c=c.getElementsByTagName("gesture")[0],m="",n=0;n<c.childNodes.length;n++)m+=c.childNodes[n].nodeValue;
if(0<m.length)if(m=m.split(";"),c=new l,n=m[0].split(","),void 0!==n[0]&&void 0!==n[1]){c.makeMoveTo(f.convertPSPointsToMM(n[0]),f.convertPSPointsToMM(n[1]));this.pointArray.push(c);for(c=1;c<m.length;c++){var y=new l,n=m[c].split(",");if(void 0!==n[0]&&void 0!==n[1]){var u=f.convertPSPointsToMM(n[0]),n=f.convertPSPointsToMM(n[1]);y.makeLineTo(u,n);this.pointArray.push(y)}else this.f.emit("error.DEBUG","chunkpoint[0] || chunkpoint[1] is undefined...")}}else this.f.emit("error.DEBUG","chunkpoint[0] || chunkpoint[1] is undefined...");
this.calculateRectFromPointArray()}}break;case "line":(c=k.attributeValue(e,"subject"))&&"Arrow"==c?this.initAnnotation(g.AnnotationType.ANNOT_ARROW):this.initAnnotation(g.AnnotationType.ANNOT_LINE),this.inreplyto||(m=RegExp(/(.+),(.+)/),c=k.attributeValue(e,"start"),n=k.attributeValue(e,"end"),c=m.exec(c),u=m.exec(n),m=f.convertPSPointsToMM(c[1]),y=f.convertPSPointsToMM(c[2]),n=f.convertPSPointsToMM(u[1]),u=f.convertPSPointsToMM(u[2]),c=new l,c.makeMoveTo(m,y),m=new l,m.makeLineTo(n,u),this.pointArray[0]=
c,this.pointArray[1]=m,c=new j.Point(c.x,c.y),m=new j.Point(m.x,m.y),this.rect=new j.Rect(c,c.sizeTo(m)),this.rect.normalize())}this.rect.origin.x=b;this.rect.origin.y=r;this.rect.size.width=d-b;this.rect.size.height=p-r;b=k.attributeValue(e,"color");/^#?[a-f\d]{6}$/i.test(b)||(b=this._getDefaultAnnotationColor(this.annottype));this.annotationcolor=this.originalAnnotationColor=this.color=b;if(b=e.getElementsByTagName("popup")[0])this.popuppage=k.attributeValue(b,"page"),this.popupIsOpen="yes"==k.attributeValue(b,
"open"),d=a.exec(k.attributeValue(b,"rect")),a=f.convertPSPointsToMM(d[1]),b=f.convertPSPointsToMM(d[2]),p=f.convertPSPointsToMM(d[3]),d=f.convertPSPointsToMM(d[4]),this.popuprect.origin.x=a,this.popuprect.origin.y=b,this.popuprect.size.width=p-a,this.popuprect.size.height=d-b};b.prototype._modifyAnnotatationCoords=function(e,b,a,g){return[e,b,a,g]};b.prototype.duplicate=function(e,i,a,g,f){var c=new b(this.f);a?(c.initAnnotation(this.annottype,this.annotationcolor,!0,f),c.content=this.getTextContent()):
(m.each(this,function(a,e){c[e]=a}),c.modifiedContent=null,c.rect&&(c.rect=c.rect.copy()),c.popuprect&&(c.popuprect=c.popuprect.copy()));c.isNew=!0;c.name=f.generateUniqueName();e||(c.replies=[]);i||(c.states=[]);a?(e=this.inreplyto?this.parent:this,c.pointArray=[],m.each(e.pointArray,function(a){c.pointArray.push(m.clone(a))}),c.color=m.clone(e.color),c.rect=e.rect.copy(),c.popuprect=e.popuprect.copy()):c.pointArray=[];g?(c.links=[],m.each(this.links,function(a){a=a.duplicate(!1,!1,!0,!1,f);a.linkedto=
c.name;a.parent=c;c.links.push(a)})):c.links=[];return c};b.prototype.needsSelectionBox=function(){return this.annottype!=g.AnnotationType.ANNOT_PIN};b.prototype.setSelected=function(e){this.linewidth=(this.selected=e)?3:2;this.annottype===g.AnnotationType.ANNOT_HIGHLIGHT&&(this.fillcolor="rgba(255, 255, 0, "+(e?".8":".3")+")");this.annottype===g.AnnotationType.ANNOT_PIN&&(this.imageRef=e?g.AnnotationPin.highlighted:g.AnnotationPin.normal)};b.prototype.updateIndicator=function(){this.indicatorText=
""+this.messagenumber;this.linkedto?this.parent&&(this.indicatorText+="-"+(m.indexOf(this.parent.links,this)+2)):0<this.getGodfather().links.length&&(this.indicatorText+="-1");this.indicatorTextColor=this.getHeaderTextColor();this.indicatorColor=this.annotationcolor};b.prototype.getUserName=function(){return this.firstname?this.lastname+", "+this.firstname+" ("+this.username+")":this.lastname+" ("+this.username+")"};b.prototype.rgbColor=function(){var e=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.annotationcolor);
return e?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16)}:null};b.prototype.getHeaderTextColor=function(){var e=this.rgbColor();return 0.5<0.3*(e.r/255)+0.59*e.g/255+0.11*e.b/255?"black":"white"};b.prototype.setModified=function(e){this._modifications.add(e);this.saved=0===this._modifications.size();this.date=new Date};b.prototype.setIsNew=function(e){this.isNew=e};b.prototype.cancelModified=function(e){"CONTENT"===e&&(this.modifiedContent=null);void 0!==e?this._modifications.remove(e):
this._modifications.clear();this.saved=0===this._modifications.size()};b.prototype.setBeingModified=function(e){void 0===e&&(e=null);this.modifiedContent!==e&&(this._modifications.add("CONTENT"),this.modifiedContent=e,this.saved=!1)};b.prototype.isBeingModified=function(){return!this.saved};b.prototype._runThroughAnnotation=function(e,b,a,g){if(b){var f=m.clone(e.replies);m.each(f,m.bind(function(e){g(e)||this._runThroughAnnotation(e,b,a,g)},this))}a&&(e=m.clone(e.states),m.each(e,m.bind(function(e){g(e)||
this._runThroughAnnotation(e,b,a,g)},this)))};b.prototype.runThroughAnnotation=function(e,b,a,g){(!e||!g(this))&&this._runThroughAnnotation(this,b,a,g)};b.prototype.toXML=function(e){var b=e.createElementNS(null,g.AnnotationElementName[this.annottype]);this.isNew&&!this.linkedto?b.setAttribute("title",this.getUserName()):b.setAttribute("title",this.messagenumber+" "+this.getUserName());(!this.name||0===this.name.length)&&this.f.emit("error.SEVERE","Trying to convert an annotation without a name to XML");
b.setAttribute("name",this.name);b.setAttribute("color",this.annotationcolor);b.setAttribute("creationdate",h.stringFromDate(this.creationdate));b.setAttribute("date",h.stringFromDate(this.date));b.setAttribute("flags",this.flags);b.setAttribute("page",this.page);var a=this.rect;this._scaling&&(a=new j.Rect(new j.Point(1*this.rect.origin.x/this._scaling.x,1*this.rect.origin.y/this._scaling.y),new j.Size(1*this.rect.size.width/this._scaling.x,1*this.rect.size.height/this._scaling.y)));b.setAttribute("rect",
h.rectToString(a));b.setAttribute("subject",this.subject);this.state&&b.setAttribute("state",this.state);this.statemodel&&b.setAttribute("statemodel",this.statemodel);this.inreplyto&&b.setAttribute("inreplyto",this.inreplyto);this.linkedto&&b.setAttribute("linkedto",this.linkedto);this._view3DPosition&&(b.setAttribute("view3Dscale",this._view3DPosition.scale),b.setAttribute("view3Dazimuth",this._view3DPosition.azimuth),b.setAttribute("view3Delevation",this._view3DPosition.elevation));if(!this.inreplyto)if(g.AnnotationType.ANNOT_FREEFORM==
this.annottype){for(var s=e.createElementNS(null,"inklist"),a=e.createElementNS(null,"gesture"),c="",d=0;d<this.pointArray.length;d++){var m=this.pointArray[d];0!==d&&(c+=";");c=this._scaling?c+(f.convertMMToPSPoints(1*m.x/this._scaling.x)+","+f.convertMMToPSPoints(1*m.y/this._scaling.y)):c+(f.convertMMToPSPoints(m.x)+","+f.convertMMToPSPoints(m.y))}a.textContent=c;s.appendChild(a);b.appendChild(s)}else if(g.AnnotationType.ANNOT_LINE==this.annottype||g.AnnotationType.ANNOT_ARROW==this.annottype)d=
this.pointArray[0],s=this.pointArray[1],a=this._scaling?new j.Rect(new j.Point(1*a.origin.x/this._scaling.x,1*a.origin.y/this._scaling.y),new j.Size(1*a.size.width/this._scaling.x,1*a.size.height/this._scaling.y)):new j.Rect(new j.Point(d.x,s.y),new j.Size(s.x-d.x,d.y-s.y)),b.setAttribute("rect",h.rectToString(a)),a=f.convertMMToPSPoints(d.x)+","+f.convertMMToPSPoints(d.y),c=f.convertMMToPSPoints(s.x)+","+f.convertMMToPSPoints(s.y),this._scaling&&(a=f.convertMMToPSPoints(1*d.x/this._scaling.x)+","+
f.convertMMToPSPoints(1*d.y/this._scaling.y),c=f.convertMMToPSPoints(1*s.x/this._scaling.x)+","+f.convertMMToPSPoints(1*s.y/this._scaling.y)),b.setAttribute("start",a),b.setAttribute("end",c),this.annottype==g.AnnotationType.ANNOT_ARROW&&(b.setAttribute("head","None"),b.setAttribute("tail","OpenArrow"));if(!this.linkedto||this.statemodel){s=e.createElement("contents-richtext");null!==this.modifiedContent&&(this.content=this.modifiedContent);if(this.content)if(a=this._parseMarkupToXMLDocument(this.content),
d=a.getElementsByTagName("body")[0])s.appendChild(p(d,e));else{c=e.createElement("body");if(a.hasChildNodes&&a.hasChildNodes())for(d=0;d<a.childNodes.length;d++)m=p(a.childNodes[d],e),null!=m&&c.appendChild(m);s.appendChild(c)}b.appendChild(s)}0===this.popuprect.origin.x&&0===this.popuprect.origin.y&&(this.popuprect.origin.x=this.rect.right(),this.popuprect.origin.y=this.rect.top());e=e.createElementNS(null,"popup");e.setAttribute("rect",h.rectToString(this.popuprect));e.setAttribute("page",this.popuppage);
e.setAttribute("open",this.popupIsOpen?"yes":"no");b.appendChild(e);return b};b.prototype._parseMarkupToXMLDocument=function(e){e=e.replace(/\&nbsp;/g," ");try{if((new DOMParser).parseFromString("","text/html")){var b=(new DOMParser).parseFromString(e,"text/html");if(b&&b.documentElement)return b.documentElement}}catch(a){}var b=document.implementation.createHTMLDocument(""),g=/<body>(.*)<\/body>/.exec(e);g&&1<=g.length&&(e=g[1]);(g=/<html>(.*)<\/html>/.exec(e))&&1<=g.length&&(e=g[1]);b.body.innerHTML=
e;return b.documentElement};b.prototype.getUserStateAnnotation=function(e){return m.find(this.states,function(b){return b.username===e})};b.prototype.getStringContent=function(e){var b=this.content.replace(/<([^<]*)>/g,"").trim();e&&b.length>e&&(b=b.substring(0,e)+"...");return b};b.prototype.setColor=function(e){null===e&&(e=this._getDefaultAnnotationColor(this.annottype));this.runThroughAnnotation(!0,!0,!0,function(a){a.annotationcolor!=e&&(a.annotationcolor=e,a.color=e,a.setModified("COLOR"))});
var b=this.getGodfather();m.each(b.links,function(a){a.annotationcolor!=e&&(a.annotationcolor=e,a.color=e,a.setModified("COLOR"))})};b.prototype.cancelModifiedColor=function(){this.cancelModified("COLOR");this.runThroughAnnotation(!0,!0,!0,function(e){e.cancelModified("COLOR")});var e=this.getGodfather();m.each(e.links,function(e){e.cancelModified("COLOR")})};b.prototype.resetAnnotationColor=function(){this.originalAnnotationColor&&this.setColor(this.originalAnnotationColor)};b.prototype.getGodfather=
function(){for(var e=this;e.parent;)e=e.parent;return e};b.prototype.getType=function(){return this.annottype};b.prototype.getTextContent=function(){return m.clone(this.content)};b.prototype.getMessageNumber=function(){return this.messagenumber};b.prototype.setUnsavedReply=function(e){this.setModified("REPLY");this.unsavedReplyText=e;""===e&&this.cancelModified("REPLY")};b.prototype.resetUnsavedReply=function(){this.unsavedReplyText=null;this.cancelModified("REPLY")};b.prototype.getUnsavedReply=function(){return this.unsavedReplyText};
b.prototype.hasUnsavedReply=function(){return null!==this.unsavedReplyText&&""!==this.unsavedReplyText};b.prototype.isStateObject=function(){return null!==this.state};b.prototype.setScale=function(e){this.scale(e);this._scaling=e};b.prototype.isScaled=function(){return null!==this._scaling&&void 0!==this._scaling};b.prototype.getScale=function(){return this._scaling};b.prototype._getDefaultAnnotationColor=function(e){return e==g.AnnotationType.ANNOT_PIN?this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR"):
this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};b.prototype._parseContentsFromXML=function(e){e=e.getElementsByTagName("contents-richtext");this.content="<p></p>";if(0<e.length){var b=e[0].getElementsByTagName("body")[0];b||(b=e[0]);"undefined"!=typeof window.XMLSerializer?this.content=(new XMLSerializer).serializeToString(b):"undefined"!=typeof b.xml&&(this.content=b.xml)}};b.prototype.getExtraContent=function(){return null};b.prototype.set3DViewPosition=function(e){this._view3DPosition=
e;this.setModified("3DVIEW")};b.prototype.get3DViewPosition=function(){return this._view3DPosition};return b});
define("web-viewer/annotation/AnnotationFilterModel2",["web-viewer/core/PrivateChannel","web-viewer/annotation/AnnotationConstants","web-viewer/core/AbstractModel","underscore","jquery"],function(d,l,j,k,h){d=function(f){j.call(this,f,"annotationFilterModel");this.f=f;this._filterRows=[];this._filterOperator=l.FilterOperators.ALL;this._isCustomFilterEnabled=!1;this._selectedState=this._selectedUser=null;this._inverseState=!1;this._numberOfFilteredAnnotations=0;this._originType=l.AnnotationOriginTypes.user.id;
this._viewerUserFilter=(f=this.f.getProperty("showuser"))?f.split("|"):[];(this._annotationFilterPinnedState=void 0!==this.f.getOption("ANNOTATION_FILTER")&&""!==this.f.getOption("ANNOTATION_FILTER"))&&this.setFilterState(this.f.getOption("ANNOTATION_FILTER"))};d.prototype.resetFilter=function(){this._selectedState=this._selectedUser=null;this._inverseState=!1;this._originType=l.AnnotationOriginTypes.user.id;this._filterRows=[];this._filterRows.push(this.getDefaultFilterRow());this._filterOperator=
l.FilterOperators.ALL;this._isCustomFilterEnabled=!1;this._numberOfFilteredAnnotations=0;this._emit("filterReset",this);this._emit("filterChanged",this)};d.prototype.setSelectedUser=function(f){this._selectedUser=f;this._isCustomFilterEnabled=!1;this._emit("filterChanged",this);this.fireFilterStateChanged()};d.prototype.setOriginType=function(f){f!==this._originType&&(this._originType=f,this._isCustomFilterEnabled=!1,this._emit("filterChanged",this),this.fireFilterStateChanged())};d.prototype.getSelectedUser=
function(){return this._selectedUser};d.prototype.getOriginType=function(){return this._originType};d.prototype.setSelectedState=function(f,c){this._selectedState=f;this._inverseState=c;this._isCustomFilterEnabled=!1;this._emit("filterChanged",this);this.fireFilterStateChanged()};d.prototype.getSelectedState=function(){return this._selectedState};d.prototype.isInverseState=function(){return this._inverseState};d.prototype.addFilterRow=function(f,c,d,g){this._filterRows[f]={filterId:f,filterType:c,
filterCondition:d,filterOption:g}};d.prototype.addEmptyRow=function(){this._filterRows.push(this.getDefaultFilterRow());this._emit("filterChanged",this);return this._filterRows.length-1};d.prototype.updateFilterType=function(f,c,d){this._filterRows[f]&&(this._filterRows[f].filterType=c,this._filterRows[f].filterOption=d,this._emit("filterChanged",this))};d.prototype.updateFilterOption=function(f,c){this._filterRows[f]&&(this._filterRows[f].filterOption=c,this._emit("filterChanged",this))};d.prototype.updateFilterCondition=
function(f,c){this._filterRows[f]&&(this._filterRows[f].filterCondition=c,this._emit("filterChanged",this))};d.prototype.removeFilterRow=function(f){delete this._filterRows[f];this._emit("filterChanged",this)};d.prototype.removeAllFilterRows=function(){this._filterRows=[];this._emit("filterChanged",this)};d.prototype.getFilterRow=function(f){return this._filterRows[f]};d.prototype.getFilterRows=function(){0===this._filterRows.length&&this._filterRows.push(this.getDefaultFilterRow());return k.without(this._filterRows,
null,void 0)};d.prototype.setFilterRows=function(f){this._filterRows=f;this._emit("filterChanged",this)};d.prototype.getDefaultFilterRow=function(){return{filterId:this._filterRows.length,filterType:l.FilterTypes.REVIEWSTATE,filterCondition:l.FilterCondition.IS,filterOption:"STATUS_ACCEPTED"}};d.prototype.setCustomFilterActive=function(f){(this._isCustomFilterEnabled=f)&&0===this._filterRows.length&&this._filterRows.push(this.getDefaultFilterRow());this._emit("filterChanged",this)};d.prototype.isCustomFilterActive=
function(){return this._isCustomFilterEnabled};d.prototype.setFilterOperator=function(f){this._filterOperator=f;this._emit("filterChanged",this)};d.prototype.getFilterOperator=function(){return this._filterOperator};d.prototype.setNumberOfFilteredAnnotations=function(f){this._numberOfFilteredAnnotations=f};d.prototype.getNumberOfFilteredAnnotations=function(){return this._numberOfFilteredAnnotations};d.prototype.isAnnotationFilterPinned=function(){return this._annotationFilterPinnedState};d.prototype.toggleAnnotationPinnedState=
function(f){(this._annotationFilterPinnedState=void 0!==f?f:!this._annotationFilterPinnedState)?this.fireFilterStateChanged():this._emit("filterStateChanged",!1)};d.prototype.getFilterState=function(){var f={customFilterOperator:this._filterOperator,customFilterRows:k.compact(this._filterRows),isCustomFilterActive:this.isCustomFilterActive(),selectedUser:this._selectedUser,selectedState:this._selectedState,inverseState:this._inverseState};return JSON.stringify(f)};d.prototype.setFilterState=function(f){try{if(f=
h.parseJSON(f))this._isCustomFilterEnabled=f.isCustomFilterActive,this._filterOperator=f.customFilterOperator,this._filterRows=f.customFilterRows,k.each(this._filterRows,function(c,g){c.filterId=g},this),this._selectedUser=f.selectedUser,this._selectedState=f.selectedState,this._inverseState=f.inverseState}catch(c){}this._emit("filterChanged",this)};d.prototype.fireFilterStateChanged=function(){this._emit("filterStateChanged",!0)};d.prototype.getViewerUserFilter=function(){return this._viewerUserFilter};
return d});
define("web-viewer/annotation/AnnotationModel","web-viewer/core/PrivateChannel web-viewer/annotation/AnnotationFilter web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/annotation/AnnotationFilterModel2 utils/ShapeUtils web-viewer/utils/ListenerUtil web-viewer/utils/ViewerUtils web-viewer/layout/component/ModalPopup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/LayoutConstants utils/OrderedObject underscore".split(" "),function(d,l,j,k,h,f,c,
n,g,m,p,b,e){var i=function(a,i){d.installTo(this,a,["annotationModel",i]);c.mixin(this,a);this.f=a;this._disabledReasons=new b;this._page=null;this._annotations=[];this._removedannotations=[];this._selectedAnnotations=[];this._filteredAnnotations=[];this._layoutType=null;this._annotationFilterModel=new h(this.f);this._orderedAnnotations=[];this._currentAnnotationIndex=-1;this._currentScaling=null;this.lockSelection=!1;this._disabledReasonChangedListener=this._addAnnotationsEnabledListener=null;this._isSavingAnnotations=
this._annotationListVisible=!1;var g=a.getCurrentUser();g.on("options.changed.PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",e.bind(function(){this.modelChanged()},this));g.on("options.changed.PREFERENCES_ANNOTATION_NEXT_MODE",e.bind(function(){this._orderedAnnotations.length=0;this.modelChanged()},this));g.on("options.changed.PREFERENCES_ANNOTATION_DATESORT_MODE",e.bind(function(a,e){this.setSortingMode(e)},this));g.on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",e.bind(function(){this.modelChanged()},
this));this.setSortingMode(a.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE"));this._canChangeAnnotations=!0;this._annotationmode=k.annotateMode.NO_RESTRICTIONS;a.getProperty("annotationmode")&&(this._annotationmode=parseInt(a.getProperty("annotationmode"),10));this._allowedAnnotators=k.allowedAnnotators.ALL;a.getProperty("annotatorsmode")&&(this._allowedAnnotators=parseInt(a.getProperty("annotatorsmode"),10));this.editabilityDependsOnApproval()&&(this._canChangeAnnotations=!1,a.loadBundle("viewer",
function(){this.setDisableReason("LOADING_APPROVAL",this.f.t("Loading"))},this));this._confirmedOnce=this._warnWhenChangingAnnotations=!1;this._filter=new l(a,this._annotationFilterModel);this._annotationFilterModel.on("filterChanged",e.bind(function(){this._filterAllAnnotations();this._orderedAnnotations=[]},this));this._temporarilyDisabled={isTemporarilyDisabled:!1,reason:"",enableAnnotationToggling:!1,showingCurrentAnnotations:!1,showingDifferenceAnnotations:!1}};i.prototype.setAnnotationListVisible=
function(a){this._annotationListVisible!==a&&(this._annotationListVisible=a,this._emit("annotationListVisible",a))};i.prototype.isAnnotationListVisible=function(){return this._annotationListVisible};i.prototype.currentOrdening=function(){return this.orderByCreationDate};i.prototype.toggleVisibility=function(a){if(void 0===a)a=1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"),a=!a;else if(a&&1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"))return;a?this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",
1):(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",0),this.unselectAllAnnotations());this.modelChanged()};i.prototype.temporarilyDisable=function(a,e,b,i){this._temporarilyDisabled.isTemporarilyDisabled=a;this._temporarilyDisabled.reason=b;this._temporarilyDisabled.enableAnnotationToggling=e;this.unselectAllAnnotations();void 0!==i?("difference"==i?this.showTemporarilyDifferencePageAnnotations():"current"==i&&this.showTemporarilyActivePageAnnotations(),this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",
1,!0)):(this._temporarilyDisabled.showingCurrentAnnotations=!1,this._temporarilyDisabled.showingDifferenceAnnotations=!1);this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");a||(this.setPage(this.f.getActivePage()),this._temporarilyDisabled.showingCurrentAnnotations=!0);this.modelChanged()};i.prototype.updateTemporarilyDisabledReason=function(){this.f.loadBundle("viewer",function(){this.isTemporarilyDisabled()&&!this.isTemporarilyCurrentPageAnnotationsShown()?(this.setDisableReason("TEMPORARY_DISABLE",
this._temporarilyDisabled.reason),this.isTemporarilyDifferencePageAnnotationsShown()&&this.setDisableReason("TEMPORARY_DISABLE",this.f.t("AnnDisabledDiffMode"))):this.removeDisableReason("TEMPORARY_DISABLE")},this)};i.prototype.isTemporarilyDisabledAndNoAnnotationsVisible=function(){return this._temporarilyDisabled.isTemporarilyDisabled&&!this._temporarilyDisabled.showingCurrentAnnotations&&!this._temporarilyDisabled.showingDifferenceAnnotations||!this.isAllowedToShowAnnotations()};i.prototype.isTemporarilyDisabled=
function(){return this._temporarilyDisabled.isTemporarilyDisabled};i.prototype.isTemporarilyDisabledAndCannotEdit=function(){return this._temporarilyDisabled.isTemporarilyDisabled&&!this._temporarilyDisabled.showingCurrentAnnotations||!this.isAllowedToShowAnnotations()};i.prototype.getTemporarilyDisabledMessage=function(){return this._temporarilyDisabled.reason};i.prototype.isTemporarilyCurrentPageAnnotationsShown=function(){return this._temporarilyDisabled.showingCurrentAnnotations&&this.isAllowedToShowAnnotations()};
i.prototype.isTemporarilyDifferencePageAnnotationsShown=function(){return this._temporarilyDisabled.showingDifferenceAnnotations&&this.isAllowedToShowAnnotations()};i.prototype.isTemporarilyAnnotationDocumentTogglingEnabled=function(){return this._temporarilyDisabled.enableAnnotationToggling&&this.isAllowedToShowAnnotations()};i.prototype.isAllowedToShowAnnotations=function(){return!e.some(this._disabledReasons.getItemsAsObject(),function(a){return a.hideAnnotations})};i.prototype.showTemporarilyDifferencePageAnnotations=
function(){if(this.isAllowedToShowAnnotations()){var a=this.f.getDocumentController().getDifferencePage();this.unselectAllAnnotations();this._temporarilyDisabled.showingDifferenceAnnotations=!0;this._temporarilyDisabled.showingCurrentAnnotations=!1;this.updateTemporarilyDisabledReason();this.setPage(a,e.bind(function(){this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()},this))}};i.prototype.showTemporarilyActivePageAnnotations=function(){if(this.isAllowedToShowAnnotations()){var a=
this.f.getActivePage();this.unselectAllAnnotations();this.setPage(a,e.bind(function(){this._temporarilyDisabled.showingDifferenceAnnotations=!1;this._temporarilyDisabled.showingCurrentAnnotations=!0;this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()},this))}};i.prototype.hideTemporarilyAnnotations=function(){this._temporarilyDisabled.showingDifferenceAnnotations=!1;this._temporarilyDisabled.showingCurrentAnnotations=!1;this.setPage(this.f.getDocumentController().getActivePage());
this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()};i.prototype.getAnnotationsPage=function(){return this._page};i.prototype.editabilityDependsOnApproval=function(){return this._annotationmode===k.annotateMode.IF_APPROVED_SHOW_WARNING||this._annotationmode===k.annotateMode.IF_APPROVED_DISABLE||this._annotationmode===k.annotateMode.IF_APPROVED_OR_REJECTED_SHOW_WARNING||this._annotationmode===k.annotateMode.IF_APPROVED_OR_REJECTED_DISABLE||this._allowedAnnotators!==
k.allowedAnnotators.ALL||this._annotationmode===k.annotateMode.ALWAYS_DISABLE};i.prototype.canChangeAnnotations=function(a){return this.isTemporarilyDisabledAndCannotEdit()||this._cannotChangeAnnotationsOfCurrentPage()||!this._canChangeAnnotations?!1:!this._confirmedOnce&&this._warnWhenChangingAnnotations&&!a?(a=this._page.isApproved()?"AnnAlreadyApproved":"AnnAlreadyRejected",this._confirmedOnce=window.confirm(this.f.i18n.t(a))):!0};i.prototype.canChangeAnnotation=function(a){if(this.isTemporarilyDisabledAndCannotEdit()||
this._cannotChangeAnnotationsOfCurrentPage())return!1;var e=k.AccessRight.READ_ONLY;this._canChangeAnnotations&&(e=a.getPermission());return e==k.AccessRight.READ_WRITE};i.prototype._cannotChangeAnnotationsOfCurrentPage=function(){return this._page&&(!this._page.getDocumentVersion().isLatestVersion()||!this._page.canChangeAnnotations())};i.prototype.canDeleteAnnotation=function(a){return this.f.getProperty("annotationblockdeletesaved")&&!a.isNew?!1:this.canChangeAnnotation(a)};i.prototype.updateApprovalInfo=
function(){this._page&&this.f.loadBundle("viewer",function(){var a=this._canChangeAnnotations;this._canChangeAnnotations=!0;this._warnWhenChangingAnnotations=!1;var b="";if(this._annotationmode===k.annotateMode.ALWAYS_DISABLE)this._canChangeAnnotations=!1,b=this.f.t("AnnDisabled");else if(this._page.isApproved()&&(this._annotationmode===k.annotateMode.IF_APPROVED_SHOW_WARNING?this._warnWhenChangingAnnotations=this._canChangeAnnotations=!0:this._annotationmode===k.annotateMode.IF_APPROVED_DISABLE&&
(this._warnWhenChangingAnnotations=this._canChangeAnnotations=!1,b=this.f.t("AnnAlreadyApprovedBlocked"))),this._page.isApproved()||this._page.isRejected())this._annotationmode===k.annotateMode.IF_APPROVED_OR_REJECTED_SHOW_WARNING?this._warnWhenChangingAnnotations=this._canChangeAnnotations=!0:this._annotationmode===k.annotateMode.IF_APPROVED_OR_REJECTED_DISABLE&&(this._warnWhenChangingAnnotations=this._canChangeAnnotations=!1,b=this._page.isApproved()?this.f.t("AnnAlreadyApprovedBlocked"):this.f.t("AnnAlreadyRejectedBlocked"));
this._canChangeAnnotations&&this._page.isUnderApproval()&&this._allowedAnnotators!==k.allowedAnnotators.ALL&&(this._allowedAnnotators===k.allowedAnnotators.ALL_APPROVERS?this._page.isUserApprover()||(this._canChangeAnnotations=!1,b=this.f.t("AnnNotApproverBlocked")):this._allowedAnnotators===k.allowedAnnotators.ALL_APPROVERS_AND_MASTER?!this._page.isUserApprover()&&!this._page.isUserApprovalMaster(e.bind(this.updateApprovalInfo,this))&&(this._canChangeAnnotations=!1,b=this.f.t("AnnNotApproverOrMasterBlocked")):
this._allowedAnnotators===k.allowedAnnotators.PENDING_APPROVERS?this._page.isUserPendingApprover()||(this._canChangeAnnotations=!1,b=this.f.t("AnnNotPendingApproverBlocked")):this._allowedAnnotators===k.allowedAnnotators.PENDING_APPROVERS_AND_MASTER&&(!this._page.isUserPendingApprover()&&!this._page.isUserApprovalMaster(e.bind(this.updateApprovalInfo,this)))&&(this._canChangeAnnotations=!1,b=this.f.t("AnnNotPendingApproverOrMasterBlocked")));""!==b?(this.setDisableReason("ANNOTATORS_MODE",b),0<this.getUnsavedAnnotationCount()&&
this.reload()):this.removeDisableReason("ANNOTATORS_MODE");a!=this._canChangeAnnotations&&this._emit("readWriteChanged")},this)};i.prototype.onApprovalUpdated=function(){this.removeDisableReason("LOADING_APPROVAL");this.updateApprovalInfo()};i.prototype.setAnnotations=function(a){var b=this.f.getProperty("AnnotationModel.annotationFilter");b&&0<a.length&&(0<b.allowedAnnotations.length&&(a=a.filter(function(a){var i=e.find(b.allowedAnnotations,function(e){return e.name===a.name});return i?(i.allowLinkedAnnotations||
(a.links=null,a.linkedto=null,a.parent=null),!0):!1})),b.resetFilter&&this.getAnnotationFilterModel().resetFilter());a=this._filter.filterIncomingAnnotations(a);this.scaleAllAnnotations(null);this._annotations=a;this._page&&this._page!==this.f.getDocumentController().getDifferencePage()&&this.scaleAllAnnotations(this._page.getCurrentScaling());this._confirmedOnce=!1;this.setSortingMode(this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE"),!0);this._filterAllAnnotations(!0);this.modelContentChanged()};
i.prototype.getAnnotations=function(){return this._annotations};i.prototype.getAnnotationOrigins=function(){return e.uniq(e.map(this._annotations,function(a){return a.originType}))};i.prototype.getAnnotationCount=function(){return e.filter(this._annotations,function(a){return a.getGodfather()===a},this).length};i.prototype._filterAllAnnotations=function(a){var b=e.filter(this._annotations,function(a){return a.getGodfather()===a},this);this._filteredAnnotations=this._filter.filterAnnotations(b);this.currentOrdening();
a||(this.modelChanged(),this.filterChanged())};i.prototype.getUsers=function(a){var b={};e.each(this._annotations,function t(i){if(!b[i.username]&&(!a||i.originType===a))b[i.username]=i.getUserName();0<i.replies.length&&e.each(i.replies,t)});void 0===b[this.f.getCurrentUser().getUsername()]&&(b[this.f.getCurrentUser().getUsername()]=this.f.getCurrentUser().getFullName());return b};i.prototype._deleteOneAnnotation=function(a){this._annotations.splice(e.indexOf(this._annotations,a),1);0<=e.indexOf(this._filteredAnnotations,
a)&&this._filteredAnnotations.splice(e.indexOf(this._filteredAnnotations,a),1);a.isNew||this._removedannotations.push(a)};i.prototype._renumberNewAnnotations=function(a){var b=this.getUnsavedAnnotations();e.each(b,e.bind(function(b){b.messagenumber>a&&(b.messagenumber-=1,b.updateIndicator())},this));this._emit("modelContentChanged")};i.prototype.deleteAnnotation=function(a){this.canDeleteAnnotation(a)?this.f.i18n.loadBundle("viewer",e.bind(function(){a.inreplyto?this._deleteAnnotationWithoutConfirmation(a):
(void 0===this._deleteAnnotationPopup&&(this._deleteAnnotationPopup=new g(this.f,"deleteAnnotationPopup",this.f.getContext()),this._deleteAnnotationPopup.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("DeleteAnnotBtnTT"))),this._deleteAnnotationPopup.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnDelete"))),this._deleteAnnotationPopup.setOkBtnText(this.f.i18n.t("YesResponse")),this._deleteAnnotationPopup.setCancelBtnText(this.f.i18n.t("NoResponse"))),
this._deleteAnnotationPopup.setOkAction(e.bind(function(){this._deleteAnnotationPopup.hide();this._deleteAnnotationWithoutConfirmation(a)},this)),this._deleteAnnotationPopup.show(),this._deleteAnnotationPopup.recalculateSize(400))},this)):this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.WARNING",this.f.i18n.t("AnnReadOnlyError"))},this)};i.prototype._deleteAnnotationWithoutConfirmation=function(a){if(a.parent){var b=e.indexOf(a.parent.replies,a);-1<b?a.parent.replies.splice(b,1):(b=e.indexOf(a.parent.states,
a),-1<b?a.parent.states.splice(b,1):-1<e.indexOf(a.parent.links,a)&&this._deleteAnnotationWithoutConfirmation(a.parent));a.isNew||this._removedannotations.push(a)}else this.unselectAllAnnotations(!0),e.each(a.links,function(a){this._deleteOneAnnotation(a)},this),this._deleteOneAnnotation(a),this._filterAllAnnotations(!0);this._emit("annotationDeleted",a);a.isNew&&this._renumberNewAnnotations(a.messagenumber);this.modelChanged()};i.prototype.reload=function(a){var b=e.bind(function(){this._emit("reload.started");
this.unselectAllAnnotations();this.resetAllAnnotations();this._page?(this.modelChanged(),this._page.reloadAnnotations(e.bind(function(a){a&&this.setAnnotations(this._page.getAnnotations());this.modelChanged();this._emit("reload.finished")},this))):this._emit("reload.finished")},this);a?b():this.promptToSaveUnsavedAnnotations(b,function(){},b)||b()};i.prototype.save=function(a,b){if(this._isSavingAnnotations)this.f.emit("error.WARNING",this.f.i18n.t("AnnAreAlreadyBeingSaved"),!0);else if(this._emit("save.started"),
this._isSavingAnnotations=!0,this.canChangeAnnotations()&&this._page){this.unselectAllAnnotations();e.each(this._annotations,function(a){if(a.hasUnsavedReply()){var b=a.getUnsavedReply();a.resetUnsavedReply();this.replyToAnnotation(a,b,!1)}},this);var i,g=this._removedannotations.slice(0);this._removedannotations=[];if(a){g=[];i=[];i.push(a);var c=a.getGodfather();e.each(c.links,function(a){!a.saved&&-1==e.indexOf(i,a)&&i.push(a)})}else i=this.getUnsavedAnnotations();this._page.saveAnnotations(i,
g,e.bind(function(a,e){this._isSavingAnnotations=!1;this._page==a&&this.setAnnotations(e);b&&b();this._emit("save.finished");this.modelChanged()},this,this._page))}else this._isSavingAnnotations=!1,this._emit("save.finished")};i.prototype.getUnsavedAnnotationCount=function(){var a=this.getUnsavedAnnotations().length,b=this.getDeletedAnnotations().length;return a+b};i.prototype.getUnsavedAnnotations=function(){var a=[];this.canChangeAnnotations(!0)&&e.each(this._annotations,e.bind(function(b){b.runThroughAnnotation(!0,
!0,!0,e.bind(function(b){(!b.saved||b.hasUnsavedReply())&&(-1==e.indexOf(a,b)&&this.canChangeAnnotation(b))&&a.push(b)},this));b=b.getGodfather();e.each(b.links,e.bind(function(b){(!b.saved||b.hasUnsavedReply())&&(-1==e.indexOf(a,b)&&this.canChangeAnnotation(b)&&!b.isStateObject())&&a.push(b)},this))},this));return a};i.prototype.getSavedAnnotations=function(){var a=[];e.each(this._annotations,function(b){b.saved&&a.push(b)});return a};i.prototype.getDeletedAnnotations=function(){return this._removedannotations};
i.prototype.getVisibleAnnotations=function(){return 0===this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")||this.isTemporarilyDisabledAndNoAnnotationsVisible()?[]:this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")&&0<this._selectedAnnotations.length?this._selectedAnnotations:this._filteredAnnotations};i.prototype.getFilteredAnnotations=function(){return this._filteredAnnotations};i.prototype.selectAnnotation=function(a,b){var e;if(!(1===this._selectedAnnotations.length&&a==this._selectedAnnotations[0])){this.unselectAllAnnotations(!0,
b);this._selectedAnnotations.push(a);var i=a.getGodfather();if(i.links)for(e=0;e<i.links.length;e++)this._selectedAnnotations.push(i.links[e]);if(a.linkedto&&(a=this.getAnnotation(a.linkedto))){for(e=0;e<a.links.length;e++)a.links[e]!=a&&this._selectedAnnotations.push(a.links[e]);this._selectedAnnotations.push(a)}this.ensureVisibility();this._layoutType==p.LayoutType.MOBILE&&this.f.emit("module.annotation.zoomToAnnotation",a);this._emit("selectedAnnotation",a);this.modelChanged()}};i.prototype.ensureVisibility=
function(){this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")||this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1)};i.prototype.getAnnotation=function(a){for(var b=0;b<this._annotations.length;b++)if(this._annotations[b].name==a)return this._annotations[b];return null};i.prototype.getAnnotationLinks=function(a){var b,e=[];if(a.links)for(b=0;b<a.links.length;b++)e.push(a.links[b]);if(a.linkedto)for(b=0;b<this._annotations.length;b++)this._annotations[b].name==a.linkedto&&e.push(this._annotations[b]);
return e};i.prototype.getReplies=function(a){var b=[];a.runThroughAnnotation(!1,!0,!1,function(a){b.push(a)});return b};i.prototype.unselectAllAnnotations=function(a,b){if(!(0>=this._selectedAnnotations.length||this.lockSelection&&!b)){var i=this._selectedAnnotations;this._selectedAnnotations=[];e.each(i,e.bind(function(a){this._emit("unselectedAnnotation",a)},this));a||this.modelChanged()}};i.prototype.resetAllAnnotations=function(){this.scaleAllAnnotations(null);this.unselectAllAnnotations();this._annotations=
[];this._removedannotations=[];this._page.resetAnnotations()};i.prototype.isAnnotationOrReplySelected=function(a){return null!==a?-1<e.indexOf(this._selectedAnnotations,a)?!0:0===a.replies.length?!1:e.some(a.replies,e.bind(function(a){return-1<e.indexOf(this._selectedAnnotations,a)},this)):!1};i.prototype.getSelectedAnnotations=function(){return this._selectedAnnotations};i.prototype.moveAnnotation=function(a,b){if(!this.canChangeAnnotation(a))return!1;a.move(b);this.modelChanged();return!0};i.prototype.transformAnnotation=
function(a,b){if(!this.canChangeAnnotation(a))return!1;a.setRect(b);this.modelChanged();return!0};i.prototype.updateStartEndOfAnnotation=function(a,b,e){if(!this.canChangeAnnotation(a))return!1;a.setStartEnd(b,e);this.modelChanged();return!0};i.prototype.addAnnotationWithRect=function(a,b,e){var i;i=this.f.getProperty("annotationcolor")?this.f.getProperty("annotationcolor"):this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");var g=new j(this.f);g.initAnnotation(e,i,!1,this,
a);b&&(g.content=b);this.addAnnotation(g)};i.prototype._nextNumberForOriginType=function(a){for(var b=0,e=0;e<this._annotations.length;e++)this._annotations[e].messagenumber>b&&this._annotations[e].originType===a&&(b=this._annotations[e].messagenumber);b++;return b};i.prototype.addAnnotation=function(a,b,i){if(this.checkCanChangeAnnotationsAndDisplayError())if(a.linkedto||(a.messagenumber=this._nextNumberForOriginType(a.originType)),a.username=this.f.getCurrentUser().getUsername(),a.firstname=this.f.getCurrentUser().getFirstName(),
a.lastname=this.f.getCurrentUser().getLastName(),a.creationdate=new Date,a.date=new Date,a.setModified("NEW"),this.ensureVisibility(),b)i||this.modelChanged(b,a);else{this._annotations.push(a);this._filterAllAnnotations(!0);var b=this._filter.compliesToFilter(a),g=!0;this._annotationFilterModel.isCustomFilterActive()&&(g=this._filter.compliesToCustomFilter(a));b&&g?(!a.linkedto&&!i&&this._emit("annotationAdded",a,!1),this._filteredAnnotations.push(a),i||this.selectAnnotation(a)):(i||this._emit("annotationAdded",
a,!0),this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("AnnNotViewable"),e.bind(function(){this._annotationFilterModel.resetFilter()},this))},this))}};i.prototype.addLinkedAnnotation=function(a,b){var e=b||this.getSelectedAnnotations()[0];e?this.canChangeAnnotation(e)?this.checkCanChangeAnnotationsAndDisplayError()&&(e=e.getGodfather(),e.linkedto&&(e=this.getAnnotation(e.linkedto)),a.linkedto=e.name,a.parent=e,e.links.push(a),a.messagenumber=e.messagenumber,
this.addAnnotation(a),a.annotationcolor=e.annotationcolor,a.color=e.color,this.selectAnnotation(e,!0)):this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("AnnCannotAddLinkedToNonOwnedAnnotation"),!0)},this):this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("NoAnnotationSelected"),!0)},this)};i.prototype.replyToAnnotation=function(a,b,i){if(this.checkCanChangeAnnotationsAndDisplayError()){a.resetUnsavedReply();var g=a.duplicate(!1,
!1,!1,!1,this);g.inreplyto=a.name;g.content=b;g.parent=a;a.replies.push(g);this.addAnnotation(g,a);i&&this.save(null,e.bind(function(){this.selectAnnotation(a,!0);g.cancelModified();g.setIsNew(!1)},this))}else a.resetUnsavedReply(),this.modelChanged()};i.prototype.setState=function(a,b){this.checkCanChangeAnnotationsAndDisplayError()&&this.f.i18n.loadBundle("viewer",e.bind(function(){var e="<p>"+this.f.i18n.t("AnnStatusSetByText",b,this.f.getCurrentUser().getFullName())+"</p>",i=a.getUserStateAnnotation(this.f.getCurrentUser().getUsername());
i?i.state!=b&&(i.state=b,i.content=e,i.setModified("STATE"),this.modelChanged(a)):(i=a.duplicate(!1,!1,!1,!1,this),i.inreplyto=a.name,i.content=e,i.parent=a,i.state=b,i.statemodel="Review",i.parent=a,i.linkedto=a.name,a.states.push(i),this.addAnnotation(i,a))},this))};i.prototype.checkCanChangeAnnotationsAndDisplayError=function(){if(this.canChangeAnnotations())return!0;0<this.getDisabledReason().length&&this.f.emit("userMessage","warn",this.getDisabledReason());return!1};i.prototype.modelChanged=
function(a,b){(b||a)&&this._emit("annotationUpdated",a,b);this._emit("modelChanged")};i.prototype.modelContentChanged=function(){this._orderedAnnotations.length=0;this._emit("modelContentChanged")};i.prototype.filterChanged=function(){this._emit("filterChanged")};i.prototype.orderByModificationDate=function(){this._filteredAnnotations=e.sortBy(this._filteredAnnotations,function(a){var b=new Date(0);a.runThroughAnnotation(!0,!0,!0,function(a){a.date>b&&(b=a.date)});return b});this.currentOrdening=
this.orderByModificationDate};i.prototype.orderByCreationDate=function(){this._filteredAnnotations=e.sortBy(this._filteredAnnotations,function(a){return a.creationdate});this.currentOrdening=this.orderByCreationDate};i.prototype.orderAnnotationsForStep=function(){var a=this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===k.AnnotationSortType.SORT_BY_CREATION_DATE,b=[];0===this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")?e.each(this._filteredAnnotations,function(a){a.runThroughAnnotation(!0,
!0,!1,function(a){b.push(a)})}):3===this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")?e.each(this._filteredAnnotations,function(a){b.push(a);b=b.concat(this.getAnnotationLinks(a))},this):b=this._filteredAnnotations;this._orderedAnnotations=e.sortBy(b,function(b){return a?-b.creationdate:-b.date});this._currentAnnotationIndex=e.indexOf(this._orderedAnnotations,this._selectedAnnotations[0])};i.prototype.getNextAnnotation=function(){0===this._orderedAnnotations.length&&this.orderAnnotationsForStep();
0<this._selectedAnnotations.length&&(this._currentAnnotationIndex=e.indexOf(this._orderedAnnotations,this._selectedAnnotations[0]));return this._orderedAnnotations[++this._currentAnnotationIndex%this._orderedAnnotations.length]};i.prototype.getPreviousAnnotation=function(){0===this._orderedAnnotations.length&&this.orderAnnotationsForStep();0<this._selectedAnnotations.length&&(this._currentAnnotationIndex=e.indexOf(this._orderedAnnotations,this._selectedAnnotations[0]));0>--this._currentAnnotationIndex&&
(this._currentAnnotationIndex=this._orderedAnnotations.length-1);return this._orderedAnnotations[this._currentAnnotationIndex%this._orderedAnnotations.length]};i.prototype.goToAnnotation=function(a){a=a?this.getNextAnnotation():this.getPreviousAnnotation();this.selectAnnotation(a,!0);var b=this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE");(2===b||3===b)&&this.f.emit("module.annotation.zoomToAnnotation",a)};i.prototype.updateAllAnnotationColors=function(){var a=this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR"),
b=this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");e.each(this._annotations,e.bind(function(e){this.canChangeAnnotation(e)&&(e.annottype==k.AnnotationType.ANNOT_PIN?e.setColor(a):e.setColor(b),this._emit("annotationUpdated",e))},this));this.modelChanged()};i.prototype.setSortingMode=function(a,b){a===k.AnnotationSortType.SORT_BY_CREATION_DATE?this.orderByCreationDate():a===k.AnnotationSortType.SORT_BY_MODIFICATION_DATE&&this.orderByModificationDate();b||this.filterChanged()};
i.prototype.generateUniqueName=function(){for(var a=100,b;void 0===b&&0<a;){var i=n.randomString(22);void 0===e.find(this._annotations,function(a){return a.name===i})&&(b=i);a--}void 0===b&&this.f.emit("error.SEVERE","Error while generating ID for new annotation");return b};i.prototype.setPage=function(a,b){if(a!=this._page){var i=this._page;this._approvalUpdatedListener&&i&&(i.getDocumentVersion().isPageList()?i.off("approval.loaded",this._approvalUpdatedListener):i.getDocumentVersion().off("approval.update",
this._approvalUpdatedListener));this.setAnnotations([]);this._emit("changed.page");this.unselectAllAnnotations(!1,!0);this._page=a;this._addAnnotationsEnabledListener&&this._unregisterListener(this._addAnnotationsEnabledListener);this._disabledReasonChangedListener&&this._unregisterListener(this._disabledReasonChangedListener);this._clearDisableReasons();a&&a.whenParametersAvailable(function(){a.requestAnnotations(e.bind(function(e){this._page=a;this.f.loadBundle("viewer",function(){a.canChangeAnnotations()?
this.removeDisableReason("CANCHANGEANNOTATIONS"):this.setDisableReason("CANCHANGEANNOTATIONS",this.f.t("AnnReadOnlyCannotChangeAnnotations"));a.getDocumentVersion().isLatestVersion()?this.removeDisableReason("NOT_LATEST"):this.setDisableReason("NOT_LATEST",this.f.t("AnnReadOnlyNotLatestVersion"))},this);e?(this.setAnnotations(a.getAnnotations()),this._checkForZoomToAnnotation(),0===this.getAnnotationCount()&&"1"===this.f.getConfig().get("annotationaddglobal")&&(0<this.getDisabledReason().length||
!this.canChangeAnnotations()?(this._addAnnotationsEnabledListener=this._registerListener("readWriteChanged",function(){0===this.getDisabledReason().length&&(this.canChangeAnnotations()&&0===this.getAnnotationCount())&&(this._emit("addGlobalAnnotation"),this._unregisterListener(this._addAnnotationsEnabledListener),this._unregisterListener(this._disabledReasonChangedListener))},this,this),this._disabledReasonChangedListener=this._registerListener("disabledReasonChanged",function(){0===this.getDisabledReason().length&&
(this.canChangeAnnotations()&&0===this.getAnnotationCount())&&(this._emit("addGlobalAnnotation"),this._unregisterListener(this._addAnnotationsEnabledListener),this._unregisterListener(this._disabledReasonChangedListener))},this,this)):this._emit("addGlobalAnnotation"))):this.f.debug.error("Annotations were NOT fetched succesfully");this.updateTemporarilyDisabledReason();b&&b()},this))},this);this._appovalUpdatedListener||(this._approvalUpdatedListener=e.bind(function(a){this.onApprovalUpdated(a)},
this));this.editabilityDependsOnApproval()&&(this.f.loadBundle("viewer",function(){this.setDisableReason("LOADING_APPROVAL",this.f.t("Loading"))},this),this.f.requestModule("approval",e.bind(function(){var b=a.getDocumentVersion();b.isPageList()?(a.on("approval.loaded",this._approvalUpdatedListener),a.requestPageApprovalSetup(this._approvalUpdatedListener)):(b.on("approval.update",this._approvalUpdatedListener),b.requestApprovalSetup(this._approvalUpdatedListener))},this)))}else void 0!==b&&b();this._annotationFilterModel.isAnnotationFilterPinned()||
this._annotationFilterModel.resetFilter();this.modelChanged()};i.prototype.getPage=function(){return this._page};i.prototype.getAnnotationsOffset=function(){return this._page.getAnnotationsOffset()};i.prototype.getDisabledReason=function(){if(0<this._disabledReasons.getLength()){var a=this._disabledReasons.getLast().reason;""===a&&e.some(this._disabledReasons.getItemsAsObject(),function(b){a=b.reason;return""!==a});return a}return""};i.prototype.setDisableReason=function(a,b,e,i){this._disabledReasons.addOrReplaceItem(a,
{reason:b,hideAnnotations:e,dontRemove:i});this._disabledReasons.moveItemByKeyToEnd(a);this._emit("disabledReasonChanged")};i.prototype.removeDisableReason=function(a){this._disabledReasons.removeByKey(a);this._emit("disabledReasonChanged")};i.prototype._clearDisableReasons=function(){var a=[];e.each(this._disabledReasons.getKeys(),function(b){this._disabledReasons.getItemByKey(b).dontRemove&&a.push(b)},this);this._disabledReasons.omitOthers(a);this._emit("disabledReasonChanged")};i.prototype.promptToSaveUnsavedAnnotations=
function(a,b,i){void 0===b&&(b=a);return this._page&&0<this.getUnsavedAnnotationCount()&&this.canChangeAnnotations(!0)?(this.f.loadBundle("viewer",function(){var c=new g(this.f,"unsavedAnnotationsPopup",this.f.getContext());c.setRemoveFromDomAfterUsage(!0);c.setOkAction(e.bind(function(){c.enableOkBtn(!1);this.save(null,e.bind(function(){c.hide();a&&a();this.toggleVisibility(!0)},this))},this));c.setCancelAction(e.bind(function(){b&&b();this.toggleVisibility(!0)},this));if(i){var f=new m(this.f,"dontSaveAnnotations",
$("<span>").append(this.f.t("RevertAnnChanges")),!1,e.bind(function(){c.hide();this.toggleVisibility(!0);i&&i()},this));c.addButton(f)}c.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("AnnTitle")));c.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnSavePrompt")));c.setOkBtnText(this.f.i18n.t("Save"));this.toggleVisibility(!1);c.show();c.recalculateSize(600)},this),!0):!1};i.prototype.setLockSelection=function(a){this.lockSelection=a};i.prototype.setLayoutType=
function(a){this._layoutType=a};i.prototype.getLayoutType=function(){return this._layoutType};i.prototype.scaleAllAnnotations=function(a){this._currentScaling&&e.each(this._annotations,function(a){a.isScaled()&&a.scale(new f.Point(1/a.getScale().x,1/a.getScale().y))},this);this._currentScaling=a;e.each(this._annotations,function(b){b.setScale(a)})};i.prototype.getCurrentScaling=function(){return this._currentScaling};i.prototype.getAnnotationFilterModel=function(){return this._annotationFilterModel};
i.prototype._checkForZoomToAnnotation=function(){var a=this.f.getProperty("AnnotationModel.zoom");if(a){var b=this.getAnnotation(a.annotationName);b&&(this._zoomToAnnotationListener&&this._unregisterListener(this._zoomToAnnotationListener),this.unselectAllAnnotations(!0,!0),this.f.emit("module.annotation.zoomToAnnotation",b,!a.animation,!a.select),this._zoomToAnnotationListener=this._registerListener("widget.ViewportWidget.repainted",e.bind(function(){this.unselectAllAnnotations(!0,!0);this.f.emit("module.annotation.zoomToAnnotation",
b,!a.animation,!a.select);this._unregisterListener(this._zoomToAnnotationListener);this._zoomToAnnotationListener=null},this),this))}};return i});
define("web-viewer/annotation/AnnotationLayerModel",["web-viewer/viewport/model/ViewportLayerModel","utils/ShapeUtils","web-viewer/utils/ListenerUtil","web-viewer/viewControls/ViewControlsConstants","underscore"],function(d,l,j,k,h){k=function(f,c,h){d.call(this,f,c);j.mixin(this,f);this.f=f;this.annotationModel=h;this._registerListener("modelChanged",this._calculateTransformation,this,this.annotationModel);this._registerListener("modelContentChanged",this.modelChanged,this,this.annotationModel);
this._registerListener("parameters.changed",this._calculateTransformation,this,this.f.getDocumentController());this._registerListener("transform.viewportWidget.transformChanged",this._calculateTransformation,this)};k.prototype=Object.create(d.prototype);k.prototype.constructor=k;k.prototype._calculateTransformation=function(){var f=this.annotationModel.getAnnotationsPage();if(null!==f&&void 0!==f){this.resetTransformation();this.getTransform().scale(1,-1);var c=f.getRotation(),d=this.f.getModule("viewport").getWorldBounds(),
g=new l.Size;g.add(this.annotationModel.getAnnotationsOffset());this.calculateTransformation(d,f.getPageSize(),g,c,f.isFlipped())}this.modelChanged()};k.prototype.getLinework=function(f,c){var d=this.annotationModel.getVisibleAnnotations(),g=[];h.each(d,function(b){h.each(b.links,function(a){g.push(a)})});for(var d=h.union(d,g),m=[],p=this.f.getOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE")&&!c,b=0;b<d.length;b++){var e=d[b];this.annotationModel.isAnnotationOrReplySelected(e)?(e.setSelected(!0),
e.needsSelectionBox()&&this.annotationModel.canChangeAnnotation(e)&&(m[b]=e.getSelectionBox())):e.setSelected(!1);p?(e.updateIndicator(),e.showIndicator=!0):e.showIndicator=!1}return h.union(d,g,h.without(h.flatten(m),void 0,null))};return k});
define("web-viewer/viewport/model/ViewportPopupModel",["underscore","web-viewer/core/PrivateChannel"],function(){var d=function(d,j){this.f=d;this.id=j;this.shown=!0};d.prototype.getId=function(){return this.id};d.prototype.show=function(){this.shown=!0};d.prototype.hide=function(){this.shown=!1};d.prototype.isShown=function(){return this.shown};d.prototype.getPopup=function(){};d.prototype.onDestroy=function(){};d.prototype.getWorldOrigin=function(){};d.prototype.getWorldSize=function(){};d.prototype.getSceneOffset=
function(){};d.prototype.onResized=function(){};d.prototype.onDragged=function(){};return d});
define("web-viewer/annotation/AnnotationPopup",["web-viewer/annotation/AnnotationConstants","web-viewer/layout/component/Popup","web-viewer/layout/component/MiniButton","jquery","underscore"],function(d,l,j,k,h){var f=function(c,f,g,d){this.f=c;l.call(this,c,f,d);this.annotation=g;this.element.addClass("annotationPopup");this.annotationNumber=k("<span />").addClass("annotationNumber");this.icon=k("<i />");this.title=k("<span />").addClass("annotationTitle")};f.prototype=Object.create(l.prototype);
f.prototype.constructor=f;f.prototype._initialize=function(){this._isInitialized||(l.prototype._initialize.call(this),this.headerWrapper.addClass("annotationPopupHeader"),this.header.append(this.annotationNumber),this.header.append(this.icon),this.header.append(this.title),this.pinIcon=new j(this.f,"pin","pinned icon-WCR_Pin12",!0,h.bind(function(c){this._emit("pinned",!this.annotation.popupIsOpen);c.stopPropagation()},this)),this.headerIcons.prepend(this.pinIcon.element),f.prototype.repaint.call(this))};
f.prototype.repaint=function(){this._isInitialized&&(this.annotation.popupIsOpen?(this.pinIcon.setIcon("pinned icon-WCR_Pin12"),this.pinIcon.setTooltip("viewer","UnpinPopupTT")):(this.pinIcon.setIcon("unpinned icon-WCR_Pin12"),this.pinIcon.setTooltip("viewer","PinPopupTT")),this.setAnnotationNumber(this.annotation.messagenumber),this.annotationNumber.css({color:this.annotation.getHeaderTextColor(),"background-color":this.annotation.annotationcolor}),this.setTitle(this.annotation.getUserName()),this.setIcon(d.AnnotationIcons[this.annotation.annottype]))};
f.prototype.setTitle=function(c){this.title.text(c)};f.prototype.remove=function(){this.removeAllListeners("pinned");l.prototype.remove.call(this)};f.prototype.setIcon=function(c){this.icon.removeClass().addClass("icon").addClass(c)};f.prototype.setAnnotationNumber=function(c){this.annotationNumber.text(c)};return f});
define("web-viewer/layout/component/RichTextEditor",["web-viewer/utils/ViewerUtils","jquery","underscore"],function(d,l,j){var k=function(h){this.f=h;this.onTextChangeCallbacks=[];this.id=d.generateUniqueDOMId("richText_");this.element=l("<div />").addClass("richText").attr("id",this.id);this.element.data("richTextObj",this);this.titleBar=l("<h3 />").addClass("title");this.titleBar.hide();this.actionBar=l("<div />").addClass("actionBar").addClass("clearfix");this.textAreaDiv=l("<div />").addClass("wrapper");
this.textArea=l("<textarea />").addClass("text");this.textAreaId="textArea_"+this.id;this.textArea.attr("id",this.textAreaId);this.initialized=!1;this.element.append(this.titleBar).append(this.textAreaDiv.append(this.textArea)).append(this.actionBar);this._fireTextChanges=!0};k.prototype.setContent=function(){};k.prototype.getContent=function(){return""};k.prototype.setButtons=function(d){this.actionBar.empty();j.each(d,function(f){f&&this.actionBar.append(f.element)},this)};k.prototype.setTitle=
function(d){this.titleBar.text(d);this.titleBar.show()};k.prototype.init=function(){};k.prototype._fireTextChanged=function(){this._shouldFireTextChanged()&&j.each(this.onTextChangeCallbacks,function(d){d()})};k.prototype._shouldFireTextChanged=function(){return this._fireTextChanges};k.prototype.isInitialized=function(){return this.initialized};k.prototype.destroy=function(){};k.prototype.onTextChanged=function(d){this.onTextChangeCallbacks.push(d)};k.prototype.beforeDetach=function(){};k.prototype.repair=
function(){};k.prototype.setHeight=function(d){this.isInitialized()&&(d-=this.actionBar.outerHeight(!0),d=Math.max(d,80),this.textAreaDiv.css("height",d))};return k});
define("web-viewer/layout/component/RichTextEditorTextarea",["web-viewer/layout/component/RichTextEditor","web-viewer/utils/ViewerUtils","utils/ConvertUtils","jquery","underscore"],function(d,l,j,k,h){l=function(f){d.call(this,f)};l.prototype=Object.create(d.prototype);l.prototype.constructor=l;l.prototype.setContent=function(f){this.textArea.val(j.convertHTMLStringToRaw(f))};l.prototype.getContent=function(){return this.isInitialized()?"<html><body>"+j.convertRawStringToHTML(this.textArea.val())+
"</body></html>":""};l.prototype.init=function(f){this.initialized?(f&&f(),this.textArea.focus()):(this.initialized=!0,this.textArea.on("keyup change",h.bind(this._fireTextChanged,this)),this.textArea.focus(),f&&f())};l.prototype.destroy=function(){this.textArea.off("keyup change");this.initialized=!1};return l});
define("web-viewer/layout/component/RichTextEditorTinyMCE",["web-viewer/layout/component/RichTextEditor","web-viewer/utils/ViewerUtils","tinyMCE","jquery","underscore"],function(d,l,j,k){var h="br cn cz de en es fr hu hr it jp nl pl ru th tr tw".split(" "),f=[],l=function(c){d.call(this,c);this.editor=void 0;this._cssContentFile="../wcr-static/web-viewer/layout/component/less/tinymce/tinymce_content_"+c.getLayoutType()+".css"};l.prototype=Object.create(d.prototype);l.prototype.constructor=Object.create(l);
l.prototype.setContent=function(c){this.textArea.val(c);this.initialized&&this.editor.setContent(c)};l.prototype.getContent=function(){return this.initialized?this.editor.getContent():""};l.prototype.init=function(c){if(this.initialized)c&&c(),this.editor.focus();else{var d=this.f.getCurrentUser().getLocale();_.contains(h,d)?this._initMCE(c,d):_.contains(f,d)?this._initMCE(c,"en"):this.f.ajax(requirejs.toUrl("lib/tinymce/langs/"+d+".js"),{dataType:"text",timeout:2E3,success:_.bind(function(){h.push(d);
this._initMCE(c,d)},this),error:_.bind(function(){f.push(d);this._initMCE(c,"en")},this)})}};l.prototype._initMCE=function(c,d){j.init({selector:"#"+this.textAreaId,menubar:!1,statusbar:!1,plugins:"paste fullpage",toolbar:"bold italic underline strikethrough | subscript superscript | undo redo",toolbar_items_size:"small",skin:"lightgrayflat",content_css:this._cssContentFile,element_format:"xhtml",doctype:"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>",
fullpage_default_doctype:"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>",inline_styles:!0,language:d,valid_elements:"p[style],p[style]/li,div,span[style],span[style],br,nobr,sub,sup,strike/s,strong/b,i,u,s,a,h?,big,small,font,tt,code,var,kbd,em,samp,center,a[href|title|style]",auto_focus:this.textAreaId,setup:_.bind(function(g){this.editor=g;g.on("keyup",_.bind(function(){this._fireTextChanged()},this));g.on("redo",_.bind(function(){this._fireTextChanged()},
this));g.on("undo",_.bind(function(){this._fireTextChanged()},this));g.on("change",_.bind(function(){this._fireTextChanged()},this));g.on("init",_.bind(function(){this.initialized=!0;c&&c()},this))},this),paste_preprocess:function(g,c){c.content=c.content.replace(/<(\/)?table[^>]*>/gi,"<$1div>");c.content=c.content.replace(/<(\/)?tr[^>]*>/gi,"<$1p>");c.content=c.content.replace(/<th[^>]*>/gi,"<span><strong>");c.content=c.content.replace(/<\/th[^>]*>/gi,"</strong></span>&nbsp;");c.content=c.content.replace(/<td[^>]*>/gi,
"<span>");c.content=c.content.replace(/<\/td[^>]*>/gi,"</span>&nbsp;")},height:"100%"})};l.prototype._shouldFireTextChanged=function(){return this.editor&&this.editor.isDirty()&&this._fireTextChanges};l.prototype.destroy=function(){this.initialized&&this.editor.destroy();this.initialized=!1};l.prototype.beforeDetach=function(){this.isInitialized()&&(this._fireTextChanges=!1,this.destroy(),this._fireTextChanges=!0)};l.prototype.repair=function(){this.init()};l.prototype.setHeight=function(c){if(this.isInitialized()){var d=
this.textAreaDiv.find(".mce-toolbar-grp").outerHeight(!0);4!==d%26&&(d=30);c=c-this.actionBar.outerHeight(!0)-d;c=Math.max(c,80);k("#"+this.textAreaId+"_ifr").css("height",c)}};return l});define("web-viewer/layout/component/RichTextEditorFactory",["web-viewer/layout/component/RichTextEditorTextarea","web-viewer/layout/component/RichTextEditorTinyMCE"],function(d,l){return{createEditor:function(j){return j.getFeatureDetector().isIOS()?new d(j):new l(j)}}});
define("web-viewer/annotation/AnnotationCharLineCount",["web-viewer/utils/ViewerUtils","component/tooltip/Tooltip","utils/ConvertUtils","jquery","underscore"],function(d,l,j,k){d=function(d){this.element=k("<div />").addClass("charLineCount");this.showing=!1;this.f=d;this.tooltip=null};d.prototype.update=function(d){this.showing&&(d=j.getCharacterLineCount(d),this.element.text(d.charCount+"/"+d.lineCount),this.tooltip?this.tooltip.setTooltipContent("viewer","charLineCount",[d.charCount,d.lineCount]):
this.tooltip=new l(this.f.i18n,this.element,this.f.getContext(),this.f.getContext(),this.f.isMobile(),"viewer","charLineCount",[d.charCount,d.lineCount]))};d.prototype.show=function(){this.element.show();this.showing=!0};d.prototype.hide=function(){this.element.hide();this.showing=!1};return d});
define("web-viewer/layout/AutoTimeLabel",["component/tooltip/Tooltip","web-viewer/utils/ViewerUtils","utils/ConvertUtils","jquery"],function(d,l,j,k){return function(h,f){function c(c){var g=Math.floor(((new Date).getTime()-c.getTime())/1E3),d=Math.floor(g/86400),g=g-86400*d,f=Math.floor(g/3600),g=Math.floor((g-3600*f)/60),b,e=null;0<d?1==d?e=h.i18n.t("dateYesterday"):5>d?b=d+h.i18n.t("daysAbbreviation"):e=j.getLangFormattedDate(h.i18n,c):0<f?b=f+h.i18n.t("hoursAbbreviation"):0<g?b=g+h.i18n.t("minutesAbbreviation"):
(h.i18n.t("secondsAbbreviation"),b="< 1"+h.i18n.t("minutesAbbreviation"));return e?e:h.i18n.t("timeAgo",b)}this.editOnTop=!0;this.element=k("<span>");this.date=f;this.tooltip=new d(h.i18n,this.element,h.getContext(),h.getContext(),h.isMobile(),j.getLangFormattedDateAndTime(h.i18n,this.date));this.updateText=function(d){h.i18n.loadBundle("viewer",_.bind(function(){this.element.text(c(this.date));var g="",g=d?h.i18n.t("createdOn"):h.i18n.t("modifiedOn");this.tooltip.setTooltipContent(g+j.getLangFormattedDateAndTime(h.i18n,
this.date))},this))};this.updateText()}});
define("web-viewer/annotation/AnnotationSingleRow","web-viewer/layout/AutoTimeLabel web-viewer/annotation/AnnotationConstants web-viewer/annotation/AnnotationCharLineCount web-viewer/layout/component/MiniButton web-viewer/layout/component/DropdownMiniButton web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup component/tooltip/Tooltip web-viewer/layout/component/RichTextEditorFactory web-viewer/layout/component/ColorPicker jquery underscore HTMLTruncator".split(" "),function(d,
l,j,k,h,f,c,n,g,m,p,b){var e=function(e,a,g,m,n,q,v){this.element=p("<div/>").addClass(g?"main":"reply");this.selected=!1;this.f=e;this._MAX_CHARS=300;this._hideHeader=n;this._annotation=a;this._main=g;this._annotationModel=m;this._isForMobile=v;this._visible=!0;this._hideHeader||(e=p("<div/>").addClass("annotHeader"),this.element.append(e),this._main&&e.append(p("<i>").addClass("icon").addClass(this._annotation.getIconClass())),g=p("<span />").addClass("userName").text(this._annotation.getUserName()),
e.append(g),this._main&&!this._isForMobile&&(this._view3D=new h(this.f,"3DView","icon icon-WCR_Actions-3D12"),this._view3D.setTooltip("viewer","annot3DView"),e.append(this._view3D.element.addClass("view3d"))),this._timelabel=new d(this.f,this._annotation.date),this._timelabel.element.addClass("date").addClass("pull-right"),e.append(this._timelabel.element),this.updateTimer=b.bind(function(){this._timelabel.date=this._annotation.date;this._timelabel.updateText(this._annotation.isAnnotationModified())},
this));this._content=p("<div/>").addClass("annotContent");this.element.append(this._content);this._actionsDiv=p("<div/>").addClass("annotActions").addClass("clearfix");this._moreActions=new h(this.f,"moreActions","icon-WCR_More-horizontal");this._moreActions.addButtonClass("annotAction");this._moreActions.setTooltip("viewer","moreActions");this._annotationColorPicker=this._richTextEditor=void 0;this._actionsDiv.append(this._moreActions.element);var w=new f(this.f,"saveEdit","icon-WCR_Save12 marginRight5",
!0,b.bind(function(a){this._annotation.content=this._richTextEditor.getContent();this._annotation.setModified("CONTENT");this._annotationModel.save();this.closeRichText();a.stopPropagation()},this)),x=new f(this.f,"cancelReply","icon-WCR_Revert12 marginRight5",!0,b.bind(function(a){this._annotation.resetAnnotationColor();this._annotationModel.modelChanged(this._annotation);this._annotation.cancelModifiedColor();this._richTextEditor.setContent("");this._annotation.cancelModified("CONTENT");this._annotationModel.modelChanged();
this.closeRichText();a.stopPropagation()},this));this._editActionsGroup=new c("editActionsGroup",[x,w]);this._editActionsGroup.element.addClass("pull-right");a.getPermissionFor(l.ActionPermissions.DUPLICATE_WITHOUT_TEXT)&&(this._duplicateWithoutText=new k(this.f,"annotationCopyWithoutText","icon-WCR_Annotation-Duplicate-NoText",!0,b.bind(function(a){this.f.emit("module.annotation.duplicateWithoutText",this._annotation);a.stopPropagation()},this)),this._duplicateWithoutText.addButtonClass("annotAction"),
this._duplicateWithoutText.setTooltip("viewer","DuplicateWithoutTextAnnotBtnTT"),this._actionsDiv.append(this._duplicateWithoutText.element));a.getPermissionFor(l.ActionPermissions.DUPLICATE)&&(this._duplicateAction=new k(this.f,"annotationDuplicate","icon-WCR_Annotation-Duplicate",!0,b.bind(function(a){this.f.emit("module.annotation.duplicateAnnotation",this._annotation);a.stopPropagation()},this)),this._duplicateAction.addButtonClass("annotAction"),this._annotation.originType===l.AnnotationOriginTypes.user.id?
this._duplicateAction.setTooltip("viewer","DuplicateAnnotBtnTT"):this._duplicateAction.setTooltip("viewer","DuplicateToUserAnnotBtnTT"),this._actionsDiv.append(this._duplicateAction.element));this._main&&(this._isForMobile&&(this._view3DMobile=new k(this.f,"3DView","icon icon-WCR_Actions-3D12",!0,b.bind(function(){this.f.emit("module.annotation.show3DView",this._annotation)},this)),this._view3DMobile.addButtonClass("annotAction"),this._view3DMobile.setTooltip("viewer","annot3DView"),this._actionsDiv.append(this._view3DMobile.element)),
this._zoomAction=new k(this.f,"annotationZoom","icon-WCR_ZoomFit",!0,b.bind(function(a){this.f.emit("module.annotation.zoomToAnnotation",this._annotation);a.stopPropagation()},this)),this._zoomAction.addButtonClass("annotAction"),this._zoomAction.setTooltip("viewer","ZoomAnnotBtnTT"),this._actionsDiv.append(this._zoomAction.element));this._statusAction=new h(this.f,"setReviewStatus","icon-WCR_Approve-submenu");this._statusAction.addButtonClass("annotAction");this._statusAction.setTooltip("viewer",
"SetReviewStateBtnTT");this._actionsDiv.append(this._statusAction.element);this._isForMobile&&void 0!==q&&this._actionsDiv.append(q);this._charLineCount=new j(this.f);this._actionsDiv.append(this._charLineCount.element);this.element.append(this._actionsDiv);this._reviews=p("<ul/>").addClass("Review").hide();this.element.append(this._reviews);this.element.mouseenter(b.bind(function(){this.mouseEntered=!0;this.showOrHideOptions()},this)).mouseleave(b.bind(function(){this.mouseEntered=!1;this.showOrHideOptions()},
this));this.f.i18n.loadBundle("viewer",b.bind(function(){this._moreActions.addAction({name:"annotationEdit",content:this.f.i18n.t("EditAnnotBtnTT"),icon:"icon-WCR_Annotate",action:b.bind(function(){this._annotation.isNew?this._annotationModel.selectAnnotation(this._annotation,!0):(this._initializeRichTextEditor(),this._richTextEditor.isInitialized()||(this._content.after(this._richTextEditor.element),this._richTextEditor.element.trigger("makeMeVisible")),this._richTextEditor.element.show(),this._content.hide(),
this._actionsDiv.hide(),this._charLineCount.element.insertAfter(this._editActionsGroup.element),this._richTextEditor.setContent("<html>"+this._annotation.content+"</html>"),this.updateColorPicker(),this._richTextEditor.init())},this)});this._moreActions.addAction({name:"duplicateAnnotation",content:this.f.i18n.t("DuplicateAnnotBtnTT"),icon:"icon-WCR_Annotation-Duplicate",action:b.bind(function(a){a.which&&(this.f.emit("module.annotation.duplicateAnnotation",this._annotation),a.stopPropagation())},
this)});this._annotation.getPermissionFor(l.ActionPermissions.DUPLICATE_WITHOUT_TEXT)&&this._moreActions.addAction({name:"duplicateWithoutText",content:this.f.i18n.t("DuplicateWithoutTextAnnotBtnTT"),icon:"icon-WCR_Annotation-Duplicate-NoText",action:b.bind(function(a){a.which&&(this.f.emit("module.annotation.duplicateWithoutText",this._annotation),a.stopPropagation())},this)});this._moreActions.addAction({name:"annotationSave",content:this.f.i18n.t("SaveAnnotBtnTT"),icon:"icon-WCR_Save",action:b.bind(function(){this._annotationModel.save()},
this)});this._moreActions.addAction({name:"annotationDelete",content:this.f.i18n.t("DeleteAnnotBtnTT"),icon:"icon-WCR_Trash",action:b.bind(function(){this._annotationModel.deleteAnnotation(this._annotation)},this)});this._main&&!this._isForMobile&&(this._moreActions.addAction({name:"update3DView",content:this.f.i18n.t("annot3DViewUpdate"),icon:"icon icon-WCR_Annotation-3D-Update",action:b.bind(function(){this.f.emit("module.annotation.update3DView",this._annotation)},this)}),this._moreActions.addAction({name:"delete3DView",
content:this.f.i18n.t("annot3DViewDelete"),icon:"icon icon-WCR_Annotation-3D-Delete",action:b.bind(function(){this.f.emit("module.annotation.delete3DView",this._annotation)},this)}));w.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));x.element.addClass("btn-mini").append(this.f.i18n.t("CancelButton"));b.each(l.AnnotationReviewStateLocs,b.bind(function(a,e){"STATUS_ANY"!=e&&this._statusAction.addAction({name:e,content:this.f.i18n.t(a),action:b.bind(function(){this._annotationModel.setState(this._annotation,
l.AnnotationReviewState[e])},this),icon:l.AnnotationReviewStateIcons[e]})},this));this._view3D&&(this._view3D.addAction({name:"update3DView",content:this.f.i18n.t("annot3DViewUpdate"),icon:"icon icon-WCR_Annotation-3D-Update",action:b.bind(function(){this.f.emit("module.annotation.update3DView",this._annotation)},this)}),this._view3D.addAction({name:"delete3DView",content:this.f.i18n.t("annot3DViewDelete"),icon:"icon icon-WCR_Annotation-3D-Delete",action:b.bind(function(){this.f.emit("module.annotation.delete3DView",
this._annotation)},this)}));this._updateView3DButtons()},this))};e.prototype.closeRichText=function(){this._actionsDiv.show();this._actionsDiv.append(this._charLineCount.element);this._content.show();this._richTextEditor.element.hide()};e.prototype.showHideCharLineCount=function(b){var a=this._annotation.getGodfather();b&&this._annotationModel.isAnnotationOrReplySelected(a)?(this._charLineCount.show(),this._charLineCount.update(this._annotation.content)):this._charLineCount.hide()};e.prototype.repaintRow=
function(){this._hideHeader||this.updateTimer();!this._annotation.isBeingModified()&&void 0!==this._richTextEditor?this.closeRichText():this.updateColorPicker();this._updateView3DButtons();this._content.empty();this._content.removeClass("noContent");var e=this._annotation.getExtraContent();e&&e.element&&(this._content.append(e.element),e.tooltip&&(this.extraContentTooltip&&this.extraContentTooltip.destroy(),this.extraContentTooltip=new n(this.f.i18n,e.element,this.f.getContext(),this.f.getContext(),
this.f.isMobile(),e.tooltip)));if(this._annotation.content&&0<this._annotation.content.length){var a=p("<div>").html(this._annotation.content);this._content.append(a);this.f.i18n.loadBundle("viewer",b.bind(function(){a.truncate({max_length:this._MAX_CHARS,more:this.f.i18n.t("ReadMore"),less:this.f.i18n.t("ReadLess"),css_more_class:"truncator-link truncator-more",css_less_class:"truncator-link truncator-less",link_prefix:"",link_suffix:""})},this))}else e||this.f.i18n.loadBundle("viewer",function(){this._content.addClass("noContent");
this._annotation.isNew?this._content.text(this.f.t("AnnNewClickToEdit")):this._content.text(this.f.t("AnnNoContent"))},this);this.showOrHideOptions();this._updateReviews(this._annotation.states);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._annotationModel.canChangeAnnotations(!0)?(this._annotationModel.canChangeAnnotation(this._annotation)?(this._moreActions.show(),this._duplicateAction&&this._duplicateAction.hide(),this._duplicateWithoutText&&this._duplicateWithoutText.hide()):
(this._moreActions.hide(),this._duplicateAction&&this._duplicateAction.show(),this._duplicateWithoutText&&this._duplicateWithoutText.show()),this._statusAction.show(),this._moreActions.setActionEnabled("annotationDelete",this._annotationModel.canDeleteAnnotation(this._annotation))):(this._duplicateAction&&this._duplicateAction.hide(),this._duplicateWithoutText&&this._duplicateWithoutText.hide(),this._moreActions.hide(),this._statusAction.hide())};e.prototype.shouldShowOptions=function(){return this._isForMobile?
this.selected:this.selected||this.mouseEntered||this._moreActions.isOpen()||this._statusAction.isOpen()};e.prototype.showOrHideOptions=function(){this.showOptions(this.shouldShowOptions())};e.prototype.showOptions=function(b){b?this._isForMobile?this._actionsDiv.show():this._actionsDiv.removeClass("hideOptions"):this._isForMobile?this._actionsDiv.hide():this._actionsDiv.addClass("hideOptions")};e.prototype._updateReviews=function(e){this.f.i18n.loadBundle("viewer",function(){this._reviews.empty();
for(var a=0;a<e.length;a++){var g=p("<li/>"),c=p("<a/>"),d=p("<i/>").addClass("icon").addClass(l.AnnotationReviewStateIcons[b.invert(l.AnnotationReviewState)[e[a].state]]),f=b.invert(l.AnnotationReviewState)[e[a].state],f=p("<span/>").text('"'+this.f.i18n.t(l.AnnotationReviewStateLocs[f])+'": '+e[a].getUserName());c.append(d);c.append(f);g.append(c);this._reviews.append(g)}},this);this._reviews.toggle(0<e.length)};e.prototype._initializeRichTextEditor=function(){this._richTextEditor||(this._richTextEditor=
g.createEditor(this.f),!this.f.getProperty("annotationcolor")&&this._main&&(this._annotationColorPicker=new m(b.bind(function(b){this._annotation.setColor("#"+b);this._annotationModel.modelChanged(this._annotation)},this)),this._annotationColorPicker.setColor(this._annotation.annotationcolor),this._annotationColorPicker.element.addClass("annotationColorPicker"),this._annotationColorPicker.setTooltip(this.f,"general","ChangeColor")),this._richTextEditor.setButtons([this._editActionsGroup,this._annotationColorPicker]),
this._richTextEditor.onTextChanged(b.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._annotation.setBeingModified(this._richTextEditor.getContent());this._annotationModel.modelChanged()},this)))};e.prototype._updateView3DButtons=function(){var b=null!==this._annotation.get3DViewPosition(),a=this.f.getModule("view3D"),a=a&&a.is3DWidgetEnabled(),e=this._annotationModel.canChangeAnnotation(this._annotation);this._view3D&&(this._view3D.toggleButton(b),this._view3D.toggleElementVisibility("update3DView",
e&&a),this._view3D.toggleElementVisibility("delete3DView",e&&b),e?this._view3D.enableDropdown():this._view3D.disableDropdown());this._view3DMobile&&(b?this._view3DMobile.show():this._view3DMobile.hide());this._moreActions&&(this._moreActions.toggleElementVisibility("delete3DView",e&&b),this._moreActions.toggleElementVisibility("update3DView",e&&a))};e.prototype.setSelected=function(b){this.selected=b;this.element.toggleClass("selected",this.selected);this.repaintRow()};e.prototype.onDetachFromDOM=
function(){this._richTextEditor&&this._richTextEditor.beforeDetach();this._hideAllTooltips()};e.prototype._hideAllTooltips=function(){this.extraContentTooltip&&this.extraContentTooltip.hide();this._duplicateAction&&this._duplicateAction.hideTooltip();this._duplicateWithoutText&&this._duplicateWithoutText.hideTooltip();this._zoomAction&&this._zoomAction.hideTooltip();this._timelabel.tooltip.hide();this._moreActions.hideTooltip()};e.prototype.onReattachToDOM=function(){this._richTextEditor&&this._richTextEditor.repair()};
e.prototype.updateColorPicker=function(){this._annotationColorPicker&&this._annotationColorPicker.setColor(this._annotation.annotationcolor)};e.prototype.setVisible=function(b){this._visible=b;this.element.toggle(b)};e.prototype.isVisible=function(){return this._visible};e.prototype.setAnnotation=function(b){this._annotation=b;this.repaintRow()};return e});
define("web-viewer/annotation/AnnotationRow","web-viewer/annotation/AnnotationSingleRow web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/annotation/AnnotationCharLineCount web-viewer/annotation/AnnotationConstants web-viewer/layout/component/MiniButton jquery underscore".split(" "),function(d,l,j,k,h,f,c,n,g){var m=function(p,b,e,i,a,m){this.f=p;this._replyLimit=a;this._replyLimit||(this._replyLimit=2);this._annotation=
b;this._annotationModel=e;this._limitReplyCount=!0;this._totalReplyCount=this._shownReplyCount=0;this.name=this._annotation.name;this.element=n("<div>").addClass("annotation").toggleClass("cannot-reply",!this._annotation.getPermissionFor(f.ActionPermissions.CAN_BE_REPLIED_TO));this.annotationRows={};this.selected=!1;this._isForMobile=m;this._repliesDiv=n("<div/>").addClass("replies");this._moreReplies=n("<p/>").addClass("MoreReplies clearfix");this._moreRepliesLabel=n("<a/>");this._moreRepliesLabel.on("click",
g.bind(function(a){this.toggleReplyLimit();a.stopPropagation()},this));this._moreReplies.append(this._moreRepliesLabel);this._moreReplies.hide();i||(this.title=n("<span/>").addClass("annotationNumber"),this.element.append(this.title));m?(b=new c(this.f,"annotationAddReply","icon-WCR_Comment",!0,g.bind(function(a){this._showRichTextEditor(a)},this)),b.addButtonClass("annotAction"),this._replyText=b.element):(this._replyText=n("<input/>"),this.f.i18n.loadBundle("viewer",g.bind(function(){this._replyText.attr("placeholder",
this.f.i18n.t("AnnReplyTT"))},this)),this._replyText.on("click",function(a){a.preventDefault();a.stopPropagation()}),this._replyText.on("focus",g.bind(function(a){this._showRichTextEditor(a)},this)));this._reply=n("<div/>").append(this._replyText).addClass("addReply");this._richTextEditor=k.createEditor(this.f);this._saveReply=new l(this.f,"saveReply","icon-WCR_Save12 marginRight5",!0,g.bind(function(a){this._annotationModel.replyToAnnotation(this._annotation,this._richTextEditor.getContent(),!0);
this._closeRichText();a.stopPropagation()},this));this._cancelReply=new l(this.f,"cancelReply","icon-WCR_Revert12 marginRight5",!0,g.bind(function(a){this._closeRichText();this._richTextEditor.setContent("");this._annotation.resetUnsavedReply();this._annotationModel.modelChanged();a.stopPropagation()},this));this._replyActionsGroup=new j("replyActionsGroup",[this._cancelReply,this._saveReply]);this._replyActionsGroup.element.addClass("pull-right");p.i18n.loadBundle("viewer",g.bind(function(){this._saveReply.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));
this._cancelReply.element.addClass("btn-mini").append(this.f.i18n.t("CancelButton"))},this));this._charLineCount=new h(p);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._richTextEditor.onTextChanged(g.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._annotation.setUnsavedReply(this._richTextEditor.getContent());this._annotationModel.modelChanged()},this));this._richTextEditor.setButtons([this._replyActionsGroup,this._charLineCount]);
this._mainRow=new d(this.f,this._annotation,!0,this._annotationModel,i,this._replyText,this._isForMobile);this.element.append(this._mainRow.element);this.annotationRows[this._annotation.name]=this._mainRow;this.element.append(this._repliesDiv);this._repliesDiv.prepend(this._moreReplies);m||this.element.append(this._reply);this.annotationUpdated();this.updateReplyLimitLabel()};m.prototype._closeRichText=function(){this._replyText.show();this._richTextEditor.setContent("");this._richTextEditor.element.hide()};
m.prototype._showRichTextEditor=function(c){this._replyText.hide();this._richTextEditor.isInitialized()||this._replyText.after(this._richTextEditor.element);this._richTextEditor.element.show();this._annotation.setUnsavedReply("");this._richTextEditor.setContent("<html><body></body></html>");this._richTextEditor.init(g.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._richTextEditor.element.trigger("makeMeVisible");this._richTextEditor.element.trigger("contentResized")},
this));c.preventDefault();c.stopPropagation()};m.prototype.showHideCharLineCount=function(c,b){c&&this._annotationModel.isAnnotationOrReplySelected(this._annotation)?(this._charLineCount.show(),this._charLineCount.update(this._richTextEditor.getContent())):this._charLineCount.hide();b&&g.each(this.annotationRows,function(b){b.showHideCharLineCount(c)})};m.prototype.annotationUpdated=function(c){this.element.css({"border-color":this._annotation.annotationcolor});this.title&&(this.title.text(this._annotation.getMessageNumber()),
this.title.css({color:this._annotation.getHeaderTextColor(),"background-color":this._annotation.annotationcolor}));this._mainRow.setAnnotation(this._annotation);var b=this._annotationModel.getReplies(this._annotation);this._totalReplyCount=b.length;var e=[];g.each(this.annotationRows,function(a,b){e.push(b)});this._annotation.runThroughAnnotation(!0,!0,!1,function(a){a=g.indexOf(e,a.name);-1<a&&e.splice(a,1)});g.each(e,function(a){this.annotationRows[a].element.remove();delete this.annotationRows[a]},
this);var i=this._totalReplyCount;this._limitReplyCount&&(i=this._replyLimit);c&&(c=b.length-g.indexOf(b,c.parent),c<=b.length&&(i=Math.max(i,c)));this._shownReplyCount=Math.min(i,this._totalReplyCount);for(c=0;c<this._totalReplyCount;c++){var a=b[c],f=this.annotationRows[a.name];f||(f=new d(this.f,a,!1,this._annotationModel,void 0,void 0,this._isForMobile),this._repliesDiv.append(f.element),this.annotationRows[a.name]=f,f.setSelected(this.selected),f.setVisible(!1));this._totalReplyCount-1-c<i?(f.setAnnotation(a),
f.setVisible(!0)):f&&f.setVisible(!1)}this._repliesDiv.prepend(this._moreReplies);this.shouldShowMoreRepliesLink()?this._moreReplies.show():this._moreReplies.hide();this.updateReplyLimitLabel();this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._annotationModel.canChangeAnnotations(!0)&&!this._annotation.isNew?(this._reply.show(),null===this._annotation.getUnsavedReply()?(this._replyText.show(),this._closeRichText()):this._richTextEditor.setContent(this._annotation.getUnsavedReply())):
(this._reply.hide(),this._replyText.hide())};m.prototype.shouldShowMoreRepliesLink=function(){return this._totalReplyCount>this._replyLimit};m.prototype.toggleReplyLimit=function(g){this._limitReplyCount=void 0===g?!this._limitReplyCount:g;this.annotationUpdated();this.updateReplyLimitLabel();this._moreReplies.trigger("contentResized")};m.prototype.updateReplyLimitLabel=function(){if(this._limitReplyCount){var g=this._totalReplyCount-this._shownReplyCount;1>=g?this._moreRepliesLabel.text(this.f.i18n.t("AnnShowOneMoreReply")):
this._moreRepliesLabel.text(this.f.i18n.t("AnnShowMoreReplies",g))}else this._moreRepliesLabel.text(this.f.i18n.t("AnnShowLessReplies"))};m.prototype.updateTimers=function(){g.each(this.annotationRows,function(g){g.updateTimer()})};m.prototype.setSelected=function(c){this.selected=c;g.each(this.annotationRows,function(b){b.setSelected(c)});this.element.toggleClass("selected",c);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"))};m.prototype.onDetachFromDOM=function(){this.detachedFromDOM||
(this.detachedFromDOM=!0,this._richTextEditor.beforeDetach(),g.each(this.annotationRows,function(g){g.onDetachFromDOM()}))};m.prototype.onReattachToDOM=function(){this.detachedFromDOM&&(this.detachedFromDOM=!1,this._richTextEditor.repair(),g.each(this.annotationRows,function(g){g.onReattachToDOM()}))};m.prototype.setAvailableHeight=function(c){if(null!==this._annotation.getUnsavedReply()){var b=c-10;this.shouldShowMoreRepliesLink()&&(b-=this._moreReplies.outerHeight(!0));g.each(this.annotationRows,
function(e){e.isVisible()&&(b-=e.element.outerHeight(!0))});this._richTextEditor.setHeight(b)}};m.prototype.setAnnotation=function(g){this._annotation=g;this.annotationUpdated()};m.prototype.getAnnotation=function(){return this._annotation};return m});
define("web-viewer/annotation/AnnotationPopupNew","web-viewer/annotation/AnnotationPopup web-viewer/layout/component/ColorPicker web-viewer/layout/component/ViewerToolbarButton component/toolbar/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/annotation/AnnotationCharLineCount web-viewer/annotation/AnnotationRow underscore".split(" "),function(d,l,j,k,h,f){var c=function(c,g,f,h,b){d.call(this,c,g,f,b);this.element.removeClass("annotationPopup").addClass("annotationPopupNew");
this.annotation.popuprect.size.width||(this.annotation.popuprect.size.width=72);this.annotation.popuprect.size.height||(this.annotation.popuprect.size.height=45);this.annotation.popuprect.origin.x||(this.annotation.popuprect.origin.x=this.annotation.rect.right());this.annotation.popuprect.origin.y||(this.annotation.popuprect.origin.y=this.annotation.rect.bottom()-this.annotation.popuprect.size.height);this.annotationModel=h};c.prototype=Object.create(d.prototype);c.prototype.constructor=c;c.prototype._initialize=
function(){d.prototype._initialize.call(this);this.richTextEditor=h.createEditor(this.f);this.richTextEditor.setContent(this.annotation.content);var c;this.f.getProperty("annotationcolor")||(c=new l(_.bind(function(b){this.annotation.setColor("#"+b);this.annotationModel.modelChanged(this.annotation)},this)),c.setColor(this.annotation.annotationcolor),c.element.addClass("annotationColorPicker"),c.setTooltip(this.f,"general","ChangeColor"));var g=new j(this.f,"saveAnnot","icon-WCR_Save12 marginRight5",
!1,_.bind(function(b){this.annotation.content=this.richTextEditor.getContent();this.annotationModel.save();b.stopPropagation()},this)),m=new j(this.f,"deleteAnnot","icon-WCR_Trash12 marginRight5",!1,_.bind(function(b){this.annotationModel.deleteAnnotation(this.annotation);b.stopPropagation()},this)),p=new k("AnnotationActionsGroup",[m,g]);p.element.addClass("pull-right");this.f.i18n.loadBundle("viewer",_.bind(function(){g.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));
m.element.addClass("btn-mini").append(this.f.i18n.t("Delete"))},this));this.charLineCount=new f(this.f);this.richTextEditor.setButtons([c,p,this.charLineCount]);this.richTextEditor.onTextChanged(_.bind(function(){this.charLineCount.update(this.richTextEditor.getContent());this.annotation.setBeingModified(this.richTextEditor.getContent())},this));this.setContent(this.richTextEditor.element);this.richTextEditor.init(_.bind(function(){this._repaintCharLineCount();this.on("contentResized",_.bind(function(b){this.richTextEditor.setHeight(b.height)},
this));this.richTextEditor.setHeight(this._outerContent.height())},this))};c.prototype.repaint=function(){this._isInitialized&&(d.prototype.repaint.call(this),this._repaintCharLineCount())};c.prototype._repaintCharLineCount=function(){this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")?(this.charLineCount.show(),this.charLineCount.update(this.richTextEditor.getContent())):this.charLineCount.hide()};c.prototype.remove=function(){this.annotationColorPicker&&this.annotationColorPicker.destroy();this.richTextEditor&&
this.richTextEditor.destroy();d.prototype.remove.call(this)};return c});
define("web-viewer/annotation/AnnotationPopupExisting",["web-viewer/annotation/AnnotationPopup","web-viewer/annotation/AnnotationRow","underscore"],function(d,l,j){var k=function(h,f,c,j,g){d.call(this,h,f,c,g);this.annotationModel=j};k.prototype=Object.create(d.prototype);k.prototype.constructor=k;k.prototype._initialize=function(){d.prototype._initialize.call(this);this.row=new l(this.f,this.annotation,this.annotationModel,!0);this.row.setSelected(!0);this.annotationExistingContent=$("<div>").addClass("AnnotationTable enableTextSelection").append(this.row.element);
this.setContent(this.annotationExistingContent);this.on("contentResized",j.bind(function(d){this.row.setAvailableHeight(d.height)},this));this.row.setAvailableHeight(this.content.height())};k.prototype.repaint=function(h){this._isInitialized&&(d.prototype.repaint.call(this),this.row.annotationUpdated(h))};return k});
define("web-viewer/annotation/AnnotationPopupModel","web-viewer/viewport/model/ViewportPopupModel web-viewer/annotation/AnnotationPopupNew web-viewer/annotation/AnnotationPopupExisting web-viewer/annotation/AnnotationConstants utils/ShapeUtils underscore".split(" "),function(d,l,j,k,h){var f=function(c,f,g,h){d.call(this,c,f);this.annotation=g;this.annotationModel=h;this.popup=null};f.prototype=Object.create(d.prototype);f.prototype.constructor=f;f.prototype.repaint=function(c){null!=this.popup&&
this.popup.repaint(c)};f.prototype.getPopup=function(c){c=c.getLayerElement();null===this.popup?this._createPopup(c):this.popup.setContainment(c);return this.popup};f.prototype._createPopup=function(c){this.popup=this.annotation.isNew?new l(this.f,this.id,this.annotation,this.annotationModel,c):new j(this.f,this.id,this.annotation,this.annotationModel,c);this.popup.on("closed",_.bind(this.onClosed,this));this.popup.on("pinned",_.bind(this.onPinned,this));this.popup.on("clicked",_.bind(this.onClicked,
this))};f.prototype.onDestroy=function(){null!=this.popup&&this.popup.remove()};f.prototype.onResized=function(c,d){var g=c.copy();g.origin.y-=g.size.height;this.annotation.popuprect.rectEquals(g)||(this.annotation.popuprect=g,d||this._fireAnnotationChanged("POPUP_SIZE"))};f.prototype.onDragged=function(c){c=c.copy();c.y-=this.annotation.popuprect.size.height;this.annotation.popuprect.origin.equals(c)||(this.annotation.popuprect.origin=c,this._fireAnnotationChanged("POPUP_POSITION"))};f.prototype.onClosed=
function(){this.annotationModel.unselectAllAnnotations(!0,!0);this.annotation.popupIsOpen&&(this.annotation.popupIsOpen=!1,this.annotation.setModified("POPUP_PINNED"));this.annotationModel.modelChanged(this.annotation)};f.prototype.onPinned=function(c){this.annotation.popupIsOpen!==c&&(this.annotation.popupIsOpen=c,this._fireAnnotationChanged("POPUP_PINNED")||this.popup.repaint())};f.prototype.onClicked=function(){this.annotationModel.selectAnnotation(this.annotation)};f.prototype._fireAnnotationChanged=
function(c){return this.annotationModel.canChangeAnnotation(this.annotation)?(this.annotation.setModified(c),this.annotationModel.modelChanged(this.annotation),!0):!1};f.prototype.getWorldOrigin=function(){return new h.Point(this.annotation.popuprect.left(),this.annotation.popuprect.bottom())};f.prototype.getWorldSize=function(){return this.annotation.popuprect.size};f.prototype.getSceneOffset=function(){if(this.annotation.getType()==k.AnnotationType.ANNOT_PIN)return new h.Size(k.AnnotationPin.imagewidth,
0)};return f});
define("web-viewer/annotation/AnnotationPopupsLayerModel",["web-viewer/viewport/model/ViewportLayerModel","web-viewer/annotation/AnnotationPopupModel","underscore"],function(d,l,j){var k=function(h,f,c){d.call(this,h,f);this.f=h;this.annotationModel=c;this._createModels();this.annotationModel.on("modelContentChanged",j.bind(function(){this.removeAllPopupModels();this._createModels()},this));this.annotationModel.on("modelChanged",j.bind(function(){var c=this.annotationModel.getAnnotationsPage();if(null!==
c&&void 0!==c){this.resetTransformation();this.getTransform().scale(1,-1);var g=c.getRotation(),d=this.f.getModule("viewport").getWorldBounds();this.calculateTransformation(d,c.getPageSize(),this.annotationModel.getAnnotationsOffset(),g,c.isFlipped())}this.modelChanged()},this));this.annotationModel.on("selectedAnnotation",j.bind(function(c){if(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")){var g=c.getGodfather(),d=this.getPopupModel(g.name);void 0!==d&&(g==c?d.repaint():d.repaint(c))}this._updateModels();
this.modelChanged()},this));this.annotationModel.on("unselectedAnnotation",j.bind(function(c){this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")&&(c=this.getPopupModel(c.getGodfather().name),void 0!==c&&c.repaint());this._updateModels()},this));this.annotationModel.on("annotationDeleted",j.bind(function(c){var g=c.getGodfather();c==g?this.removePopupModel(c.name):(c=this.getPopupModel(g.name),void 0!==c&&c.repaint())},this));this.annotationModel.on("annotationAdded",j.bind(function(c){this._createModel(c)},
this));this.annotationModel.on("annotationUpdated",j.bind(function(c,g){var d=this.getPopupModel(c.getGodfather().name);void 0!==d&&d.repaint(g);this._updateModels()},this));this.annotationModel.on("annotationListVisible",j.bind(function(){this._updateModels();this.modelChanged()},this));this.annotationModel.on("readWriteChanged",j.bind(function(){j.each(this.getPopupModels(),function(c){c.repaint()},this);this.modelChanged()},this));this.annotationModel.on("temporarilyDisableChanged",j.bind(function(){this._updateModels()},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",j.bind(function(){this._updateModels();this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",j.bind(function(){this._updateModels();this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWCOUNT",j.bind(function(){j.each(this.getPopupModels(),function(c){var g=this.annotationModel.getAnnotation(c.getId());
this.annotationModel.isAnnotationOrReplySelected(g)&&c.repaint()},this);this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",j.bind(function(){this._updateModels()},this))};k.prototype=Object.create(d.prototype);k.prototype.constructor=k;k.prototype._updateModels=function(){this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?this.annotationModel.isAnnotationListVisible()?this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")?0<this.annotationModel.getSelectedAnnotations().length?
j.each(this.getPopupModels(),function(d){this._showSelected(d)},this):j.each(this.getPopupModels(),function(d){this._showPinnedOrSelected(d)},this):this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY")?j.each(this.getPopupModels(),function(d){this._showSelected(d)},this):j.each(this.getPopupModels(),function(d){this._showPinnedOrSelected(d)},this):j.each(this.getPopupModels(),function(d){this._showPinnedOrSelected(d)},this):j.each(this.getPopupModels(),function(d){d.hide()},this)};k.prototype._showSelected=
function(d){var f=this.annotationModel.getAnnotation(d.getId());this.annotationModel.isAnnotationOrReplySelected(f)?d.show():d.hide()};k.prototype._showPinnedOrSelected=function(d){var f=this.annotationModel.getAnnotation(d.getId());!this.annotationModel.isTemporarilyDisabledAndNoAnnotationsVisible()&&f&&(f.popupIsOpen||this.annotationModel.isAnnotationOrReplySelected(f))?d.show():d.hide()};k.prototype._createModels=function(){j.each(this.annotationModel.getAnnotations(),function(d){this._createModel(d)},
this);this._updateModels();this.modelChanged()};k.prototype._createModel=function(d){d.linkedto||(d=new l(this.f,d.name,d,this.annotationModel),this.addPopupModel(d))};return k});
define("web-viewer/annotation/AnnotationTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/DrawUtils web-viewer/utils/ViewerUtils web-viewer/annotation/AnnotationConstants web-viewer/annotation/Annotation web-viewer/core/CoreConstants".split(" "),function(d,l,j,k,h,f,c,n){h=function(c,m){l.call(this,c,n.TOOLS.ANNOTATION);this.f=c;this._annotationModel=m;this._defaultState="defaultState";this._hoverState="hoverState";this._draggingState="draggingState";this._anchorState=
"anchorState";this._anchor=void 0;this._touchDown=this._targetAnnotation=null;this.registerState(this._defaultState,function(d){return{mousemove:function(b){var e=d._getAnnotationLayer(b);e&&e.isVisible()&&(d._verifyObjects(b,e),(d._targetAnnotation||d._anchor)&&d.requestActivation())},mouseup:function(){},mousedown:function(b){d._getAnnotationLayer(b)&&(m.unselectAllAnnotations(),b.originalEvent.preventDefault())},mouseout:function(){d.isActive()&&c.emit("toolManager.request.deactivation",d)},mouseleave:function(){d.isActive()&&
c.emit("toolManager.request.deactivation",d)},contextmenu:function(b){b.preventDefault();b.stopPropagation();return!1}}}(this));this.registerState(this._hoverState,d.defaults(function(d){return{mousedown:function(b){1===b.which&&(d._verifyObjects(b),d._touchDown=d._getAnnotationLayer(b).getWorldPointFromScene(d.getScenePoint(b)),d._anchor&&d._targetAnnotation.annottype!=f.AnnotationType.ANNOT_FREEFORM?(c.emit("viewport.startInteractive"),d.changeState(d._anchorState)):d._targetAnnotation&&(c.emit("viewport.startInteractive"),
m.selectAnnotation(d._targetAnnotation),d.changeState(d._draggingState)));b.originalEvent.preventDefault()},mousemove:function(b){d._verifyObjects(b);d.cursorShouldChange()}}}(this),this.getState(this._defaultState)));this.registerState(this._draggingState,d.defaults(function(d){return{mousemove:function(b){d.cursorShouldChange();var e=d._getAnnotationLayer(b).getWorldPointFromScene(d.getScenePoint(b)),c=d._widget.getWorld().getWorldBounds(),b=d._getAnnotationLayer(b).convertWorldRectToLayer(new j.Rect(new j.Point,
c.size));b.origin.y=-(b.size.height+b.origin.y)-c.origin.y;b.origin.x+=c.origin.x;c=d.keepMoveSizeWithinRect(b,d._targetAnnotation.rect,d._touchDown.sizeTo(e));m.moveAnnotation(d._targetAnnotation,c);d._touchDown=e},mouseup:function(){c.emit("viewport.stopInteractive");d.changeState(d._hoverState)},mouseout:function(){c.emit("viewport.stopInteractive");d.changeState(d._hoverState)},enterState:function(){c.emit("viewport.startInteractive")},leaveState:function(){c.emit("viewport.stopInteractive")}}}(this),
this.getState(this._defaultState)));this.registerState(this._anchorState,d.defaults(function(d){return{mousemove:function(b){var b=d._getWorldPoint(b),e,c=null;switch(d._anchor.anchor){case k.LWANCHOR_TOPLEFT:c="NW";break;case k.LWANCHOR_TOPCENTER:c="N";break;case k.LWANCHOR_TOPRIGHT:c="NE";break;case k.LWANCHOR_BOTTOMLEFT:c="SW";break;case k.LWANCHOR_BOTTOMCENTER:c="S";break;case k.LWANCHOR_BOTTOMRIGHT:c="SE";break;case k.LWANCHOR_CENTERLEFT:c="W";break;case k.LWANCHOR_CENTERRIGHT:c="E"}e=c;if(null!=
e){c=d._anchor.linework.rect.copy();if(-1<e.indexOf("E")||-1<e.indexOf("W"))if(-1<e.indexOf("W")){var a=d._anchor.linework.rect.left()-b.x;c.origin.x-=a;c.size.width+=a}else a=d._anchor.linework.rect.right()-b.x,c.size.width-=a;if(-1<e.indexOf("N")||-1<e.indexOf("S"))-1<e.indexOf("N")?(e=d._anchor.linework.rect.top()-b.y,c.origin.y-=e,c.size.height+=e):(e=d._anchor.linework.rect.bottom()-b.y,c.size.height-=e);m.transformAnnotation(d._anchor.linework,c)}else d._anchor.anchor==k.LWANCHOR_START?m.updateStartEndOfAnnotation(d._anchor.linework,
b,null):d._anchor.anchor==k.LWANCHOR_END&&m.updateStartEndOfAnnotation(d._anchor.linework,null,b);d._touchDown=b},mouseup:function(){c.emit("viewport.stopInteractive");d.cursorShouldChange();d.changeState(d._hoverState)},mouseleave:function(){c.emit("viewport.stopInteractive");d.cursorShouldChange();d.changeState(d._hoverState)},mouseout:function(){}}}(this),this.getState(this._defaultState)));this._override("initialize",d.bind(function(c,b){this._super(c,b);this.persistentKeyEvents.push(["del",d.bind(function(){0<
this._annotationModel.getSelectedAnnotations().length&&d.each(this._annotationModel.getSelectedAnnotations(),d.bind(function(b){this._annotationModel.deleteAnnotation(b)},this))},this),"keyup"]);this.changeState(this._defaultState);this.registerPassiveEvents(["mousemove","mousedown"]);this.registerActiveEvents("mousemove mousedown mouseup mouseout mouseleave contextmenu".split(" "))},this));this._override("activate",d.bind(function(c){this._super(c);this.changeState(this._hoverState)},this));this._override("deactivate",
d.bind(function(c){this._super(c);this.changeState(this._defaultState)},this))};h.prototype=Object.create(l.prototype);h.prototype.constructor=h;h.prototype.getDefaultCursor=function(){return this._anchor?this._cursorForAnchor():this.getCurrentStateName()==this._draggingState?this._annotationModel.canChangeAnnotation(this._targetAnnotation)?"cursor-moveObject":"cursor-notAllowed":"cursor-select"};h.prototype._deActivate=function(){this.isActive()&&(this.changeState(this._defaultState),this.f.emit("toolManager.request.deactivation",
this))};h.prototype._cursorForAnchor=function(){var c="cursor-moveObject";if(this._anchor.linework.annottype==f.AnnotationType.ANNOT_ARROW||this._anchor.linework.annottype==f.AnnotationType.ANNOT_LINE)return c;var d=this._getAnnotationLayer("Main");if(!d)return c;var h=d.getScenePointFromWorld(this._anchor.rect.center()),b=new j.Size(this._anchor.rect.size.width,this._anchor.rect.size.height),h=new j.Rect(new j.Point(h.x-b.width/2,h.y-b.height/2),b),d=d.getSceneRectFromWorld(this._anchor.linework.rect);
h.containsPoint(d.topleft())?c="NW":h.containsPoint(d.topcenter())?c="N":h.containsPoint(d.topright())?c="NE":h.containsPoint(d.centerleft())?c="W":h.containsPoint(d.centerright())?c="E":h.containsPoint(d.bottomleft())?c="SW":h.containsPoint(d.bottomcenter())?c="S":h.containsPoint(d.bottomright())&&(c="SE");return"cursor-resize"+c};h.prototype._getAnnotationLayer=function(c){if(c=this._widget.requestView(c))if(c=c.getLayer("Annotations"))return c;return null};h.prototype._getClosestLineworkFromPoint=
function(c,d){var f=d;f||(f=this._getAnnotationLayer(c));return f?f.getClosestLineworkFromPoint(this.getScenePoint(c)):null};h.prototype._getWorldPoint=function(c){var d=this._annotationModel.getAnnotationsPage(),c=this.keepPointWithinWorldBounds(this.getWorldPoint(c),!1);c.y=d.getPageSize().height-c.y;var f=d.getDocumentPageOrigin();c.offset(new j.Size(-f.x,f.y));var b=d.getTrimboxRect().size,f=0;0!==b.width&&0!==b.height&&(f=d.getPageSize().height-(b.height+d.getMargins().top+d.getMargins().bottom));
b=d.getMargins();d.isReaderSpread()&&d.get("isRightPage")&&(b.left=-b.left);c.offset(new j.Size(-b.left,-b.bottom-f));return c};h.prototype._verifyObjects=function(d,f){if(!f&&(f=this._getAnnotationLayer(d),!f))return;var h=this._getClosestLineworkFromPoint(d,f);this._anchor=this._targetAnnotation=null;h&&(h instanceof c?this._targetAnnotation=h:h.anchor&&(this._anchor=h,this._targetAnnotation=h.linework));!h&&!this._targetAnnotation&&this._deActivate(d)};return h});
define("web-viewer/annotation/AnnotationDrawTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/annotation/Annotation web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(d,l,j,k,h,f,c,n,g,m,p){k=function(b,e,i){l.call(this,b,p.TOOLS.ANNOTATION_DRAW);n.mixin(this,b);var a;this.drawLinkedAnnotation=
!1;this._annotationModule=i;this._annotationModel=e;this.setAnnotationType=function(a){b.setOption("PREFERENCES_ANNOTATION_TOOLMODE",a)};this.getAnnotationType=function(){return b.getOption("PREFERENCES_ANNOTATION_TOOLMODE")};this.setAnnotationColor=function(a){b.getCurrentUser().setColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR",a)};this.getAnnotationColor=function(){return b.getProperty("annotationcolor")?b.getProperty("annotationcolor"):b.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};
this.getDefaultCursor=function(){return"cursor-drawAnnotation"};this.addGlobalAnnotation=function(){this.drawLinkedAnnotation||e.unselectAllAnnotations(!0,!0);var c=b.getModule("viewport").getWorldBounds();m("Main")&&(a=new f(b),a.initAnnotation(this.getAnnotationType(),this.getAnnotationColor(),!1,e),a.rect=b.getModule("viewport").getWorld().getSceneRectFromWorld(c),k("Main"))};this._registerListener("addGlobalAnnotation",function(){if(this.f.isParameterUpdateOngoing())var a=this._registerListener("parameters.changed",
function(){this._unregisterListener(a);this.addGlobalAnnotation()},this,this.f.getDocumentController());else this.addGlobalAnnotation()},this,this._annotationModel);var m=d.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{mousedown:function(){},mouseup:function(){},mousemove:function(){},mouseout:function(){},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},mouseleave:function(){},click:function(){},
canBeInterrupted:!0});this.registerState("draw",d.defaults({mousedown:d.bind(function(c){if(1===c.which){this._annotationModel.getAnnotationFilterModel().setOriginType(g.AnnotationOriginTypes.user.id);this.drawLinkedAnnotation||e.unselectAllAnnotations(!0,!0);this.requestCanvasLayer(c);var d=this.keepPointWithinWorldBounds(this.getWorldPoint(c),!0);a=new f(b);a.initAnnotation(this.getAnnotationType(),this.getAnnotationColor(),!1,e);a.rect=new j.Rect(d,new j.Size);this.changeState("drawing")}c.originalEvent.preventDefault()},
this)},this.getState("default")));var k=d.bind(function(b){q();b||(a=null);a&&2===a.pointArray.length&&a.pointArray[0].x==a.pointArray[1].x&&a.pointArray[0].y==a.pointArray[1].y&&(a=null);if(null!==a&&(0===Math.abs(a.rect.size.width)||0>=Math.abs(a.rect.size.height)))0===Math.abs(a.rect.size.width)&&0>=Math.abs(a.rect.size.height)?a=null:a.annottype!=g.AnnotationType.ANNOT_ARROW&&a.annottype!=g.AnnotationType.ANNOT_LINE&&(a=null);if(a){var e=m(b);e?(a.rect=e.getWorldRectFromScene(a.rect),this._annotationModel.getPage().isReaderSpread()?
this._annotationModule.promptIfAnnotationOutsidePage(a.rect,d.bind(function(b){var c=this.drawLinkedAnnotation;b&&!c&&(this.drawLinkedAnnotation=!0);this.createAnnotation(a,e);b&&!c&&(this.drawLinkedAnnotation=!1)},this),function(){a=null},this.drawLinkedAnnotation):this.createAnnotation(a,e)):a=null}this.changeState("draw")},this);this.createAnnotation=function(a,b){for(var c=0;c<a.pointArray.length;c++){var d=a.pointArray[c],i=new j.Point(d.x,d.y),i=b.getWorldPointFromScene(i);d.x=i.x;d.y=i.y}this.drawLinkedAnnotation?
e.addLinkedAnnotation(a):(e.addAnnotation(a),this.isActive()&&this.requestDeactivation())};var t=d.throttle(d.bind(function(){var b=this.getCanvasCtx();if(b){var e=this.getCanvasSize();b.clearRect(0,0,e.width,e.height);a&&h.drawOverlay(this.f,b,[a])}},this),40);this.registerState("drawing",d.defaults({enterState:function(){b.emit("viewport.startInteractive");b.emit("layout.disableTextSelection")},leaveState:function(){b.emit("viewport.stopInteractive");setTimeout(function(){b.emit("layout.enableTextSelection")},
500)},mousemove:d.bind(function(b){var e=a.rect.copy(),d=this.keepPointWithinWorldBounds(this.getWorldPoint(b),!0);if(this.getAnnotationType()==g.AnnotationType.ANNOT_FREEFORM){b=new c;if(0===a.pointArray.length)b.makeMoveTo(a.rect.origin.x,a.rect.origin.y);else{var i=a.pointArray[a.pointArray.length-1];if(0>Math.abs(i.x-d.x)||0>Math.abs(i.y-d.y))return;b.makeLineTo(d.x,d.y)}a.pointArray.push(b);d=Math.abs(b.x-e.origin.x);b.x<e.origin.x?(d=Math.abs(e.origin.x-b.x),e.origin.x=b.x,e.size.width+=d):
d>e.size.width&&(e.size.width=d);d=Math.abs(b.y-e.origin.y);b.y<e.origin.y?(d=Math.abs(e.origin.y-b.y),e.origin.y=b.y,e.size.height+=d):d>e.size.height&&(e.size.height=d)}else e.size=a.rect.origin.sizeTo(d);a.setRect(e,!0);t()},this),mouseclick:function(){},mouseup:function(a){k(a)},mouseleave:function(){k()},mousedown:function(a){a.originalEvent.preventDefault()},canBeInterrupted:!1},this.getState("default")));this.canBeInterrupted=function(){return!1};this.activeKeyEvents=[];this.persistentKeyEvents=
[];this._override("initialize",function(a,b){this._super(a,b);this.changeState("default");this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "));this.activeKeyEvents.push(["shift",d.bind(function(){this.drawLinkedAnnotation=!0},this),"keydown"]);this.activeKeyEvents.push(["shift",d.bind(function(){this.drawLinkedAnnotation=!1},this),"keyup"])});var q=d.bind(function(){this.releaseCanvasLayer()},this);this.canBeActivated=function(){return e.canChangeAnnotations()};
this._override("activate",function(a){this._super(a);this.getAnnotationType();this.getAnnotationColor();e.setLockSelection(!0);this.changeState("draw")});this._override("deactivate",function(a){this._super(a);this.changeState("default");q();this.drawLinkedAnnotation=!1;e.setLockSelection(!1)});b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",d.bind(function(a,b){!b&&this.isActive()&&this.requestDeactivation()},this))};k.prototype=Object.create(l.prototype);return k.prototype.constructor=
k});
define("web-viewer/annotation/AnnotationIndicatorTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/viewport/model/ViewportLayerModel utils/ShapeUtils web-viewer/annotation/AnnotationConstants web-viewer/core/CoreConstants".split(" "),function(d,l,j,k,h,f){d=function(c,d){l.call(this,c,f.TOOLS.ANNOTATION_INDICATOR);this.f=c;this.layerModel=new j(c,"annotationIndication");this.layerModel.annotation=null;this.layerModel.tool=this;this.layerModel.annotationModel=d;this.layerModel.alpha=0.7;
this.layerModel.render=function(c,d){c.fillStyle="rgba(0, 0, 0, "+this.alpha+")";c.clearRect(d.origin.x,d.origin.y,d.size.width,d.size.height);c.beginPath();c.rect(d.origin.x,d.origin.y,d.size.width,d.size.height);c.fill();c.save();if(this.annotation){var f=Math.abs(this.tool.sceneToWorldSize(new k.Size(10,10)).width),b=this.annotationModel.getAnnotationsPage();if(null!==b&&void 0!==b){this.resetTransformation();this.getTransform().scale(1,-1);var e=b.getRotation(),i=this.f.getModule("viewport").getWorldBounds();
this.calculateTransformation(i,b.getPageSize(),this.annotationModel.getAnnotationsOffset(),e,b.isFlipped())}b=this.annotation.rect.copy();b.normalize();c.clearRect(b.origin.x-f,b.origin.y+b.size.height+f,b.size.width+2*f,-b.size.height-2*f);e=this.annotationModel.getAnnotationLinks(this.annotation);for(i=0;i<e.length;i++)b=e[i].rect.copy(),b.normalize(),c.clearRect(b.origin.x-f,b.origin.y+b.size.height+f,b.size.width+2*f,-b.size.height-2*f)}c.restore()};this._override("activate",function(){this._super();
this.f.getModule("viewport").addLayer("annotationIndication",this.layerModel)});this._override("deactivate",function(c){this._super(c);this.f.getModule("viewport").removeLayer("annotationIndication")})};d.prototype=Object.create(l.prototype);d.prototype.constructor=d;d.prototype.canBeInterrupted=function(){return!1};d.prototype.setAnnotation=function(c){this.layerModel.annotation=c};return d});
define("web-viewer/annotation/AnnotationOriginSelector",["jquery","web-viewer/annotation/AnnotationConstants","component/toolbar/ButtonGroup","component/toolbar/ToolbarButton","component/tooltip/Tooltip"],function(d,l,j,k){var h=function(f,c,h,g,m){this._filterModel=c;this._annotationModel=h;this._annotationModel.on("modelChanged",_.bind(this._enableToolbarButtons,this));this._annotationModel.on("modelContentChanged",_.bind(this._enableToolbarButtons,this));this._annotationModel.on("modelContentChanged",
_.bind(this._activateToolbarButtons,this));this._filterModel.on("filterChanged",_.bind(this._activateToolbarButtons,this));this.f=f;this._buttonGroup=new j("annotationTypeButtonGroup");this.element=d("<div class='annotation-origin-selector'/>").append(this._buttonGroup.element);this._context=g;this._isMobile=m;this._buttons={};this._initTypeFilters()};h.prototype._initTypeFilters=function(){_.each(l.AnnotationOriginTypes,function(f){var c=f.id,h=f.icon;f.subIcon&&(h=d("<i class='icon containerIcon icon-normal'/>").addClass(h),
h.append(d("<i class='icon subIcon icon-normal'/>").addClass(f.subIcon)));f=new k(this.f.i18n,this._context,this._isMobile,c,h,this._isMobile,_.bind(function(){this._filterModel.setOriginType(c);this._annotationModel.unselectAllAnnotations()},this),this.f.i18n.t(f.langKey));this._buttonGroup.addButton(f);this._buttons[c]=f},this);this._enableToolbarButtons();this._activateToolbarButtons()};h.prototype._enableToolbarButtons=function(){var d=_.uniq(_.map(this._annotationModel.getAnnotations(),function(c){return c.originType})),
c=_.uniq(_.map(d,function(c){return l.AnnotationOriginTypes[c].group}));_.each(this._buttons,function(h,g){var j=_.find(d,function(b){return g===b}),k=_.find(c,function(b){return l.AnnotationOriginTypes[g].group===b});h.setEnabled(j||g===l.AnnotationOriginTypes.user.id);var b=l.AnnotationOriginTypes[g];b&&b.hideBtnOnEmpty?j?h.show():h.hide():b&&b.hideBtnOnGroupEmpty&&(k?h.show():h.hide())})};h.prototype._activateToolbarButtons=function(){var d=this._filterModel.getOriginType();_.each(this._buttons,
function(c){c.setActive(c.name===d)})};return h});
define("tpl!web-viewer/annotation/AnnotationCustomFilterPopup",function(){return function(d){var l,j="",j=j+('\r\n    <div class="filterOperator">\r\n        <span class="operatorText">'+(null==(l=d.i18n("FilterMatch"))?"":_.escape(l))+'</span>\r\n        <select class="filterOperatorSelector">\r\n            <option ');0==d.filterOperator&&(j+='selected="selected"');j+=' value="0">'+(null==(l=d.i18n("AnnotFilterAllOperator"))?"":_.escape(l))+"</option>    \r\n            <option ";1==d.filterOperator&&
(j+='selected="selected"');j+=' value="1">'+(null==(l=d.i18n("AnnotFilterAnyOperator"))?"":_.escape(l))+'</option>\r\n        </select>\r\n        <span class="operatorText">'+(null==(l=d.i18n("FilterOperator"))?"":_.escape(l))+'</span>\r\n    </div>\r\n    <div class="filterRows">\r\n        ';_.each(d.getFilterRows(),function(k,h){j+='\r\n            <div class="" data-bind="'+(null==(l=h)?"":_.escape(l))+'">\r\n                '+(null==(l=d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",
k,"filter"))?"":l)+"\r\n            </div>\t\r\n        "});return j+='\r\n    </div>\r\n    <a class="addFilterRow">\r\n        <i class="icon-WCR_Filter-Add12"></i><span class="addFilterRowText">'+(null==(l=d.i18n("AnnotFilterAddRow"))?"":_.escape(l))+"</span>\r\n    </a>"}});
define("tpl!web-viewer/annotation/AnnotationCustomFilterRow",function(){return function(d){var l,j="",j=j+('<div class="filterRow" data-bind="'+(null==(l=d.filter.filterId)?"":_.escape(l))+'">\r\n    <select class="filterType">\r\n        ');_.each(d.getFilterTypes(),function(k,h){j+="\r\n            <option ";d.filter.filterType==h&&(j+='selected="selected"');j+=' value="'+(null==(l=h)?"":_.escape(l))+'">'+(null==(l=d.i18n(k))?"":_.escape(l))+"</option>\r\n        "});j+='\r\n    </select>\r\n    <select class="filterCondition">\r\n        <option ';
0==d.filter.filterCondition&&(j+='selected="selected"');j+=' value="0">'+(null==(l=d.i18n("AnnotFilterIs"))?"":_.escape(l))+"</option>\r\n        <option ";1==d.filter.filterCondition&&(j+='selected="selected"');j+=' value="1">'+(null==(l=d.i18n("AnnotFilterIsNot"))?"":_.escape(l))+'</option>\r\n    </select>\r\n    <select class="filterOption">\r\n        ';_.each(d.getOptions(d.filter.filterType,d.filter.filterOption),function(k,h){j+="\r\n            <option ";d.filter.filterOption===h&&(j+='selected="selected"');
j+=" ";"hidden"===h&&(j+="selected hidden");j+=' value="'+(null==(l=h)?"":_.escape(l))+'">\r\n                '+(null==(l=k)?"":_.escape(l))+"\r\n            </option>\r\n        "});j+="  \r\n    </select>\r\n    ";0!==d.filter.filterId&&(j+='\r\n        <a class="removeFilterRow" data-bind="'+(null==(l=d.filter.filterId)?"":_.escape(l))+'">\r\n            <i class="icon-WCR_Filter-Remove12"></i>\r\n        </a>\r\n    ');return j+="\r\n</div>"}});
define("web-viewer/annotation/AnnotationCustomFilterPopup","web-viewer/core/PrivateChannel web-viewer/layout/component/Popup web-viewer/layout/component/ViewerToolbarButton Template web-viewer/annotation/AnnotationConstants tpl!web-viewer/annotation/AnnotationCustomFilterPopup tpl!web-viewer/annotation/AnnotationCustomFilterRow jquery underscore".split(" "),function(d,l,j,k,h,f,c,n,g){c=function(c,p,b){l.call(this,c,p,c.getContext());d.installTo(this,c,["annotationFilterPopup"]);this.element.addClass("annotation-custom-filter-popup");
this._annotationModel=b;this._filterModel=this._annotationModel.getAnnotationFilterModel();this._savedFilterState=null;this._wasCustomFilterActive=!1;this._filterContent=n("<div>").addClass("annotationFilter");this._location=null;this.content.append(this._filterContent);this._okButton=new j(this.f,"okButton",n("<span/>"),!1,g.bind(function(){this._filterModel.setCustomFilterActive(!0);this._filterModel.fireFilterStateChanged();this.hide()},this));this._okButton.addClass("btn-success");this._cancelButton=
new j(this.f,"cancelButton",n("<span/>"),!1,g.bind(function(){this._filterModel.setFilterState(this._savedFilterState);this._savedFilterState=null;this._wasCustomFilterActive||this._filterModel.setCustomFilterActive(!1);this.hide()},this));this._cancelButton.addClass("btn");this.addButton(this._cancelButton.element);this.addButton(this._okButton.element);this.t=new k(this.f.i18n,f);this.t.setContext(this._filterContent);this.t.d.getFilterRows=g.bind(function(){return this._filterModel.getFilterRows()},
this);this.t.d.getFilterTypes=g.bind(function(){return g.values(h.FilterTypeNameLocs)},this);this.t.d.getOptions=g.bind(function(b,c){var a=this._annotationModel.getUsers(h.AnnotationOriginTypes.user.id);if(b==h.FilterTypes.AUTHOR)return c&&void 0===a[c]&&(a.hidden=this.f.i18n.t("AnnotFilterUserNotAvailable")),a;if(b==h.FilterTypes.REVIEWSTATE||b==h.FilterTypes.REVIEWAUTHORANDSTATE){var d={};g.each(h.AnnotationReviewStateLocs,function(a,b){d[b]=this.f.i18n.t(a)},this);if(b==h.FilterTypes.REVIEWSTATE)return d;
var f={};g.each(a,function(b,e){g.each(d,function(a,e){f[b+" "+e]=b+" "+a});e!==g.last(g.keys(a))&&(f[b+"Delimiter"]="\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500")},this);c&&void 0===f[c]&&(f.hidden=this.f.i18n.t("AnnotFilterUserNotAvailable"));return f}},this);this.on("closed",g.bind(function(){this.hide()},this));this.t.bind("click",".addFilterRow",function(){var b=this._filterModel.addEmptyRow();this._addFilterRow(b)},this);this.t.bind("click",".removeFilterRow",function(b){b=
n(b).attr("data-bind");this._removeFilterRow(b)},this);this.t.bind("change",".filterType",function(b){var c=n(b).parent().attr("data-bind"),b=n(b).val(),a=this.t.d.getOptions(b);this._filterModel.updateFilterType(c,b,g.first(g.keys(a)));this._rerenderFilterRow(c)},this);this.t.bind("change",".filterCondition",function(b){var c=n(b).parent().attr("data-bind"),b=n(b).val();this._filterModel.updateFilterCondition(c,b)},this);this.t.bind("change",".filterOption",function(b){var c=n(b).parent().attr("data-bind"),
b=n(b).val();this._filterModel.updateFilterOption(c,b)},this);this.t.bind("change",".filterOperatorSelector",function(b){b=n(b).val();this._filterModel.setFilterOperator(b)},this);this.f.i18n.loadBundle("viewer",function(){this.setHeader(n("<span/>").addClass("popupTitle").html(this.f.i18n.t("CustomAnnotationFilter")));this._okButton.element.html(this.f.i18n.t("ApplyCustomFilter"));this._cancelButton.element.html(this.f.i18n.t("AppDialogCancel"))},this)};c.prototype=Object.create(l.prototype);c.prototype.constructor=
c;c.prototype.render=function(){this.f.i18n.loadBundle("viewer",function(){this.t.d.filterOperator=this._filterModel.getFilterOperator();this.t.render()},this)};c.prototype._rerenderFilterRow=function(c){var d=this._filterModel.getFilterRow(c);this.content.find(".filterRow[data-bind='"+c+"']").html(this.t.d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",d,"filter"))};c.prototype._addFilterRow=function(c){c=this._filterModel.getFilterRow(c);this.content.find(".filterRows").append(this.t.d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",
c,"filter"));this.recalculateSize(this._location,475)};c.prototype._removeFilterRow=function(c){this.content.find(".filterRow[data-bind='"+c+"']").remove();this._filterModel.removeFilterRow(c);this.recalculateSize(this._location,475)};c.prototype.show=function(c){this._savedFilterState=this._filterModel.getFilterState();this._wasCustomFilterActive=this._filterModel.isCustomFilterActive();this.render();this._location=c;this._filterModel.setCustomFilterActive(!0);l.prototype.show.call(this,c,475)};
return c});
define("web-viewer/annotation/AnnotationWidget","web-viewer/layout/AbstractWidget web-viewer/annotation/AnnotationRow web-viewer/annotation/AnnotationOriginSelector web-viewer/annotation/AnnotationCustomFilterPopup jquery web-viewer/annotation/AnnotationConstants utils/ShapeUtils web-viewer/layout/component/MiniButton component/button/Button component/toolbar/ButtonGroup web-viewer/layout/component/DropdownMiniButton web-viewer/layout/LayoutConstants web-viewer/layout/component/ViewerToolbarButton underscore".split(" "),function(d,
l,j,k,h,f,c,n,g,m,p,b,e,i){e=function(a,e,l,t){d.call(this,a,b.Widget.ANNOTATION);this.f=a;this.annotationModel=l;this.annotationModule=e;this.annotationRows={};this._isForMobile=t===b.LayoutType.MOBILE;this.detailsDiv=h("<div>").addClass("annotationDetails enableTextSelection");this.nonScrollablePart=h("<div>").addClass("nonScrollablePart");this._annotationOriginSelector=new j(a,l.getAnnotationFilterModel(),l,this.detailsDiv,this._isForMobile);this.nonScrollablePart.append(this._annotationOriginSelector.element);
this.detailsDiv.append(this.nonScrollablePart);this.warningMessage=h("<div/>").addClass("alert").text(this.annotationModel.getDisabledReason()).toggle(0<this.annotationModel.getDisabledReason().length);this.nonScrollablePart.append(this.warningMessage);this.temporarilyDisabledDiv=h("<div/>").addClass("annotationsTemporarilyDisabled").hide();this.nonScrollablePart.append(this.temporarilyDisabledDiv);this.showCurrentFileAnnotationsButton=new g(this.f.i18n,this.f.getContext(),this.f.isMobile(),"currentDocument",
h("<span/>").text("current").prepend(h("<i>").addClass("icon icon-WCR_Compare-Current")),!0,i.bind(function(){this.annotationModule.toggleCurrentPageAnnotations()},this));this.showCurrentFileAnnotationsButton.element.addClass("btn");this.showDifferenceFileAnnotationsButton=new g(this.f.i18n,this.f.getContext(),this.f.isMobile(),"differenceDocument",h("<span/>").text("reference").prepend(h("<i>").addClass("icon icon-WCR_Compare-Reference")),!0,i.bind(function(){this.annotationModule.toggleDifferencePageAnnotations()},
this));this.showDifferenceFileAnnotationsButton.element.addClass("btn");this.annotationToggleGroup=new m("annotationToggleBetweenCurrentAndDifference",[this.showCurrentFileAnnotationsButton,this.showDifferenceFileAnnotationsButton]);this.temporaryAnnotationToggler=h("<div/>").addClass("temporaryAnnotationToggle");a.i18n.loadBundle("viewer",function(){this.temporaryAnnotationToggler.append(h("<span/>").text(this.f.t("AnnShowAnnotationsFor")+": ")).append(h("<br/>")).append(this.annotationToggleGroup.element);
this.showCurrentFileAnnotationsButton.setContent(h("<span/>").text(this.f.t("CaptionCurrent")).prepend(h("<i>").addClass("icon icon-WCR_Compare-Current")));this.showDifferenceFileAnnotationsButton.setContent(h("<span/>").text(this.f.t("CaptionPrevious")).prepend(h("<i>").addClass("icon icon-WCR_Compare-Reference")))},this);this.temporarilyDisabledDiv.append(this.temporaryAnnotationToggler);this.temporaryAnnotationToggler.hide();this.header=h("<div>").addClass("annotationFilter");this._annotationFilters=
h("<div>").addClass("annotationFilterSelectors");this._customFilters=h("<div>").addClass("customFilterControls");this.header.append(this._annotationFilters);this._numberOfSelectedThreads=h("<span/>").addClass("threadsCount");this.header.append(this._customFilters);this._customFilters.append(this._numberOfSelectedThreads);this.bindKeys([[["esc"],i.bind(function(a){a.preventDefault();a.stopPropagation();this.annotationModel&&this.annotationModel.unselectAllAnnotations()},this),"keydown"]]);this.annotationModel.getAnnotationFilterModel().on("filterStateChanged",
i.bind(function(){this.annotationModel.getAnnotationFilterModel().getOriginType()!==f.AnnotationOriginTypes.user.id?(this._annotationFilters&&this._annotationFilters.hide(),this._pinFilterButton&&this._pinFilterButton.element.hide(),this._openFilterPopupButton&&this._openFilterPopupButton.element.hide(),this._duplicateFilteredAnnotationsButton&&(i.all(this.annotationModel.getFilteredAnnotations(),function(a){return a.getPermissionFor(f.ActionPermissions.DUPLICATE)})?this._duplicateFilteredAnnotationsButton.element.show():
this._duplicateFilteredAnnotationsButton.element.hide()),this._copyFilteredAnnotationsWithoutText&&this._copyFilteredAnnotationsWithoutText.element.show()):(this._annotationFilters&&this._annotationFilters.show(),this._pinFilterButton&&this._pinFilterButton.element.show(),this._openFilterPopupButton&&this._openFilterPopupButton.element.show(),this._duplicateFilteredAnnotationsButton&&this._duplicateFilteredAnnotationsButton.element.hide(),this._copyFilteredAnnotationsWithoutText&&this._copyFilteredAnnotationsWithoutText.element.hide())},
this));this._isForMobile||(this._customFilterPopup=new k(this.f,"customFilter",this.annotationModel),this.annotationModel.getAnnotationFilterModel().on("filterReset",i.bind(function(){this._customFilterPopup.isVisible()&&this._customFilterPopup.hide()},this)),this._pinFilterButton=new n(this.f,"pinFilter","icon-WCR_Pin12",!0,i.bind(function(){this.annotationModel.getAnnotationFilterModel().toggleAnnotationPinnedState();this._updateFilterPinnedIcon()},this)),this._updateFilterPinnedIcon(),this._pinFilterButton.element.addClass("pinAnnotationFilter"),
this._copyFilteredAnnotationsWithoutText=new n(this.f,"duplicateAllFilteredAnnotationWithoutText"," icon icon-WCR_Annotation-Duplicate-NoText12",!0,i.bind(function(){this.f.emit("module.annotation.duplicateAllFilteredAnnotationWithoutText")},this)),this._copyFilteredAnnotationsWithoutText.setTooltip("viewer","duplicateAllFilteredAnnotationWithoutText"),this._copyFilteredAnnotationsWithoutText.element.addClass("pinAnnotationFilter"),this._copyFilteredAnnotationsWithoutText.element.hide(),this._duplicateFilteredAnnotationsButton=
new n(this.f,"duplicateAllFiltered","icon icon-WCR_Annotation-Duplicate12",!0,i.bind(function(){this.f.emit("module.annotation.duplicateAllFilteredAnnotations")},this)),this._duplicateFilteredAnnotationsButton.setTooltip("viewer","duplicateAllFilteredAnnotations"),this._duplicateFilteredAnnotationsButton.element.addClass("pinAnnotationFilter"),this._duplicateFilteredAnnotationsButton.element.hide(),this._openFilterPopupButton=new n(this.f,"customFilter","icon-WCR_Filter12",!0,i.bind(function(){var a=
250>this.context.offset().left?this.context.width():this.context.offset().left-250,a=new c.Point(a,this.context.offset().top);this._customFilterPopup.show(a)},this)),this._openFilterPopupButton.element.addClass("customFilterBtn"),this._openFilterPopupButton.setTooltip("viewer","OpenCustomFilterPopup"),this._customFilters.append(this._copyFilteredAnnotationsWithoutText.element),this._customFilters.append(this._duplicateFilteredAnnotationsButton.element));this.annotationsListWrapper=h("<div>").addClass("annotationListWrapper");
this.annotationsListWrapper.on("makeMeVisible",i.partial(function(a,b){var e=h(b.target).offset().top,c=h(b.target).outerHeight(),d=h(this).offset().top,i=h(this).outerHeight();if(0>e-d||e+c>d+i)e=h(this).scrollTop()+e-d,h(this).scrollTop(e);a._visibleItem=h(b.target);b.preventDefault();b.stopPropagation()},this));this._isForMobile||(this._customFilters.append(this._openFilterPopupButton.element),this._customFilters.append(this._pinFilterButton.element));this.detailsDiv.append(this.annotationsListWrapper);
this.annotationList=h("<div>").addClass("annotationList");this._isForMobile?this.annotationsListWrapper.append(this.header):this.nonScrollablePart.append(this.header);this.annotationsListWrapper.append(this.annotationList);a.i18n.loadBundle("viewer",function(){this.setTitle(this.f.i18n.t("AnnWidgetTitle"))},this);this.setIcon("icon icon-WCR_Comment");this.inDOM={};this.toBeRemovedFromDOM={};this.saveButton=null;this.disableSaveButton=!1;this.annotationModel.on("disabledReasonChanged",i.bind(function(){this.warningMessage.text(this.annotationModel.getDisabledReason());
this.warningMessage.toggle(0<this.annotationModel.getDisabledReason().length);this.resized()},this));this.annotationModel.on("save.finished",i.bind(function(){this.disableSaveButton=!1;this.updateSaveButton();this.reloadButton.setEnabled(!0)},this));this.annotationModel.on("readWriteChanged",i.bind(function(){i.each(this.annotationRows,function(a){a.annotationUpdated()})},this));this.saveButton=new n(a,"saveAnnotations","icon-WCR_Save",!0,i.bind(function(){this.annotationModel.save()},this),"fontIconDisabled icon-WCR_Save");
this.updateSaveButton();this.stepThroughButton=new n(a,"stepThroughAnn","icon-WCR_Step",!0,i.bind(function(a){a.shiftKey?this.annotationModel.goToAnnotation(!1):this.annotationModel.goToAnnotation(!0)},this));this.stepThroughButton.setDisabledIcon("icon-WCR_Step fontIconDisabled");this.stepThroughButton.element.on("contextmenu",i.bind(function(a){a.preventDefault();this.stepThroughButton.isEnabled()&&this.annotationModel.goToAnnotation(!1)},this));this.stepThroughButton.setTooltip("viewer","StepThroughAnnTT");
this.reloadButton=new n(a,"reloadAnnotations","icon-WCR_Refresh",!0,i.bind(function(){this.annotationModel.reload()},this),"icon-WCR_Refresh fontIconDisabled");this.reloadButton.setTooltip("viewer","ReloadMiniBtnTT");this.annotationModel.on("save.started",i.bind(function(){this.reloadButton.setEnabled(!1);this.disableSaveButton=!0;this.updateSaveButton()},this));this.annotationModel.on("reload.started",i.bind(function(){this.reloadButton.setEnabled(!1)},this));this.annotationModel.on("reload.finished",
i.bind(function(){this.reloadButton.setEnabled(!0)},this));this.annotationModel.on("temporarilyDisableChanged",i.bind(this.updateListVisibility,this));this.annotationModel.on("disabledReasonChanged",i.bind(this.updateListVisibility,this));this.updateListVisibility();a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_DATESORT_MODE",i.bind(function(a,b){this.setSortByMode(b)},this));a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_NEXT_MODE",i.bind(function(a,b){this.setStepThroughMode(b)},
this));a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",i.bind(function(a,b){this.setShowSelectedAnnotationOnly(0<b)},this));a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",i.bind(function(a,b){this.setShowSelectedAnnotationPopupOnly(0<b)},this));a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",i.bind(function(a,b){this.setShowSequenceLabel(0<b)},this));a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWCOUNT",
i.bind(function(a,b){this.setShowCharLineCounter(0<b)},this));this.optionButton=new p(a,"annotationSettings","icon-WCR_Settings-submenu");a.i18n.loadBundle("viewer",function(){function a(b,e){e&&this.setStepThroughMode(b,!0)}function b(a,e){e&&this.setSortByMode(a,!0)}this.optionButton.addOption({name:"stepByThread",content:this.f.i18n.t("AnnSortThread"),onchange:i.bind(a,this,f.StepThroughMode.BY_THREAD),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==f.StepThroughMode.BY_THREAD,userCannotUncheck:!0});
this.optionButton.addOption({name:"stepWithReplies",content:this.f.i18n.t("AnnSortDate"),onchange:i.bind(a,this,f.StepThroughMode.WITH_REPLIES),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==f.StepThroughMode.WITH_REPLIES,userCannotUncheck:!0});this.optionButton.addOption({name:"stepWithZoom",content:this.f.i18n.t("AnnSortThreadFit"),onchange:i.bind(a,this,f.StepThroughMode.WITH_ZOOM),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==f.StepThroughMode.WITH_ZOOM,userCannotUncheck:!0});
this.optionButton.addOption({name:"stepWithLinked",content:this.f.i18n.t("AnnSortAreaFit"),onchange:i.bind(a,this,f.StepThroughMode.WITH_LINKED),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==f.StepThroughMode.WITH_LINKED,userCannotUncheck:!0});this.optionButton.addDivider();this.optionButton.addOption({name:"showselann",content:this.f.i18n.t("AnnListShowSel"),onchange:i.bind(function(a){this.setShowSelectedAnnotationOnly(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")});
this.optionButton.addOption({name:"showselannpopup",content:this.f.i18n.t("AnnListShowSelPopup"),onchange:i.bind(function(a){this.setShowSelectedAnnotationPopupOnly(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY")});this.optionButton.addOption({name:"shownumber",content:this.f.i18n.t("AnnSeqLabelShow"),onchange:i.bind(function(a){this.setShowSequenceLabel(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE")});this.optionButton.addOption({name:"showCharLineCount",
content:this.f.i18n.t("AnnCountShow"),onchange:i.bind(function(a){this.setShowCharLineCounter(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")});this.optionButton.addDivider();this.optionButton.addOption({name:"sortbycreationdate",content:this.f.i18n.t("DateSortCreation"),onchange:i.bind(b,this,f.AnnotationSortType.SORT_BY_CREATION_DATE),selected:this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===f.AnnotationSortType.SORT_BY_CREATION_DATE,userCannotUncheck:!0});
this.optionButton.addOption({name:"sortbymodificationdate",content:this.f.i18n.t("DateSortModification"),onchange:i.bind(b,this,f.AnnotationSortType.SORT_BY_MODIFICATION_DATE),selected:this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===f.AnnotationSortType.SORT_BY_MODIFICATION_DATE,userCannotUncheck:!0});this.setShowSelectedAnnotationOnly(0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY"),!1);this.updateWarningBadge()},this);this.on("movingStarted",i.bind(function(){this.context&&
this.context.find("[id^=richText_]").each(function(){var a=h(this).data("richTextObj");a&&a.isInitialized()&&(a.destroy(),a.isDestroyed=!0)})},this));this.on("movingStopped",i.bind(function(){this.context&&this.context.find("[id^=richText_]").each(function(){var a=h(this).data("richTextObj");a&&a.isDestroyed&&i.defer(function(){a.init()})})},this));this.on("visible",function(a){l.setAnnotationListVisible(a)});l.setAnnotationListVisible(this.isVisible());l.on("selectedAnnotation",i.bind(this.selectAnnotation,
this));l.on("unselectedAnnotation",i.bind(this.deselectAnnotation,this));l.on("annotationAdded",i.bind(function(a,b){b||this.addAnnotation(a,!0)},this));l.on("annotationUpdated",i.bind(this.updateAnnotation,this));l.on("annotationDeleted",i.bind(this.deleteAnnotation,this));var q=i.bind(function(){this._updateButtons();this.renderCompleteWidget()},this),v=i.bind(function(){this._updateButtons()},this);this._override("setContext",function(a,b){this._super(a,b);this.renderCompleteWidget();this.context.append(this.detailsDiv);
this.headerExtra.append(this.saveButton.element).append(this.stepThroughButton.element).append(this.reloadButton.element).append(this.optionButton.element);this._updateButtons();this.annotationModel.on("filterChanged",q);this.annotationModel.on("modelContentChanged",q);this.annotationModel.on("modelChanged",v);this.annotationModel.on("changed.page",i.bind(function(){var a=i.keys(this.inDOM);i.each(a,function(a){this._removeFromDOM(a)},this);this.annotationRows={}},this));this.startHeartBeat();this.resized()});
this._override("destroy",function(){this._super();l.off("filterChanged",q);l.off("modelContentChanged",q);l.off("modelChanged",v);this.stopHeartBeat()})};e.prototype=Object.create(d.prototype);e.prototype.constructor=e;e.widgetName=b.Widget.ANNOTATION;e.prototype.getMinimumSize=function(){return new c.Size(250,150)};e.prototype.willFill=function(){return!0};e.prototype._updateButtons=function(){this.updateSaveButton();this.updateStepThroughButton(!0)};e.prototype.updateSaveButton=function(){if(this.saveButton)if(this.disableSaveButton)this.saveButton.setEnabled(!1);
else{var a=this.annotationModel.getUnsavedAnnotationCount();0<a?(this.saveButton.setEnabled(!0),this.saveButton.setBadge(a),0<this.annotationModel.getUnsavedAnnotations().length?0<this.annotationModel.getDeletedAnnotations().length?this.saveButton.setTooltip("viewer","SaveMiniBtnTT",[this.annotationModel.getUnsavedAnnotations().length,this.annotationModel.getDeletedAnnotations().length]):this.saveButton.setTooltip("viewer","SaveMiniBtnAnnTT",[this.annotationModel.getUnsavedAnnotations().length]):
this.saveButton.setTooltip("viewer","SaveMiniBtnDelTT",[this.annotationModel.getDeletedAnnotations().length])):this.saveButton.setEnabled(!1)}};e.prototype.updateWarningBadge=function(){var a=this.optionButton.getOptionValue("showselann"),b=this.optionButton.getOptionValue("showselannpopup");a||b?(this.optionButton.setWarning(),this.f.i18n.loadBundle("viewer",function(){var e=this.f.i18n.t("AnnWidgetOptionsTT")+".",e=e+("<br />"+this.f.i18n.t("Warning"));a&&(e+="  "+this.f.i18n.t("OnlySelectedAnnotationWarningTT"));
b&&this.optionButton.isActionEnabled("showselannpopup")&&(a&&(e+="<br />"),e+="  "+this.f.i18n.t("OnlySelectedAnnotationPopupWarningTT"));this.optionButton.setTooltip(e)},this)):(this.optionButton.removeWarning(),this.optionButton.setTooltip("viewer","AnnWidgetOptionsTT"))};e.prototype.updateStepThroughButton=function(a){0===i.size(this.annotationModel.getFilteredAnnotations())||!a?this.stepThroughButton.setEnabled(!1):this.stepThroughButton.setEnabled(!0)};e.prototype.setSortByMode=function(a,b){b&&
this.f.setOption("PREFERENCES_ANNOTATION_DATESORT_MODE",a);this.optionButton.toggleOption("sortbycreationdate",a==f.AnnotationSortType.SORT_BY_CREATION_DATE);this.optionButton.toggleOption("sortbymodificationdate",a==f.AnnotationSortType.SORT_BY_MODIFICATION_DATE)};e.prototype.setShowSelectedAnnotationOnly=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",a?1:0);a&&(this.optionButton.toggleOption("showselannpopup",!1),this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",
0));this.updateWarningBadge()};e.prototype.setShowSelectedAnnotationPopupOnly=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",a?1:0);a&&(this.optionButton.toggleOption("showselann",!1),this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",0));this.updateWarningBadge()};e.prototype.setStepThroughMode=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_NEXT_MODE",a);this.optionButton.toggleOption("stepWithReplies",a==f.StepThroughMode.WITH_REPLIES);this.optionButton.toggleOption("stepByThread",
a==f.StepThroughMode.BY_THREAD);this.optionButton.toggleOption("stepWithZoom",a==f.StepThroughMode.WITH_ZOOM);this.optionButton.toggleOption("stepWithLinked",a==f.StepThroughMode.WITH_LINKED)};e.prototype.setShowSequenceLabel=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",a?1:0);this.optionButton.toggleOption("shownumber",a)};e.prototype.setShowCharLineCounter=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWCOUNT",a?1:0);this.optionButton.toggleOption("showCharLineCount",
a);i.each(this.annotationRows,function(b){b.showHideCharLineCount(a,!0)})};e.prototype.renderCompleteWidget=function(){this._isDirty||(this._isDirty=!0,this.f.i18n.loadBundle("viewer",function(){i.defer(i.bind(function(){this._isDirty=!1;this.renderHeader();this.renderAnnotationList()},this))},this))};e.prototype.renderHeader=function(){this._annotationFilters.empty();var a=this.annotationModel.getAnnotationOrigins();1<a.length||1===a.length&&a[0]!==f.AnnotationOriginTypes.user.id?this._annotationOriginSelector.element.show():
this._annotationOriginSelector.element.hide();this._usercombo=h("<select>");var a=h("<option/>").text(this.f.i18n.t("AnnAllUsers")).val("All"),b=h("<option selected disabled hidden value=''/>").text(this.f.i18n.t("AnnotFilterCustomEnabled"));this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._usercombo.append(b);this._usercombo.append(a);a=this.annotationModel.getUsers(f.AnnotationOriginTypes.user.id);i.each(a,function(a,b){var e=h("<option/>").text(a).val(b);this._usercombo.append(e)},
this);var e=this.annotationModel.getAnnotationFilterModel().getSelectedUser();e&&!this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&(0<this._usercombo.find("option").filter(function(a,b){return h(b).attr("value")===e}).length?this._usercombo.val(e):(a=h("<option hidden selected/>").text(this.f.i18n.t("AnnotFilterUserNotAvailable")),this._usercombo.append(a)));this._annotationFilters.append(this._usercombo);this._usercombo.on("change",i.bind(function(a){"All"!=a.target.value?
this.annotationModel.getAnnotationFilterModel().setSelectedUser(a.target.value):this.annotationModel.getAnnotationFilterModel().setSelectedUser(null)},this));this._statecombo=h("<select>");a=h("<option/>").text(this.f.i18n.t("AnnAllReviewState")).val("All");b=h("<option selected disabled hidden value=''/>").text(this.f.i18n.t("AnnotFilterCustomEnabled"));this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._statecombo.append(b);this._statecombo.append(a);this._statecombo.append(h("<option>").text("------------------------------").attr("disabled",
"disabled"));a=h("<option/>").text(this.f.i18n.t("AnnStatusAny")).val("Any");this._statecombo.append(a);a=h("<option/>").text(this.f.i18n.t("AnnNoReviewState")).val("NOT_Any");this._statecombo.append(a);this._statecombo.append(h("<option>").text("------------------------------").attr("disabled","disabled"));i.each(f.AnnotationReviewState,function(a,b){var e=h("<option/>").text(this.f.i18n.t(f.AnnotationReviewStateLocs[b])).val(f.AnnotationReviewState[b]);this._statecombo.append(e)},this);this._statecombo.append(h("<option>").text("------------------------------").attr("disabled",
"disabled"));i.each(f.AnnotationReviewState,function(a,b){var e=h("<option/>").text(this.f.i18n.t("AllExcept",this.f.i18n.t(f.AnnotationReviewStateLocs[b]))).val("NOT_"+f.AnnotationReviewState[b]);this._statecombo.append(e)},this);this._annotationFilters.append(this._statecombo);this._statecombo.on("change",i.bind(function(a){if("All"!=a.target.value){var b=-1<a.target.value.indexOf("NOT_"),a=a.target.value;b&&(a=a.substring(4));this.annotationModel.getAnnotationFilterModel().setSelectedState(a,b)}else this.annotationModel.getAnnotationFilterModel().setSelectedState(null,
!1);return!0},this));(a=this.annotationModel.getAnnotationFilterModel().getSelectedState())&&!this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._statecombo.val((this.annotationModel.getAnnotationFilterModel().isInverseState()?"NOT_":"")+a);this._customFilterPopup&&this._customFilterPopup.isVisible()&&this._customFilterPopup.render();this._updateNumberOfSelectedAnnotations()};e.prototype._updateNumberOfSelectedAnnotations=function(){this.f.i18n.loadBundle("viewer",function(){var a=
this.f.i18n.t("SelectedThreadsCount",this.annotationModel.getAnnotationFilterModel().getNumberOfFilteredAnnotations(),this.annotationModel.getAnnotationCount());this._numberOfSelectedThreads.text(a)},this)};e.prototype.renderAnnotationList=function(){var a=this.annotationModel.getFilteredAnnotations();this.toBeRemovedFromDOM=i.clone(this.inDOM);i.each(a,function(a){if(!(a.linkedto&&0<a.linkedto.length))if(this.annotationRows[a.name]){var b=this.annotationRows[a.name];b.element.next("hr").remove();
b.setAnnotation(a);this._addToDom(b);b.element.show()}else this.addAnnotation(a)},this);i.each(this.toBeRemovedFromDOM,function(a,b){this._removeFromDOM(b)},this);this.toBeRemovedFromDOM={};this._fireResized()};e.prototype._addToDom=function(a){this.inDOM[a.name]=1;delete this.toBeRemovedFromDOM[a.name];a.onDetachFromDOM();this.annotationList.append(a.element).append(h("<hr/>"));a.onReattachToDOM()};e.prototype._removeFromDOM=function(a){if(this.inDOM[a]){var b=this.annotationRows[a];b&&(b.element.next("hr").remove(),
b.onDetachFromDOM(),b.element.detach());delete this.toBeRemovedFromDOM[a];delete this.inDOM[a]}};e.prototype.addAnnotation=function(a,b){if(!(a.linkedto&&0<a.linkedto.length)){var e=new l(this.f,a,this.annotationModel,void 0,void 0,this._isForMobile);this.annotationRows[a.name]=e;var c=e.element;this._addToDom(e);c.on("click",i.bind(function(a){this.annotationModel.selectAnnotation(e.getAnnotation(),!0);a.stopPropagation()},this));var d=!1,f=!1;c.on("mousedown",i.bind(function(){d=!0;setTimeout(i.bind(function(){d&&
(f=!0,this.f.emit("module.annotation.highlightAnnotation",e.getAnnotation()))},this),500)},this));c.on("mouseup",i.bind(function(){d&&f&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");f=d=!1},this));c.on("mouseout",i.bind(function(){d&&f&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");f=d=!1},this));c.on("mouseleave",i.bind(function(){d&&f&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");f=d=!1},this));this.annotationModel.isAnnotationOrReplySelected(a)&&
this.selectAnnotation(a);this._updateNumberOfSelectedAnnotations();b&&this._fireResized()}};e.prototype.selectAnnotation=function(a){this.annotationRows[a.inreplyto]&&this.annotationRows[a.inreplyto].toggleReplyLimit(!1);if(this.annotationRows[a.name]||this.annotationRows[a.inreplyto])a=this.annotationRows[a.name]||this.annotationRows[a.inreplyto].annotationRows[a.name],a.setSelected(!0),a.element.trigger("makeMeVisible")};e.prototype.deselectAnnotation=function(a){var b;this.annotationRows[a.name]&&
(b=this.annotationRows[a.name]);this.annotationRows[a.inreplyto]&&(this.annotationRows[a.inreplyto].toggleReplyLimit(),void 0===b&&(b=this.annotationRows[a.inreplyto].annotationRows[a.name]));b&&b.setSelected(!1)};e.prototype.updateAnnotation=function(a,b){if(this.annotationRows[a.name])this.annotationRows[a.name].annotationUpdated(b);else if(a.linkedto&&!a.parent&&this.annotationRows[a.linkedto])this.annotationRows[a.linkedto].annotationUpdated();else{var e=a.getGodfather();e!==a&&this.updateAnnotation(e,
a)}};e.prototype.deleteAnnotation=function(a){this.annotationRows[a.name]?(this._removeFromDOM(a.name),delete this.annotationRows[a.name]):a.linkedto&&!a.parent&&this.annotationRows[a.linkedto]?(this._removeFromDOM(a.linkedto),delete this.annotationRows[a.linkedto]):(a=a.getGodfather(),this.updateAnnotation(a));this._updateNumberOfSelectedAnnotations();this._fireResized()};e.prototype.resized=function(){this.annotationsListWrapper.css("height","");this.isContextAvailable()&&"flex"!==this.detailsDiv.css("display")&&
i.defer(i.bind(function(){this.context.css("overflow","hidden");this.annotationsListWrapper.css("height","auto");var a=this.context.outerHeight(!0);this._isForMobile||(a-=this.header.outerHeight(!0));this.warningMessage.is(":visible")&&(a-=this.warningMessage.outerHeight(!0));this.temporarilyDisabledDiv.is(":visible")&&(a-=this.temporarilyDisabledDiv.outerHeight(!0));this._annotationOriginSelector.element.is(":visible")&&(a-=this._annotationOriginSelector.element.outerHeight(!0));0<a&&this.annotationsListWrapper.css("height",
a);this._visibleItem&&this._visibleItem.trigger("makeMeVisible");this.context.css("overflow","auto")},this))};e.prototype.getPreferredSize=function(){return new c.Size(this.annotationsListWrapper.outerWidth(!0),this.annotationsListWrapper.outerHeight(!0)+this.nonScrollablePart.outerHeight(!0))};e.prototype.startHeartBeat=function(){this.canRunTimer=!0;this.updateTimers()};e.prototype.stopHeartBeat=function(){this.canRunTimer=!1};e.prototype._updateFilterPinnedIcon=function(){this.annotationModel.getAnnotationFilterModel().isAnnotationFilterPinned()?
(this._pinFilterButton.setIcon("pinned icon-WCR_Pin12"),this._pinFilterButton.setTooltip("viewer","AnnotFilterPinOn")):(this._pinFilterButton.setIcon("unpinned icon-WCR_Pin12"),this._pinFilterButton.setTooltip("viewer","AnnotFilterPinOff"))};e.prototype.updateTimers=function(){this.canRunTimer&&(i.each(this.annotationRows,function(a){a.updateTimers()}),setTimeout(i.bind(function(){this.updateTimers()},this),3E4))};e.prototype.updateListVisibility=function(){this.annotationModel.isTemporarilyDisabled()?
(this.temporarilyDisabledDiv.toggle(this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()),this.temporaryAnnotationToggler.toggle(this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()),this.showCurrentFileAnnotationsButton.setActive(this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()),this.showDifferenceFileAnnotationsButton.setActive(this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()),this.annotationModel.isTemporarilyDisabledAndNoAnnotationsVisible()?
(this.header.hide(),this.annotationsListWrapper.hide(),this.updateStepThroughButton(!1),this.reloadButton.setEnabled(!1)):(this.header.show(),this.annotationsListWrapper.show(),this.updateStepThroughButton(!0),this.reloadButton.setEnabled(!0))):(this.header.show(),this.annotationsListWrapper.show(),this.temporarilyDisabledDiv.hide(),this.updateStepThroughButton(!0),this.reloadButton.setEnabled(!0));this.resized()};return e});
define("web-viewer/annotation/GVAnnotationConstants",{GVTypes:{barcode:{contentProperties:{"Decoded Value:":{langKey:"BarcodeValue"},"Decoded ValueLeft/Bottom:":{langKey:"BarcodeValueLeftBottom"},"Decoded Value Left/Bottom:":{langKey:"BarcodeValueLeftBottom"},"Decoded ValueRight/Top:":{langKey:"BarcodeValueRightTop"},"Decoded Value Right/Top:":{langKey:"BarcodeValueRightTop"},"Type:":{langKey:"BarcodeType"},"Grade:":{langKey:"BarcodeGrade"},"Magnification:":{langKey:"BarcodeMagnification"},"BWR:":{langKey:"BarcodeBWR"}}},
braille:{contentProperties:{"Language:":{langKey:"BrailleSelLang"},"Translation:":{langKey:"BrailleTranslation",stop:"EOF"}}},text:{contentProperties:{"Type:":{langKey:"TextCompareType"},"Master:":{langKey:"TextCompareMaster"},"Sample:":{langKey:"TextCompareSample"}},valueProperties:{Bold:"TextCompareTypeBold",Case:"TextCompareTypeCase",Change:"TextCompareTypeChange",Color:"TextCompareTypeColor",Deletion:"TextCompareTypeDeletion",Size:"TextCompareTypeSize",Space:"TextCompareTypeSpace","Sub/Super":"TextCompareTypeSubSuper",
"Font Type":"TextCompareTypeFontType",Hyphen:"TextCompareTypeHyphen",Insertion:"TextCompareTypeInsertion",Italic:"TextCompareTypeItalic",Location:"TextCompareTypeLocation",Underline:"TextCompareTypeUnderline"}}}});define("tpl!web-viewer/annotation/AnnotationGV",function(){return function(d){var l,j="",j=j+"<p>";_.each(d.lines,function(d){j+="\r\n\t"+(null==(l=d.key)?"":_.escape(l))+" "+(null==(l=d.value)?"":_.escape(l))+"<br/>\r\n"});return j+="</p>"}});
define("web-viewer/annotation/AnnotationGV","web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/annotation/GVAnnotationConstants utils/XMLUtils tpl!./AnnotationGV jquery".split(" "),function(d,l,j,k,h,f){var c=function(c,f){d.call(this,c,f);this.imageTooltip=this.imageWrapper=null};c.prototype=Object.create(d.prototype);c.prototype.constructor=c;c.prototype._parseContentsFromXML=function(c){var d=c.getElementsByTagName("contents-richtext");0===d.length&&(d=c.getElementsByTagName("contents"));
var f=[];if(0<d.length){var l=d[0].getElementsByTagName("body")[0];l||(l=d[0]);var b=l.textContent;j.GVTypes[this.originType]&&j.GVTypes[this.originType].contentProperties?(_.each(j.GVTypes[this.originType].contentProperties,function(e,a){var c=b.indexOf(a);if(-1!==c){var c=b.substr(c+a.length),d;e.stop||(d=c.indexOf("\n"),-1===d&&(d=void 0));d=c.substr(0,d).trim();j.GVTypes[this.originType].valueProperties&&j.GVTypes[this.originType].valueProperties[d]&&(d=this.f.i18n.t(j.GVTypes[this.originType].valueProperties[d]));
f.push({key:this.f.i18n.t(e.langKey),value:d})}},this),this.content=h({lines:f})):this.content="<p>"+l.textContent+"</p>"}d=k.attributeValue(c,"tMaster");c=k.attributeValue(c,"tSample");if(null!==d&&null!==c){this.imageWrapper="<div class='imageWrapper'>"+("<img class='masterImage' src='data:image/png;base64,"+d+"' alt='Master'/>")+("<img class='sampleImage' src='data:image/png;base64,"+c+"' alt='Sample'/>")+"</div>";var e=this.content="";_.each(f,function(b,a){0<a&&(e+="<br />");e+=b.key+" "+b.value});
this.imageTooltip=e}else this.imageTooltip=this.imageWrapper=null;this.lastname=this.f.i18n.t(this.originType+"Title")};c.prototype.initWithXML=function(c,f,h){d.prototype.initWithXML.call(this,c,f,h);this.messagenumber=h};c.prototype._modifyAnnotatationCoords=function(c,d,f,h,b){var e=-(b.trimboxOffset.width-b.mediaboxOffest.width),b=b.trimboxOffset.height-b.mediaboxOffest.height;return[c+e,d+b,f+e,h+b]};c.prototype.getPermission=function(){return l.AccessRight.READ_ONLY};c.prototype.getPermissionFor=
function(c){switch(c){case l.ActionPermissions.DUPLICATE:return this.originType!==l.AnnotationOriginTypes.artwork.id;case l.ActionPermissions.DUPLICATE_WITHOUT_TEXT:return!0;case l.ActionPermissions.CAN_BE_REPLIED_TO:return!1}};c.prototype.getExtraContent=function(){return this.imageWrapper?{element:f(this.imageWrapper),tooltip:this.imageTooltip}:null};c.prototype.getTextContent=function(){return this.imageTooltip?this.imageTooltip:d.prototype.getTextContent.call(this)};c.prototype.getIconClass=function(){return this.originType===
l.AnnotationOriginTypes.braille.id||this.originType===l.AnnotationOriginTypes.barcode.id||this.originType===l.AnnotationOriginTypes.text.id||this.originType===l.AnnotationOriginTypes.artwork.id||this.originType===l.AnnotationOriginTypes.spelling.id?l.AnnotationOriginTypes[this.originType].subIcon:d.prototype.getIconClass.call(this)};return c});
define("web-viewer/annotation/AnnotationDataExtensions","web-viewer/annotation/Annotation web-viewer/annotation/AnnotationGV web-viewer/data/AbstractDocumentPage utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/annotation/AnnotationConstants underscore".split(" "),function(d,l,j,k,h,f,c,n){return function(g){function m(b){var e="";if(b.inreplyto)return(b=b.getGodfather())&&0<=b.messagenumber&&(e=" ("+b.messagenumber+")"),g.i18n.t("AnnCommReply")+e;0<=b.messagenumber&&!b.isNew&&
(e=" ("+b.messagenumber+")");return g.i18n.t(c.AnnotationComments[b.annottype])+e}var p=g.getDataAdapter();p.WebCenter?(j.prototype._initAnnotationModule=function(){this._annotData||(this._annotData={dataStatus:"notAvailable",onAnnotationsAvailableCallbacks:[],annotations:[]})},j.prototype.requestAnnotations=function(b){this._initAnnotationModule();"available"===this._annotData.dataStatus?b(!0):"loading"===this._annotData.dataStatus?this._annotData.onAnnotationsAvailableCallbacks.push(b):this.hasAnnotations()?
(this._annotData.onAnnotationsAvailableCallbacks.push(b),this._fetchAnnotationsFromServer()):b(!0)},j.prototype.reloadAnnotations=function(b){this._initAnnotationModule();"loading"===this._annotData.dataStatus?this._annotData.onAnnotationsAvailableCallbacks.push(b):(this._annotData.onAnnotationsAvailableCallbacks.push(b),this._fetchAnnotationsFromServer())},j.prototype.resetAnnotations=function(){this._annotData.dataStatus="notAvailable";this._annotData.annotations=[]},j.prototype._fireOnAnnotationsAvailableCallbacks=
function(b){n.each(this._annotData.onAnnotationsAvailableCallbacks,function(e){e&&e(b)});this._annotData.onAnnotationsAvailableCallbacks=[];this._annotData.dataStatus=b?"available":"notAvailable"},j.prototype._fetchAnnotationsFromServer=function(){var b={};this.hasGraphics()||this.hasSvg()?b.file=this.get("file"):this.hasCad()&&(b.cad=this.get("cad"),b.style=this.get("style"));this._annotData.dataStatus="loading";var e=[];this.hasAnnotations(c.AnnotationOriginTypes.user.id)&&e.push(this._getUserAnnotations(b));
this._hasGVAnnotations()&&e.push(this._getGVAnnotations(b));var d=$.Deferred(),a=!0;$.when.apply($,e).done(n.bind(function(){var a=[];n.each(arguments,function(b){a=a.concat(b)});this._annotData.annotations=a;d.resolve(a)},this)).fail(n.bind(function(b){g.i18n.loadBundle("viewer",function(){g.emit("error.SEVERE",g.i18n.t("AnnOpenError",""),b)});a=!1;d.reject()},this)).always(n.bind(function(){this._fireOnAnnotationsAvailableCallbacks(a)},this));return d.promise()},j.prototype._getAnnotationsFromURL=
function(b,e,c){var a=$.Deferred(),d;g.ajax(b,n.extend({success:n.bind(function(b){if(b){var e=b.getElementsByTagName("status");if(e[0]&&(e=e[0].getElementsByTagName("value"),e[0]&&"-1"===h.textContent(e[0]))){a.reject();return}}d=this._parseAnnotationData(b,this._annotData.annotations,c);a.resolve(d)},this),error:n.bind(function(b){try{var e=(new DOMParser).parseFromString(b.responseText,"text/xml");d=this._parseAnnotationData(e,this._annotData.annotations,c);a.resolve(d);return}catch(f){}a.reject(b.responseText)},
this)},e));return a.promise()},j.prototype._getUserAnnotations=function(b){b=p.ViewServer("getannotations.jsp",b);return this._getAnnotationsFromURL(b,{},c.AnnotationOriginTypes.user.id)},j.prototype._hasGVAnnotations=function(){return this.hasAnnotations(c.AnnotationOriginTypes.artwork.id)||this.hasAnnotations(c.AnnotationOriginTypes.braille.id)||this.hasAnnotations(c.AnnotationOriginTypes.barcode.id)||this.hasAnnotations(c.AnnotationOriginTypes.text.id)||this.hasAnnotations(c.AnnotationOriginTypes.spelling.id)||
this.hasAnnotations(c.AnnotationOriginTypes.ext.id)||this.hasAnnotations(c.AnnotationOriginTypes.editor.id)||this.hasAnnotations(c.AnnotationOriginTypes.acrobat.id)},j.prototype._getGVAnnotations=function(b){this.getDocumentVersion().isMultiPage()&&(b.fmp=1,b.page=this.getPagenum()-1);b.afs=1;var b=p.ViewServer("getannotations.jsp",b),e=$.Deferred();this._getAnnotationsFromURL(b).done(function(b){e.resolve(b)}).fail(function(){e.resolve([])});return e},j.prototype._parseAnnotationData=function(b,
e,f){this._initAnnotationModule();var a={};if(!b)return[];var h=[];try{var j=b.getElementsByTagName("annots"),k,l;j&&1<=j.length&&(k=b.getElementsByTagName("annots")[0]);k&&(l=k.firstChild);var m={};if(null!=e)for(b=0;b<e.length;b++)e[b].runThroughAnnotation(!0,!0,!0,function(a){m[a.name]=a});for(var e={},n;l;){if(1===l.nodeType){var p=l.getAttribute("name"),b=null;m[p]?(b=m[p],b.replies=[],b.links=[],b.states=[],b.resetUnsavedReply(),b.cancelModified(),b._scaling=null,delete m[p]):(n=this._getAnnotationSourceFromXML(l,
f),b=n===c.AnnotationOriginTypes.user.id?new d(g):this._createAnnotation(n));n=b.originType;a[n]=a[n]?++a[n]:1;b.initWithXML(l,{trimboxOffset:this.getAnnotationsOffset(),mediaboxOffest:this.getAnnotationsOffset(!0)},a[n]);e[b.name]=b}l=l.nextSibling}var m=null,y;for(y in e)if(e.hasOwnProperty(y)){var u=e[y];if(u.inreplyto){var z=e[u.inreplyto];z&&(u.parent=z,u.state?z.states.push(u):z.replies.push(u))}else u.linkedto?e[u.linkedto]&&(e[u.linkedto].links.push(u),h.push(e[y]),u.parent=e[u.linkedto],
u.messagenumber=u.parent.messagenumber,u.updateIndicator()):h.push(e[y])}}catch(A){g.i18n.loadBundle("viewer",function(){g.emit("error.SEVERE",g.i18n.t("AnnDisplayError"),A)})}return h},j.prototype._getAnnotationSourceFromXML=function(b,e){if(e)return e;var d=h.attributeValue(b,d);if(d){if(f.startsWith(d,"GVBarcode")||f.startsWith(d,"Barcode"))return c.AnnotationOriginTypes.barcode.id;if(f.startsWith(d,"GVBraille")||f.startsWith(d,"BrailleProof"))return c.AnnotationOriginTypes.braille.id;if(f.startsWith(d,
"GVSpell"))return c.AnnotationOriginTypes.spelling.id;if(f.startsWith(d,"GVArtwork"))return c.AnnotationOriginTypes.artwork.id;if(f.startsWith(d,"GVText"))return c.AnnotationOriginTypes.text.id;if(f.startsWith(d,"Global Vision")){var a=h.attributeValue(b,a);if(a){if(f.endsWith(a,"Spelling"))return c.AnnotationOriginTypes.spelling.id;if(f.endsWith(a,"Change"))return c.AnnotationOriginTypes.text.id;if(f.endsWith(a,"Difference"))return c.AnnotationOriginTypes.artwork.id}}}if(d=h.attributeValue(b,"source"))if(a=
d.lastIndexOf("-"),0<a)return d.substr(a+1,d.lastIndexOf(".")-a-1);return c.AnnotationOriginTypes.ext.id},j.prototype._createAnnotation=function(b){return new l(g,b)},j.prototype.getAnnotations=function(){this._initAnnotationModule();return this._annotData.annotations},j.prototype.getAnnotationsOffset=function(b){var e=this.f.getModule("viewport"),c=this.getRotation()%360,a=this.isFlipped(),e=e.getWorldBounds(),d=this.getPageSize();if(this.hasGraphics())return b=b?this.getMediaBoxRect():this.getTrimboxRect(),
c=!a&&0===c||a&&90===c?b.bottomleft():!a&&90===c||a&&180===c?b.topleft():!a&&180===c||a&&270===c?b.topright():b.bottomright(),new k.Size(c.x,-(e.size.height-c.y));if(this.hasCad()){b=new k.Point;this.getCad()&&this.getCad().getLocation()&&(b=this.getCad().getLocation().origin.copy());if(!a&&0===c)b.y+=d.height;else if(a||90!==c)!a&&180===c?b.x+=d.width:a||(b.x+=d.height,b.y+=d.width);a&&90===c?b.y+=d.width:a&&180===c||(a&&270===c?b.x+=d.height:a&&(b.x+=d.width,b.y+=d.height));return new k.Size(b.x,
-(e.size.height-b.y))}return this.hasSvg()&&this.isReaderSpread()&&this.get("isRightPage")?(c=this.f.getDocumentController().getDifferencePage())?new k.Size(c.getSVGSize().width,0):new k.Size(this.getSVGSize().width,0):new k.Size},j.prototype.saveAnnotations=function(b,e,c){var a=document.implementation.createDocument("http://ns.adobe.com/xfdf/","xfdf",null);try{a.characterSet="UTF-8"}catch(d){}try{a.charset="UTF-8"}catch(f){}var h=document.createElementNS(null,"annots");a.documentElement.appendChild(h);
for(var j=[],l=[],k=0;k<b.length;k++)b[k].isNew?j.push(b[k]):l.push(b[k]),h.appendChild(b[k].toXML(a));var m=[];e&&0<e.length&&n.each(e,function(a){a.runThroughAnnotation(!0,!0,!0,function(a){m.push(a.name)})});b={};this.get("file")?b.file=this.get("file"):this.get("cad")&&(b.cad=this.get("cad"),b.style=this.get("style"));m&&0<m.length&&(b.remove=m);h=p.ViewServer("changeannotations.jsp",b);a=[this._getAnnotationsFromURL(h,{processData:!1,contentType:"text/xml; charset=UTF-8",data:a,type:"POST"})];
this._hasGVAnnotations()&&a.push(this._getGVAnnotations(b));$.when.apply($,a).done(n.bind(function(){var a=[];n.each(arguments,function(b){a=a.concat(b)});this._annotData.annotations=a;this._fireOnAnnotationsAvailableCallbacks(!0);this._processAfterParsingSavedAnnotations(j,l,e,c)},this)).fail(n.bind(function(a){g.i18n.loadBundle("viewer",function(){g.emit("error.SEVERE",g.i18n.t("AnnSaveError",""),a)})},this))},j.prototype._processAfterParsingSavedAnnotations=function(b,e,c,a){var d=this.getAnnotations(),
f=n.pluck(d,"originType"),h={};n.each(f,function(a){h[a]=!0});this.setHasAnnotations(0<n.size(d),h);this.reportAnnotations(b,e,c,function(b){a&&a(d);b&&((b=g.getProperty("annotationcallbackurl"))&&g.ajax(b,{dataType:void 0,noAjaxParam:!0}),g.i18n.loadBundle("viewer",function(){g.emit("userMessage","success",g.i18n.t("AnnotationsSaved"),!0)}))})},j.prototype.reportAnnotations=function(b,e,c,a){var d=0;b&&(d+=b.length);e&&(d+=e.length);c&&(d+=c.length);0===d&&a(!0);var f=0,h=!0,j=function(b){b||(h=
!1);f++;f===d&&a&&a(h)};g.i18n.loadBundle("viewer",n.bind(function(){b&&n.each(b,function(a){a.cancelModified();this.alertOnAnnotationAdded(a,j)},this);e&&n.each(e,function(a){a.cancelModified();this.alertOnAnnotationModified(a,j)},this);c&&n.each(c,function(a){this.alertOnAnnotationDelete(a,j)},this)},this))},j.prototype.alertOnAnnotationAdded=function(b,e){var c=b.date.getTime()==b.creationdate.getTime(),a=m(b),c=g.i18n.t(c?"AnnCommAdded":"AnnCommAdded2",a,b.getStringContent(130),b.getUserName(),
g.i18n.d("AnnCommDate",b.creationdate),g.i18n.d("AnnCommDate",b.date));this.getDocumentVersion().isMultiPage()&&(c=g.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+c);this.updateApprovalState(c,e)},j.prototype.alertOnAnnotationDelete=function(b,e,c){if(!c&&b.replies&&0<b.replies.length){var a=n.after(b.replies.length,n.bind(function(){this.alertOnAnnotationDelete(b,e,!0)},this));n.each(b.replies,function(b){this.alertOnAnnotationDelete(b,a)},this)}else{var c=
b.date.getTime()==b.creationdate.getTime(),d=m(b),c=g.i18n.t(c?"AnnCommDeleted":"AnnCommDeleted2",d,b.getStringContent(130),g.getCurrentUser().getFullName(),b.getUserName(),g.i18n.d("AnnCommDate",new Date),g.i18n.d("AnnCommDate",b.creationdate),g.i18n.d("AnnCommDate",b.date));this.getDocumentVersion().isMultiPage()&&(c=g.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+c);this.updateApprovalState(c,e)}},j.prototype.alertOnAnnotationModified=function(b,
e){var c=m(b),c=g.i18n.t("AnnCommModded",c,b.getStringContent(130),g.getCurrentUser().getFullName(),b.getUserName(),g.i18n.d("AnnCommDate",b.creationdate),g.i18n.d("AnnCommDate",new Date));this.getDocumentVersion().isMultiPage()&&(c=g.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+c);this.updateApprovalState(c,e)},j.prototype.updateApprovalState=function(b,e){var c={approvalcomments:b,projectid:this.getDocument().get("projectid"),docid:this.getDocument().get("docid"),
docversionid:this.get("pageDocversionid"),pageno:this.getPagenum()};void 0!==this.get("pageindex")&&(c.pageindex=this.get("pageindex"));void 0!==this.get("pagename")&&(c.pagename=this.get("pagename"));var a=p.WebCenter("updateapprovalstate.jsp");g.ajax(a,{success:function(){e&&e(!0)},error:function(a,b,c){g.i18n.loadBundle("viewer",function(){g.emit("error.SEVERE",g.i18n.t("DocumentHistoryUpdateError"),a,b,c)});e&&e(!1)},data:c,type:"POST"})}):g.emit("error.SEVERE","Can't initialize Annotations on a non-webcenter data-adapter")}});
define("web-viewer/annotation/AnnotationNoteDrawTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(d,l,j,k,h,f,c){var n=function(g,m,n){l.call(this,g,c.TOOLS.ANNOTATION_NOTE_DRAW);this.drawLinkedAnnotation=!1;this._annotationModel=m;this._annotationModule=n;this.setAnnotationColor=function(b){g.getCurrentUser().setColor("PREFERENCES_ANNOTATION_NOTE_COLOR",
b)};this.getAnnotationColor=function(){return g.getProperty("annotationcolor")?g.getProperty("annotationcolor"):g.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR")};this.getDefaultCursor=function(){return"cursor-drawComment"};var b=d.bind(function(b){if(b=this._widget.requestView(b))if(b=b.getLayer("Annotations"))return b;return null},this);this.registerState("default",{contextmenu:function(b){b.preventDefault();b.stopPropagation();return!1},click:d.bind(function(e){var c=b(e);if(c){var e=
this.keepPointWithinWorldBounds(this.getWorldPoint(e),!0),e=new j.Rect(e,new j.Size),a=new k(g);a.initAnnotation(h.AnnotationType.ANNOT_PIN,this.getAnnotationColor(),!1,m);e=c.getWorldRectFromScene(e);e.origin.x=f.parseFloat(e.origin.x.toFixed(2));e.origin.y=f.parseFloat(e.origin.y.toFixed(2));a.rect=e;this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(a.rect,d.bind(function(){this.addAnnotation(a)},this),function(){a=null}):this.addAnnotation(a)}},
this)});this.canBeInterrupted=function(){return!0};this.activeKeyEvents=[];this.persistentKeyEvents=[];this._override("initialize",function(b,c){this._super(b,c);this.changeState("default");this.registerActiveEvents(["contextmenu","click"]);this.activeKeyEvents.push(["shift",d.bind(function(){this.drawLinkedAnnotation=!0},this),"keydown"]);this.activeKeyEvents.push(["shift",d.bind(function(){this.drawLinkedAnnotation=!1},this),"keyup"])});this._override("activate",function(b){this._super(b);m.setLockSelection(!0)});
this.canBeActivated=function(){return m.canChangeAnnotations()};this._override("deactivate",function(b){this._super(b);this.drawLinkedAnnotation=!1;m.setLockSelection(!1)});g.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",d.bind(function(b,c){!c&&this.isActive()&&this.requestDeactivation()},this))};n.prototype=new l;n.prototype.constructor=n;n.prototype.addAnnotation=function(c){this.drawLinkedAnnotation?this._annotationModel.addLinkedAnnotation(c):(this._annotationModel.addAnnotation(c),
this.requestDeactivation())};return n});
define("web-viewer/annotation/AnnotationTouchDrawTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/TouchUtil web-viewer/annotation/Annotation web-viewer/utils/LineworkPoint web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(d,l,j,k,h,f,c,n,g,m,p){k=function(b,e,f){l.call(this,b,p.TOOLS.ANNOTATION_TOUCH_DRAW);var a=void 0;this.drawLinkedAnnotation=
!1;this._annotationModel=e;this._annotationModule=f;this.setAnnotationType=function(){};this.getAnnotationType=function(){return g.AnnotationType.ANNOT_FREEFORM};this.setAnnotationColor=function(a){b.getCurrentUser().setColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR",a)};this.getAnnotationColor=function(){return b.getProperty("annotationcolor")?b.getProperty("annotationcolor"):b.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};this.getDefaultCursor=function(){return"cursor-drawAnnotation"};
var k=d.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{panstart:function(){},panmove:function(){},panend:function(){},canBeInterrupted:!0});this.registerState("draw",d.defaults({panstart:d.bind(function(d){this.requestCanvasLayer(d.pointers[0]);var f=this.keepPointWithinWorldBounds(this.getWorldPoint(d.pointers[0]),!0);a=new c(b);a.initAnnotation(g.AnnotationType.ANNOT_FREEFORM,this.getAnnotationColor(),!1,
e);a.rect=new j.Rect(f,new j.Size);this.changeState("drawing");d.preventDefault()},this)},this.getState("default")));var m=d.bind(function(b){q();b||(a=null);a&&2===a.pointArray.length&&a.pointArray[0].x==a.pointArray[1].x&&a.pointArray[0].y==a.pointArray[1].y&&(a=null);if(null!==a&&(0===Math.abs(a.rect.size.width)||0>=Math.abs(a.rect.size.height)))a=null;if(a){var c=k(b);c?(a.rect=c.getWorldRectFromScene(a.rect),this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(a.rect,
d.bind(function(){this.createAnnotation(a,c)},this),function(){a=null}):this.createAnnotation(a,c)):a=null}this.changeState("draw")},this);this.createAnnotation=function(a,b){for(var c=0;c<a.pointArray.length;c++){var d=a.pointArray[c],f=new j.Point(d.x,d.y),f=b.getWorldPointFromScene(f);d.x=f.x;d.y=f.y}e.addAnnotation(a);this.requestDeactivation()};var t=d.throttle(d.bind(function(){var b=this.getCanvasCtx();if(b){var c=this.getCanvasSize();b.clearRect(0,0,c.width,c.height);a&&h.drawOverlay(this.f,
b,[a])}},this),40);this.registerState("drawing",d.defaults({enterState:function(){b.emit("viewport.startInteractive");b.emit("layout.disableTextSelection")},leaveState:function(){b.emit("viewport.stopInteractive");setTimeout(function(){b.emit("layout.enableTextSelection")},500)},panmove:d.bind(function(b){var c=a.rect.copy(),e=this.keepPointWithinWorldBounds(this.getWorldPoint(b.pointers[0]),!0),d=new n;if(0===a.pointArray.length)d.makeMoveTo(a.rect.origin.x,a.rect.origin.y);else{var f=a.pointArray[a.pointArray.length-
1];if(0>Math.abs(f.x-e.x)||0>Math.abs(f.y-e.y))return;d.makeLineTo(e.x,e.y)}a.pointArray.push(d);e=Math.abs(d.x-c.origin.x);d.x<c.origin.x?(e=Math.abs(c.origin.x-d.x),c.origin.x=d.x,c.size.width+=e):e>c.size.width&&(c.size.width=e);e=Math.abs(d.y-c.origin.y);d.y<c.origin.y?(e=Math.abs(c.origin.y-d.y),c.origin.y=d.y,c.size.height+=e):e>c.size.height&&(c.size.height=e);a.setRect(c,!0);b.preventDefault();t()},this),panend:function(a){m(a.pointers[0])},canBeInterrupted:!1},this.getState("default")));
this.canBeInterrupted=function(){return!1};this.activeKeyEvents=[];this.persistentKeyEvents=[];var q=d.bind(function(){this.releaseCanvasLayer()},this);this.canBeActivated=function(){return e.canChangeAnnotations()};b.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",d.bind(function(a,b){!b&&this.isActive()&&this.requestDeactivation()},this))};k.prototype=Object.create(l.prototype);k.prototype.constructor=k;k.prototype.initialize=function(b,c){l.prototype.initialize.apply(this,
arguments);this._touchUtil=new f(b.getElement()[0]);this.changeState("default")};k.prototype.doActivation=function(){l.prototype.doActivation.call(this);this._annotationModel.setLockSelection(!0);this._touchUtil.addPanStartListener(d.bind(function(b){this.getCurrentState().panstart(b)},this));this._touchUtil.addPanMoveListener(d.bind(function(b){this.getCurrentState().panmove(b)},this));this._touchUtil.addPanEndListener(d.bind(function(b){this.getCurrentState().panend(b)},this));this.changeState("draw");
this.drawLinkedAnnotation=!1};k.prototype.doDeactivation=function(){l.prototype.doDeactivation.call(this);this.changeState("default");this.releaseCanvasLayer();this._touchUtil.removeAllListeners();this._annotationModel.setLockSelection(!1)};return k});
define("web-viewer/annotation/AnnotationTouchTool","underscore web-viewer/viewport/tools/AbstractTool utils/ShapeUtils web-viewer/utils/TouchUtil web-viewer/annotation/Annotation web-viewer/core/CoreConstants".split(" "),function(d,l,j,k,h,f){var c=function(c,g){l.call(this,c,f.TOOLS.ANNOTATION_TOUCH);this.f=c;this._annotationModel=g;this._defaultState="defaultState";this._annotationSelectedState="annotationSelectedState";this._annotationSelectedPanningState="annotationSelectedPanningState";this.registerState(this._defaultState,
function(c){return{enterState:function(){c._annotationModel.unselectAllAnnotations();c._activeAnnotation=null},panstart:function(){},panmove:function(){},panend:function(){},singletap:function(d){d=c.getScenePointFromTouch(d);d.view&&((d=c.getClosestAnnotation(d.view,d.point))?c._annotationModel.selectAnnotation(d):c._annotationModel.unselectAllAnnotations())}}}(this));this.registerState(this._annotationSelectedState,function(c){return d.defaults({enterState:function(){},panstart:function(d){var b=
c.getScenePointFromTouch(d);if(b.view){var e=c.getClosestAnnotation(b.view,b.point);c._activeAnnotation===e&&c._annotationModel.canChangeAnnotation(e)&&(c.changeState(c._annotationSelectedPanningState),c._previousPoint=c._getAnnotationLayer(b.view).getWorldPointFromScene(c.getScenePoint(d.pointers[0])),c.requestActivation())}},panmove:function(){},panend:function(){}},c.getState(c._defaultState))}(this));this.registerState(this._annotationSelectedPanningState,function(c){return{enterState:function(){c.f.emit("viewport.startInteractive");
c.f.emit("layout.disableTextSelection")},leaveState:function(){c.isActive()&&c.requestDeactivation();c.f.emit("viewport.stopInteractive");setTimeout(function(){c.f.emit("layout.enableTextSelection")},500)},panstart:function(){},panmove:function(d){if(c.isActive()){var b=c._widget.requestView(d.pointers[0]);if(b){var d=c._getAnnotationLayer(b).getWorldPointFromScene(c.getScenePoint(d.pointers[0])),e=c._widget.getWorld().getWorldBounds(),b=c._getAnnotationLayer(b).convertWorldRectToLayer(new j.Rect(new j.Point,
e.size));b.origin.y=-(b.size.height+b.origin.y)-e.origin.y;b.origin.x+=e.origin.x;b=c.keepMoveSizeWithinRect(b,c._activeAnnotation.rect,c._previousPoint.sizeTo(d));g.moveAnnotation(c._activeAnnotation,b);c._previousPoint=d}}else c.changeState(c._annotationSelectedState)},panend:function(){c.changeState(c._annotationSelectedState)}}}(this));this._annotationModel.on("unselectedAnnotation",d.bind(function(){this.changeState(this._defaultState)},this));this._annotationModel.on("selectedAnnotation",d.bind(function(c){c!=
this._activeAnnotation&&(this._activeAnnotation=c,this.changeState(this._annotationSelectedState))},this))};c.prototype=Object.create(l.prototype);c.prototype.constructor=c;c.prototype.getScenePointFromTouch=function(c){return this._touchUtil.getScenePointFromTouch(c,this._widget)};c.prototype.getClosestAnnotation=function(c,d){var f=c.getClosestLineworkFromPoint(d,["Annotations"],30);if(f){if(f instanceof h)return f;if(f.anchor&&f.linework instanceof h)return f.linework}return null};c.prototype.initialize=
function(c,f){l.prototype.initialize.apply(this,arguments);this._touchUtil=new k(c.getElement()[0]);this.changeState(this._defaultState);this._touchUtil.addSingleTapListener(d.bind(function(c){this.getCurrentState().singletap(c)},this));this._touchUtil.addPanStartListener(d.bind(function(c){this.getCurrentState().panstart(c)},this));this._touchUtil.addPanMoveListener(d.bind(function(c){this.getCurrentState().panmove(c)},this));this._touchUtil.addPanEndListener(d.bind(function(c){this.getCurrentState().panend(c)},
this))};c.prototype._getAnnotationLayer=function(c){return c&&(c=c.getLayer("Annotations"))?c:null};return c});
define("web-viewer/annotation/AnnotationToolbarComponent","component/toolbar/ToolbarComponent component/toolbar/ButtonGroup web-viewer/layout/component/ViewerToolbarButton web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/annotation/AnnotationConstants".split(" "),function(d,l,j,k,h,f,c){var n=function(g,m,n,b){d.call(this,f.ToolbarComponent.ANNOTATION,g);this.f=g;this.annotationModel=m;var e=new l("AnnotateGroup");e.setTitle(g.i18n,
"viewer","AnnBtnGroupTitle");this.addButtonGroup(e);var i=new j(g,"HideAnnotationsButton",g.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?"icon-WCR_Annotation-Hide":"icon-WCR_Annotation-Show",!0,function(){m.toggleVisibility()});i.setTooltip("viewer",g.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?"HideAnnotationsBtnTT":"ShowAnnotationsBtnTT");g.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",function(a,b){b?(i.setTooltip("viewer","HideAnnotationsBtnTT"),i.setIcon("icon-WCR_Annotation-Hide")):
(i.setTooltip("viewer","ShowAnnotationsBtnTT"),i.setIcon("icon-WCR_Annotation-Show"));x()});e.addButton(i);var a=new j(g,"AnnotateButton","icon icon-WCR_Annotation-Global-cont icon-danger",!0,function(){m.toggleVisibility(!0)});a.setTooltip("viewer","AddAnnotationBtnTT");a.listenToTool(n,!0);e.addButton(a);g.getOption("PREFERENCES_ANNOTATION_TOOLMODE")!=c.ANNOT_PIN&&a.setIcon(c.AnnotationToolIcons[g.getOption("PREFERENCES_ANNOTATION_TOOLMODE")].icon,c.AnnotationToolIcons[g.getOption("PREFERENCES_ANNOTATION_TOOLMODE")].sub);
g.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_TOOLMODE",function(b,e){e!=c.ANNOT_PIN&&a.setIcon(c.AnnotationToolIcons[e].icon,c.AnnotationToolIcons[e].sub)});var s=new d("AnnotationSelectorSubtoolbar");a.addSubtoolbarComponent(s);var r=new l("AnnotateSubGroup");s.addButtonGroup(r);var t=void 0,q=new k(g,"RectangleButton",c.AnnotationToolIcons[c.AnnotationType.ANNOT_RECT].icon,!0,function(){n.setAnnotationType(c.AnnotationType.ANNOT_RECT);t&&t.setColor(n.getAnnotationColor())});q.listenToToolOption("annotationdrawtool",
"PREFERENCES_ANNOTATION_TOOLMODE",c.AnnotationType.ANNOT_RECT);q.setTooltip("viewer","AnnRectTT");q.setIcon(c.AnnotationToolIcons[c.AnnotationType.ANNOT_RECT].icon,c.AnnotationToolIcons[c.AnnotationType.ANNOT_RECT].sub);r.addButton(q);q=new k(g,"OvalButton","addOval",!0,function(){n.setAnnotationType(c.AnnotationType.ANNOT_ELLIPSE);t&&t.setColor(n.getAnnotationColor())});q.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",c.AnnotationType.ANNOT_ELLIPSE);q.setTooltip("viewer",
"AnnOvalTT");q.setIcon(c.AnnotationToolIcons[c.AnnotationType.ANNOT_ELLIPSE].icon,c.AnnotationToolIcons[c.AnnotationType.ANNOT_ELLIPSE].sub);r.addButton(q);q=new k(g,"LineButton","addLine",!0,function(){n.setAnnotationType(c.AnnotationType.ANNOT_LINE);t&&t.setColor(n.getAnnotationColor())});q.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",c.AnnotationType.ANNOT_LINE);q.setTooltip("viewer","AnnLineTT");q.setIcon(c.AnnotationToolIcons[c.AnnotationType.ANNOT_LINE].icon,c.AnnotationToolIcons[c.AnnotationType.ANNOT_LINE].sub);
r.addButton(q);q=new k(g,"ArrowButton","addArrow",!0,function(){n.setAnnotationType(c.AnnotationType.ANNOT_ARROW);t&&t.setColor(n.getAnnotationColor())});q.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",c.AnnotationType.ANNOT_ARROW);q.setTooltip("viewer","AnnArrowTT");q.setIcon(c.AnnotationToolIcons[c.AnnotationType.ANNOT_ARROW].icon,c.AnnotationToolIcons[c.AnnotationType.ANNOT_ARROW].sub);r.addButton(q);q=new k(g,"FreeformButton","addFreehand",!0,function(){n.setAnnotationType(c.AnnotationType.ANNOT_FREEFORM);
t&&t.setColor(n.getAnnotationColor())});q.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",c.AnnotationType.ANNOT_FREEFORM);q.setTooltip("viewer","AnnFreehandTT");q.setIcon(c.AnnotationToolIcons[c.AnnotationType.ANNOT_FREEFORM].icon,c.AnnotationToolIcons[c.AnnotationType.ANNOT_FREEFORM].sub);r.addButton(q);q=new k(g,"HighlightButton","addHighlight",!0,function(){n.setAnnotationType(c.AnnotationType.ANNOT_HIGHLIGHT);t&&t.setColor(n.getAnnotationColor())});q.listenToToolOption("annotationdrawtool",
"PREFERENCES_ANNOTATION_TOOLMODE",c.AnnotationType.ANNOT_HIGHLIGHT);q.setTooltip("viewer","AnnHighlightTT");q.setIcon(c.AnnotationToolIcons[c.AnnotationType.ANNOT_HIGHLIGHT].icon,c.AnnotationToolIcons[c.AnnotationType.ANNOT_HIGHLIGHT].sub);r.addButton(q);r=new l("AnnotateSubGroupGlobAction");s.addButtonGroup(r);q=new k(g,"GlobalAnnotation","addGlobalAnnotation",!0,function(a){n.setAnnotationType(c.AnnotationType.ANNOT_RECT);n.addGlobalAnnotation(a)});q.setTooltip("viewer","AnnNewRectGlobal");q.setIcon("icon-WCR_Annotation-Global-cont icon-danger",
["icon icon-WCR_Annotation-Global-sub icon-white"]);r.addButton(q);g.getProperty("annotationcolor")||(r=new l("AnnotateSubGroupColor"),s.addButtonGroup(r),t=new h(function(a){n.setAnnotationColor("#"+a)}),g.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_RECTANGLE_COLOR",function(){t.setColor(g.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR"))}),t.setColor(g.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")),s=new k(g,"ColorSelector",t.element,!0),
s.setTooltip("viewer","AnnColorDefaultRect"),q=new k(g,"ColorReset","icon icon-WCR_WF-Undo",!0,_.bind(function(){g.resetOption("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");this.askToChangeAnnotationColors()},this)),q.setIcon("icon icon-WCR_WF-Undo"),q.setTooltip("viewer","AnnResetDefaultColor"),r.addButton(s),r.addButton(q));var v=new j(g,"CommentButton","addComment",!0,function(){m.toggleVisibility(!0)});v.listenToTool(b,!0);v.setTooltip("viewer","AnnCommNote");v.setIcon("icon icon-WCR_Annotation-Note-sub");
e.addButton(v);if(!g.getProperty("annotationcolor")){s=new d("AnnotationNoteSelectorSubtoolbar");v.addSubtoolbarComponent(s);e=new l("AnnotateNoteSubGroup");s.addButtonGroup(e);var w=new h(function(a){b.setAnnotationColor("#"+a)});g.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_NOTE_COLOR",function(){w.setColor(b.getAnnotationColor())});w.setColor(b.getAnnotationColor());s=new k(g,"ColorSelector",w.element,!0);s.setTooltip("viewer","AnnColorDefaultNote");r=new k(g,"ColorReset","icon icon-WCR_WF-Undo",
!0,_.bind(function(){g.resetOption("PREFERENCES_ANNOTATION_NOTE_COLOR");this.askToChangeAnnotationColors()},this));r.setTooltip("viewer","AnnResetNoteColor");e.addButton(s);e.addButton(r)}var x=function(){if(m.canChangeAnnotations(!0))a.setEnabled(!0),v.setEnabled(!0);else{var c="";0<m.getDisabledReason().length&&(c=m.getDisabledReason());a.setDisabledTooltip(c);v.setDisabledTooltip(c);n.isActive()&&n.requestDeactivation();b.isActive()&&b.requestDeactivation();a.setEnabled(!1);v.setEnabled(!1)}i.setEnabled(!m.isTemporarilyDisabledAndNoAnnotationsVisible())};
x();m.on("readWriteChanged",x);m.on("temporarilyDisableChanged",x);m.on("disabledReasonChanged",x)};n.prototype=Object.create(d.prototype);n.prototype.constructor=n;n.toolbarName=f.ToolbarComponent.ANNOTATION;n.prototype.askToChangeAnnotationColors=function(){this.f.i18n.loadBundle("viewer",_.bind(function(){confirm(this.f.i18n.t("AnnUpdateColors"))&&this.annotationModel.updateAllAnnotationColors()},this))};return n});
define("web-viewer/annotation/AnnotationTouchToolbarComponent",["component/toolbar/ToolbarComponent","component/toolbar/ButtonGroup","web-viewer/layout/component/ViewerToolbarButton","web-viewer/layout/LayoutConstants"],function(d,l,j,k){var h=function(f,c,h){d.call(this,k.ToolbarComponent.ANNOTATION,f);this.f=f;this.annotationModel=c;var g=new l("AnnotateGroup");g.setTitle(f.i18n,"viewer","AnnBtnGroupTitle");this.addButtonGroup(g);var m=new j(f,"AnnotateButton","icon-WCR_Add",!0,function(){c.toggleVisibility(!0)});
m.listenToTool(h,!0);g.addButton(m);f=function(){if(c.canChangeAnnotations(!0))m.setEnabled(!0);else{var d="";0<c.getDisabledReason().length&&(d=c.getDisabledReason());m.setDisabledTooltip(d);h.isActive()&&h.requestDeactivation();m.setEnabled(!1)}};f();c.on("readWriteChanged",f);c.on("temporarilyDisableChanged",f);c.on("disabledReasonChanged",f)};h.prototype=Object.create(d.prototype);h.prototype.constructor=h;h.toolbarName=k.ToolbarComponent.ANNOTATION;return h});
define("web-viewer/annotation/AnnotationModule","underscore web-viewer/core/AbstractModule web-viewer/annotation/AnnotationModel web-viewer/annotation/AnnotationLayerModel web-viewer/annotation/AnnotationPopupsLayerModel web-viewer/annotation/AnnotationTool web-viewer/annotation/AnnotationDrawTool web-viewer/annotation/AnnotationIndicatorTool web-viewer/annotation/AnnotationWidget web-viewer/annotation/Annotation utils/Transformation utils/ShapeUtils web-viewer/annotation/AnnotationDataExtensions web-viewer/annotation/AnnotationNoteDrawTool web-viewer/annotation/AnnotationTouchDrawTool web-viewer/annotation/AnnotationTouchTool web-viewer/annotation/AnnotationToolbarComponent web-viewer/annotation/AnnotationTouchToolbarComponent web-viewer/annotation/AnnotationConstants web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/utils/ListenerUtil".split(" "),
function(d,l,j,k,h,f,c,n,g,m,p,b,e,i,a,s,r,t,q,v,w,x){p=function(h,k){l.call(this,h,k,"annotation");x.mixin(this,h);this.annotationModel=new j(this.f,"annotation");this.layerModels={};e(h);this._drawTool=new c(h,this.annotationModel,this);this._noteDrawTool=new i(h,this.annotationModel,this);this._indicatorTool=new n(h,this.annotationModel);this._publishTool(this._indicatorTool);this.f.isMobile()?(this._touchDrawTool=new a(h,this.annotationModel,this),this._publishTool(this._touchDrawTool),this._selectTool=
new s(h,this.annotationModel)):(this._publishTool(this._drawTool),this._publishTool(this._noteDrawTool),this._selectTool=new f(h,this.annotationModel));this._publishTool(this._selectTool);this._annotateComponent=null;this._publishToolbarComponent(r.toolbarName,d.bind(function(a){return this._annotateComponent=a===w.LayoutType.MOBILE?new t(h,this.annotationModel,this._touchDrawTool):new r(h,this.annotationModel,this._drawTool,this._noteDrawTool)},this));this._annotationWidget=null;this._publishWidget(g.widgetName,
d.bind(function(a){this.annotationModel.setLayoutType(a);return this._annotationWidget=new g(h,this,this.annotationModel,a)},this));this.on("highlightAnnotation",d.bind(function(a){this.annotationModel.selectAnnotation(a,!0);this._indicatorTool.setAnnotation(a);h.emit("toolManager.request.activation","annotationindicatortool")},this));this.on("duplicateAnnotation",d.bind(function(a){a.getPermissionFor(q.ActionPermissions.DUPLICATE)&&(this.annotationModel.getAnnotationFilterModel().setOriginType(q.AnnotationOriginTypes.user.id),
this._duplicateAnnotation(a,!1,!1,!0,!0))},this));this.on("duplicateWithoutText",d.bind(function(a){a.getPermissionFor(q.ActionPermissions.DUPLICATE_WITHOUT_TEXT)&&(this.annotationModel.getAnnotationFilterModel().setOriginType(q.AnnotationOriginTypes.user.id),this._duplicateAnnotation(a,!1,!1,!0,!0,!0))},this));this.on("duplicateAllFilteredAnnotations",d.bind(function(){var a=d.filter(this.annotationModel.getFilteredAnnotations(),function(a){return a.getPermissionFor(q.ActionPermissions.DUPLICATE)});
0<a.length&&(this.annotationModel.getAnnotationFilterModel().setOriginType(q.AnnotationOriginTypes.user.id),d.each(a,function(a){this._duplicateAnnotation(a,!1,!1,!0,!0,!1,!0)},this),this.annotationModel.modelChanged(),this.annotationModel.modelContentChanged())},this));this.on("duplicateAllFilteredAnnotationWithoutText",d.bind(function(){var a=d.filter(this.annotationModel.getFilteredAnnotations(),function(a){return a.getPermissionFor(q.ActionPermissions.DUPLICATE_WITHOUT_TEXT)});0<a.length&&(this.annotationModel.getAnnotationFilterModel().setOriginType(q.AnnotationOriginTypes.user.id),
d.each(a,function(a){this._duplicateAnnotation(a,!1,!1,!0,!0,!0,!0)},this),this.annotationModel.modelChanged(),this.annotationModel.modelContentChanged())},this));this.on("zoomToAnnotation",d.bind(function(a,b,c){var e={},d=a.rect.copy();3!==h.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")&&(d=a.getOutliningRect());var f=null;20>Math.abs(d.size.width)&&(f=(20-d.size.width)/2,d.origin.x-=f,d.size.width=20);20>Math.abs(d.size.height)&&(f=(20-d.size.height)/2,d.origin.y-=f,d.size.height=20);e.rect=m().transformedRect(d);
e.constrain=!0;e.animated=!b;this.annotationModel.ensureVisibility();this.annotationModel.getLayoutType()!==w.LayoutType.MOBILE&&!c&&this.annotationModel.selectAnnotation(a,!0);h.emit("viewport.fitInRect",e)},this));this.on("temporarilyDisable",d.bind(function(a,b,c,d){this.annotationModel.temporarilyDisable(a,b,c,d)},this));var m=d.bind(function(){return this.layerModels.AnnotationLayer.getTransform().copy()},this);this.convertWorldRectToAnnotationLayer=function(a){var c=m().createInverse();return new b.Rect(c.transformedPoint(a.origin),
c.transformedSize(a.size))};this.on("createAnnotation",d.bind(function(a,b,c){void 0===c&&(c=q.AnnotationType.ANNOT_RECT);this.annotationModel.addAnnotationWithRect(this.convertWorldRectToAnnotationLayer(a),b,c)},this));this._registerListener("intercept.activePageChange",function(a){var b=a.newActivePage,c=a.oldActivePage;b!==c&&this.promptToSaveUnsavedAnnotations(d.bind(function(){this.f.getDocumentController().changeActivePage(b)},this),d.bind(function(){},this),d.bind(function(){this.annotationModel.resetAllAnnotations();
this.f.getDocumentController().changeActivePage(b)},this))&&(a.newActivePage=c)},this);this._registerListener("viewControls.compensationChanged",function(){if(this.annotationModel){var a=this.annotationModel.getAnnotationsPage();a!==this.f.getDocumentController().getDifferencePage()&&(a=a.getCurrentScaling(),this.annotationModel.scaleAllAnnotations(a))}},this,this.f);this._registerListener("filterStateChanged",function(a){a?this.f.setOption("ANNOTATION_FILTER",this.annotationModel.getAnnotationFilterModel().getFilterState()):
this.f.resetOption("ANNOTATION_FILTER")},this,this.annotationModel.getAnnotationFilterModel());this._registerListener("annotationAdded",function(a){this.f.isMobile()||this._save3DView(a)},this,this.annotationModel);this.on("update3DView",d.bind(function(a){this._save3DView(a)},this));this.on("delete3DView",d.bind(function(a){this._save3DView(a,!0)},this));this.on("show3DView",d.bind(function(a){this._show3DView(a)},this));this._registerListener("selectedAnnotation",function(a){this.annotationModel.getLayoutType()!==
w.LayoutType.MOBILE&&this._show3DView(a.getGodfather(),!1)},this,this.annotationModel);this.f.whenModuleAvailable("view3D",d.bind(function(a){a.on("3DWidget.enabled",d.bind(function(){this.annotationModel.modelContentChanged()},this))},this));this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailable(this._whenActiveOrDifferencePageChangedAndParametersAvailable,this);this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(this._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange,
this)};p.prototype=Object.create(l.prototype);p.prototype.constructor=p;p.prototype._show3DView=function(a,b){var c=this.f.getModule("view3D"),d=a.get3DViewPosition();c&&d&&(this.annotationModel.getLayoutType()===w.LayoutType.MOBILE?c.show3D(d):c.setCameraPosition(d),(void 0===b||b)&&this.annotationModel.selectAnnotation(a,!0))};p.prototype._save3DView=function(a,b){if(a.getGodfather()===a)if(b)a.set3DViewPosition(null),this.annotationModel.selectAnnotation(a,!0),this.annotationModel.modelChanged(a);
else{var c=this.f.getModule("view3D");if(c&&(c=c.getCameraPosition()))a.set3DViewPosition(c),this.annotationModel.selectAnnotation(a,!0),this.annotationModel.modelChanged(a)}};p.prototype.hasUnsavedElements=function(){return 0<this.annotationModel.getUnsavedAnnotationCount()};p.prototype.saveAllUnsavedElements=function(a){this.annotationModel.save(null,a)};p.prototype._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=function(a,b){if(void 0===this.layerModels.AnnotationLayer){this.layerModels.AnnotationLayer=
new k(this.f,"Annotations",this.annotationModel);this.layerModels.AnnotationPopupsLayer=new h(this.f,"AnnotationPopups",this.annotationModel);var c=this.f.getModule("viewport");c.addLayer("Annotations",this.layerModels.AnnotationLayer);c.addLayer("AnnotationPopups",this.layerModels.AnnotationPopupsLayer,"Main")}this.annotationModel.isTemporarilyDisabled()?this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()?(this.annotationModel.setPage(a),this.annotationModel.modelChanged()):this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()&&
(this.annotationModel.setPage(b),this.annotationModel.modelChanged()):this.annotationModel.setPage(a)};p.prototype._whenActiveOrDifferencePageChangedAndParametersAvailable=function(a){this._annotateComponent&&(a.isBlankPage()?this._annotateComponent.hide():this._annotateComponent.show())};p.prototype.toggleDifferencePageAnnotations=function(a){void 0===a&&(a=!this.annotationModel.isTemporarilyDifferencePageAnnotationsShown());a?(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1,!0),this.annotationModel.showTemporarilyDifferencePageAnnotations()):
this.annotationModel.hideTemporarilyAnnotations()};p.prototype.toggleCurrentPageAnnotations=function(a){void 0===a&&(a=!this.annotationModel.isTemporarilyCurrentPageAnnotationsShown());a?(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1,!0),this.annotationModel.showTemporarilyActivePageAnnotations()):this.annotationModel.hideTemporarilyAnnotations()};p.prototype.getUnsavedElementsName=function(){return this.f.i18n.t("Annotations")};p.prototype.isTemporarilyCurrentPageAnnotationsShown=function(){return this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()};
p.prototype.isTemporarilyDifferencePageAnnotationsShown=function(){return this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()};p.prototype.getState=function(){return{annotationModel:{temporarilyDisabled:{temporarilyDisabled:this.annotationModel.isTemporarilyDisabled(),temporarilyCurrentPageAnnotationsShown:this.annotationModel.isTemporarilyCurrentPageAnnotationsShown(),temporarilyDifferencePageAnnotationsShown:this.annotationModel.isTemporarilyDifferencePageAnnotationsShown(),temporarilyDisabledMessage:this.annotationModel.getTemporarilyDisabledMessage(),
temporaryAnnotationDocumentTogglingEnabled:this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()},annotationVisibility:1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"),filter:this.annotationModel.getAnnotationFilterModel().getFilterState()}}};p.prototype.setState=function(a){this.f.whenModuleAvailable("annotation",function(){if(void 0!==a){var b=a.annotationModel;a.disableSelectTool&&(this._selectTool=null,this._unpublishTool("annotationtool"),this._indicatorTool=null,this._unpublishTool("annotationindicatortool"));
if(void 0!==b){var c=b.temporarilyDisabled;void 0!==c&&(this.annotationModel.temporarilyDisable(c.temporarilyDisabled,c.temporaryAnnotationDocumentTogglingEnabled,c.temporarilyDisabledMessage),c.temporarilyCurrentPageAnnotationsShown?this.annotationModel.showTemporarilyActivePageAnnotations():c.temporarilyDifferencePageAnnotationsShown&&this.annotationModel.showTemporarilyDifferencePageAnnotations());this.annotationModel.toggleVisibility(b.annotationVisibility);b.filter&&this.annotationModel.getAnnotationFilterModel().setFilterState(b.filter)}}},
this)};p.prototype.promptToSaveUnsavedAnnotations=function(a,b,c){return this.annotationModel.promptToSaveUnsavedAnnotations(a,b,c)};p.prototype.promptIfAnnotationOutsidePage=function(a,b,c,e,f){!0===f&&(a=this.convertWorldRectToAnnotationLayer(a));var f=this.f.getDocumentController().getActivePage(),g=!0;f.hasCad()||(g=f.isRectOnPage(a));if(g)b();else{var h=new v(this.f,"annotationOnOtherPage",this.f.getContext());h.setRemoveFromDomAfterUsage(!0);h.setOkAction(d.bind(function(){b(e);h.hide()},this));
h.setCancelAction(d.bind(function(){c()},this));h.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("AnnSaveTitle")));h.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnSaveOutsidePrompt")));h.setOkBtnText(this.f.i18n.t("YesResponse"));h.setCancelBtnText(this.f.i18n.t("NoResponse"));h.show()}};p.prototype.reload=function(){this.annotationModel.reload(!0)};p.prototype.disableAnnotations=function(a,b,c){a?this.annotationModel.setDisableReason(b,c,!0,!0):this.annotationModel.removeDisableReason(b)};
p.prototype._duplicateAnnotation=function(a,b,c,e,f,g,h){var i=a.getGodfather().duplicate(b,c,e,f,this.annotationModel);g&&(i.content="");a.inreplyto&&(i.content=d.clone(a.content));a=null;a=i.getType()==q.AnnotationType.ANNOT_PIN?this._noteDrawTool.getAnnotationColor():this._drawTool.getAnnotationColor();i.setColor(a);this.annotationModel.unselectAllAnnotations(!0,!0);this.annotationModel.addAnnotation(i,!1,h);0<i.links.length&&d.each(i.links,function(a){a.messagenumber=i.messagenumber;this.annotationModel.addAnnotation(a)},
this);i.setColor(a);h||this.annotationModel.modelChanged(i)};p.prototype.addLinkedAnnotations=function(a,b,c){for(var d=null,e=null,f=0;f<a.length;f++)d=new m(this.f),d.initAnnotation(c,this._getAnnotationColor(),0===f,this.annotationModel,this.convertWorldRectToAnnotationLayer(a[f])),0===f?(d.content=b,e=d,this.annotationModel.unselectAllAnnotations(!0,!0),this.annotationModel.addAnnotation(d)):this.annotationModel.addLinkedAnnotation(d,e)};p.prototype._getAnnotationColor=function(){return this.f.getProperty("annotationcolor")?
this.f.getProperty("annotationcolor"):this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};return p});